/*
 * @(#)ExportEinstellungenBastBand.java   03.11.09
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.bast.exportimport;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.plugin.gtm.bast.gui.IExportEinstellungen;
import de.inovat.buv.plugin.gtm.bast.KonstantenGTMBast;

//~ JDK IMPORTE ===============================================================

import java.util.ArrayList;
import java.util.List;

//~ KLASSEN ===================================================================

public class ExportEinstellungenBastBand implements IExportEinstellungen {

    /** Liste der File Namen. */
    private List<String> _listeFileName = new ArrayList<String>();

    //~ METHODEN ==============================================================

    /**
     * Ermittlung der Liste aller Ausgabedateien.
     * @return   _listeFileName  Liste aller Ausgabedateien.
     */
    @Override
    public List<String> ermittleAlleAusgabeDateien() {
        return _listeFileName;
    }

    /**
     * Ermittlung des Dateityps
     * @return Dateityp der Exportdatei.
     */
    @Override
    public String ermittleDateiTyp() {
        return ".xls";
    }

    /**
     * Ermittlung der default Exportdatei.
     * @return Exportdatei.
     */
    @Override
    public String ermittleDefaultExportDatei() {
        return null;
    }

    /**
     * Ermittlung der Dokumentenendung.
     * @return Dokumentenendung.
     */
    @Override
    public String[] ermittleFilterExtensions() {
        return new String[] { "*.xls" };
    }

    /**
     * Ermittlung der Parameter ID.
     * @return  SpeicherparameterID fr den Export BAST.
     */
    @Override
    public String ermittleParameterID() {
        return KonstantenGTMBast.EXPORT_BAST;
    }

    /**
     * Ermittlung des TextZeitbereiches.
     * @return  "".
     */
    @Override
    public String ermittleTextZeitbereich() {
        return "";
    }

    /**
     * Ermittlung der ZeitangabeBis.
     *
     * @return  0.
     */
    @Override
    public long ermittleZeitangabeBis() {
        return 0;
    }

    /**
     * Ermittlung der ZeitangabeVon.
     * @return 0.
     */
    @Override
    public long ermittleZeitangabeVon() {
        return 0;
    }

    /**
     * Gibt an ob Bearbeiten erlaubt ist.
     * @return true;
     */
    @Override
    public boolean istBearbeitenErlaubt() {
        return true;
    }

    /**
     * Gibt an ob die Dateiauswahl mglich ist.
     * @return false.
     */
    @Override
    public boolean istDateiAuswahl() {
        return false;
    }

    /**
     * Gibt an ob Drucken erlaubt ist.
     * @return  false.
     */
    @Override
    public boolean istDruckenErlaubt() {
        return false;
    }

    /**
     * Gibt an ob die Versendung der Projektsteckbriefe in einer E-Mail erlaubt ist.
     * @return true.
     */
    @Override
    public boolean istEmailErlaubt() {
        return true;
    }

    /**
     * Gibt an, ob die Erstellung meherer Projektsteckbriefe erlaubt ist.
     * @return true.
     */
    @Override
    public boolean istErstellungMehrereDateienMoeglich() {
        return true;
    }

    @Override
    public boolean istZeitbereichsAngabeMoeglich() {
        return false;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 21.10.13
