/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.bast.gui;

//~ KLASSEN ===================================================================

/**
 * Parameter fr den Export, der im Speicher gespeichert wird.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 88 $ / $Date: 2012-03-09 16:20:38 +0100 (Fr, 09 Mrz 2012) $ / ($Author: LG $)
 */
public class Parameter {

    /**
     * Datei, wohin exportiert wird.
     */
    private String _datei;

    /**
     * Fortschrittsanzeige fr den Exportprozess.
     */
    private int _fortschrittsanzeige;

    /**
     * Meldungen.
     */
    private String _meldungen;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Erzeugt eine Instanz der Klasse Parameter
     * (wird von XMLDecoder bentigt).
     */
    public Parameter() {}

    /**
     * Erzeugt eine Instanz der Klasse Parameter.
     *
     * @param datei Datei.
     * @param fortschrittsanzeige Fortschrittsanzeige.
     * @param meldungen Meldungen
     */
    public Parameter(String datei, int fortschrittsanzeige, String meldungen) {
        _datei               = datei;
        _fortschrittsanzeige = fortschrittsanzeige;
        _meldungen           = meldungen;
    }

    //~ GET METHODEN ==========================================================

    /**
     * Getter fr Eigenschaft 'datei'.
     *
     * @return Wert der Eigenschaft 'datei'.
     *
     * @see #_datei
     */
    public String getDatei() {
        return _datei;
    }

    /**
     * Getter fr Eigenschaft 'fortschrittsanzeige'.
     *
     * @return Wert der Eigenschaft 'fortschrittsanzeige'.
     *
     * @see #_fortschrittsanzeige
     */
    public int getFortschrittsanzeige() {
        return _fortschrittsanzeige;
    }

    /**
     * Getter fr Eigenschaft 'meldungen'.
     *
     * @return Wert der Eigenschaft 'meldungen'.
     *
     * @see #_meldungen
     */
    public String getMeldungen() {
        return _meldungen;
    }

    //~ SET METHODEN ==========================================================

    /**
     * Setter fr Eigenschaft 'datei'.
     *
     * @param datei Wert zum Setzen der Eigenschaft 'datei'.
     *
     * @see #_datei
     */
    public void setDatei(String datei) {
        _datei = datei;
    }

    /**
     * Setter fr Eigenschaft 'fortschrittsanzeige'.
     *
     * @param fortschrittsanzeige Wert zum Setzen der Eigenschaft 'fortschrittsanzeige'.
     *
     * @see #_fortschrittsanzeige
     */
    public void setFortschrittsanzeige(int fortschrittsanzeige) {
        _fortschrittsanzeige = fortschrittsanzeige;
    }

    /**
     * Setter fr Eigenschaft 'meldungen'.
     *
     * @param meldungen Wert zum Setzen der Eigenschaft 'meldungen'.
     *
     * @see #_meldungen
     */
    public void setMeldungen(String meldungen) {
        _meldungen = meldungen;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 25.09.09
