/*
 * @(#)ViewGTMDialog.java   08.03.13
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.navigation;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.gtm.datvew.aktionen.AktionenGTM;
import de.inovat.buv.plugin.gtm.hilfe.HilfeVew;
import de.inovat.buv.plugin.gtm.navigation.gtmdiag.GTMDialogGUI;
import de.inovat.buv.projektlib.rechtevew.aktionen.AbstrakteSichtMitBerechtigung;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

//~ KLASSEN ===================================================================

/**
 * Die Sicht Dialog.
 *
 * @author inovat
 * @author Dagmar Rostek (DR)
 * @version $Revision: 155 $Date: 2009-12-18 14:40:09 +0100 (Fr, 18 Dez 2009) $ / ($Author: LG $)
 */
public class ViewGTMDialog extends AbstrakteSichtMitBerechtigung {
    public static final String ID = "de.inovat.buv.plugin.gtm.navigation.tabellendarstellung.view";

    //~ FELDER ================================================================

    /** GTM-Dialog-Instanz */
    private GTMDialogGUI _gui;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Erzeugt eine Instanz der Klasse ViewGTMDialog.
     */
    public ViewGTMDialog() {}

    //~ METHODEN ==============================================================

    @Override
    public void dispose() {
        if (_gui != null) {
            _gui.getToolkit().dispose();

            // Sobald das Fenster geschlossen wird, werden alle beim Datenverteiler angemeldeten
            // Objekte vom Datenverteiler abgemeldet.
            _gui.abmeldenDavBeendenThread();
        }

        super.dispose();
    }

    //~ GET METHODEN ==========================================================

    @Override
    public String getBerechtigungsFunktionId() {
        return AktionenGTM.FUNKTION_ID_TABELLENDARSTELLUNG;
    }

    @Override
    public String getHilfeContextId() {
        return HilfeVew.getInstanz().ermittleIdFuerAnker(HilfeVew.ANKER_TABELLENDARSTELLUNG);
    }

    //~ METHODEN ==============================================================

    @Override
    public Control initGUI(Composite parent) {
        _gui = new GTMDialogGUI(parent);

        return _gui;
    }

    //~ SET METHODEN ==========================================================

    @Override
    public void setFocus() {

        // Setzen des Fokus auf die scrolled Composite. Dies ist notwendig, damit die folgende Methode
        // immer nur einmal aufgerufen wird, genau dann, wenn die ScrolledComposite den Fokus erhlt.
        // Diese Funktionen sind aber nur erlaubt, wenn der Benutzer die Berechtigung dazu hat (deswegen try-catch-block)!
        try {
            _gui.getScrolledComposite().setFocus();
            _gui.aktualisiereDarstellungBeiFocuserhalt();
        }
        catch (Exception ignored) {}
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 21.10.13
