/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.navigation.gtmdiag;

//~ KLASSEN ===================================================================

/**
 * Singelton Klasse reprsentiert die gewhlte Darstellung.
 *
 * @author inovat
 * @author Dagmar Rostek (DR)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public final class GewaehlteDarstellung {

    /**
     * Instanz der Klasse. Wird nur einmal erzeugt.
     */
    private static GewaehlteDarstellung _instanz = new GewaehlteDarstellung();

    //~ FELDER ================================================================

    /**
     * String der Darstellungsnamen enthlt, so dass der Verwaltungsdialog vorbelegt werden kann.
     */
    private String _gewaehlteDarstellung = "";

    /** String der den gewhlten Filter enthlt. */
    private String _gewaehlterFilter = "";

    /** String der den Soriternamen enthlt. */
    private String _gewaehlteSortierung = "";

    /** String der den gewhlten Spaltennamen enthlt. */
    private String _gewaehlteSpalten = "";

    //~ GET METHODEN ==========================================================

    /**
     * Getter fr Eigenschaft 'gewaehlteDarstellung'.
     *
     * @return Wert der Eigenschaft 'gewaehlteDarstellung'.
     *
     * @see #_gewaehlteDarstellung
     */
    public String getGewaehlteDarstellung() {
        return _gewaehlteDarstellung;
    }

    /**
     * Getter fr Eigenschaft 'gewaehlterFilter'.
     *
     * @return Wert der Eigenschaft 'gewaehlterFilter'.
     *
     * @see #_gewaehlterFilter
     */
    public String getGewaehlterFilter() {
        return _gewaehlterFilter;
    }

    /**
     *     Getter fr Eigenschaft 'gewaehlteSortierung'.
     *
     *     @return Wert der Eigenschaft 'gewaehlteSortierung'.
     *
     *     @see #_gewaehlteSortierung
     */
    public String getGewaehlteSortierung() {
        return _gewaehlteSortierung;
    }

    /**
     * Getter fr Eigenschaft 'gewaehlteSpalten'.
     *
     * @return Wert der Eigenschaft 'gewaehlteSpalten'.
     *
     * @see #_gewaehlteSpalten
     */
    public String getGewaehlteSpalten() {
        return _gewaehlteSpalten;
    }

    /**
     * Gibt die einzige Instanz der Klasse zurck.
     * @return Instanz der Klasse.
     */
    public static GewaehlteDarstellung getInstanz() {
        return _instanz;
    }

    //~ SET METHODEN ==========================================================

    /**
     * Setter fr Eigenschaft 'gewaehlteDarstellung'.
     *
     * @param gewaehlteDarstellung Wert zum Setzen der Eigenschaft 'gewaehlteDarstellung'.
     *
     * @see #_gewaehlteDarstellung
     */
    public void setGewaehlteDarstellung(String gewaehlteDarstellung) {
        _gewaehlteDarstellung = gewaehlteDarstellung;
    }

    /**
     * Setter fr Eigenschaft 'gewaehlterFilter'.
     *
     * @param gewaehlterFilter Wert zum Setzen der Eigenschaft 'gewaehlterFilter'.
     *
     * @see #_gewaehlterFilter
     */
    public void setGewaehlterFilter(String gewaehlterFilter) {
        _gewaehlterFilter = gewaehlterFilter;
    }

    /**
     * Setter fr Eigenschaft 'gewaehlteSortierung'.
     *
     * @param gewaehlteSortierung Wert zum Setzen der Eigenschaft 'gewaehlteSortierung'.
     *
     * @see #_gewaehlteSortierung
     */
    public void setGewaehlteSortierung(String gewaehlteSortierung) {
        _gewaehlteSortierung = gewaehlteSortierung;
    }

    /**
     * Setter fr Eigenschaft 'gewaehlteSpalten'.
     *
     * @param gewaehlteSpalten Wert zum Setzen der Eigenschaft 'gewaehlteSpalten'.
     *
     * @see #_gewaehlteSpalten
     */
    public void setGewaehlteSpalten(String gewaehlteSpalten) {
        _gewaehlteSpalten = gewaehlteSpalten;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 21.10.13
