/*
 * @(#)MyJavaNumberFormatSpecifierImpl.java   11.01.10
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.visualisierung.ganglinien;

//~ NICHT JDK IMPORTE =========================================================

import com.ibm.icu.text.SimpleDateFormat;
import com.ibm.icu.util.ULocale;
import de.inovat.buv.plugin.gtm.visualisierung.ganglinien.GanglinienGUIVew.GanglinienArt;
import org.eclipse.birt.chart.model.attribute.JavaNumberFormatSpecifier;
import org.eclipse.birt.chart.model.attribute.impl.JavaNumberFormatSpecifierImpl;

import java.util.Date;

//~ JDK IMPORTE ===============================================================

//~ KLASSEN ===================================================================

/**
 * Formatierung der Zeitpunktwerten fr die X-Achse.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 88 $ / $Date: 2012-03-09 16:20:38 +0100 (Fr, 09 Mrz 2012) $ / ($Author: LG $)
 */
public class MyZeitJavaNumberFormatSpecifierImpl extends JavaNumberFormatSpecifierImpl {

    /** GanglinienArt. */
    private GanglinienArt _zeitModus;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Erzeugt eine Instanz der Klasse MyZeitJavaNumberFormatSpecifierImpl.
     *
     * @param zeitModus GanglinienArt.
     */
    public MyZeitJavaNumberFormatSpecifierImpl(GanglinienArt zeitModus) {
        super();
        _zeitModus = zeitModus;
    }

    //~ METHODEN ==============================================================

    @Override
    public JavaNumberFormatSpecifier copyInstance() {
        return new MyZeitJavaNumberFormatSpecifierImpl(_zeitModus);
    }

    @Override
    public String format(double value, ULocale lo) {
        SimpleDateFormat sdc;

        if (_zeitModus.istTag()) {
            sdc = new SimpleDateFormat("HH:mm", lo);
        } else {
            sdc = new SimpleDateFormat("dd.MM.yyyy", lo);
        }

        return sdc.format(new Date((long) value));
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 10.01.11
