/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.projektlib;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.projektlib.aktionen.Aktionen;
import de.inovat.buv.projektlib.speicher.OrdnerEinstellungen;

import org.eclipse.ui.IPerspectiveDescriptor;
import org.eclipse.ui.IStartup;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchListener;
import org.eclipse.ui.PlatformUI;

//~ KLASSEN ===================================================================

/**
 * ber diese Klasse werden Projekt-PlugIns in RahmenWerk geladen.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 76 $ / $Date: 2013-10-29 16:22:06 +0100 (Di, 29 Okt 2013) $ / ($Author: LG $)
 */
public class StartUp implements IStartup {

    /**
     * Definiere IWorkbenchListener um die inovat-Perspective beim Schlieen zurckzusetzen.
     */
    private void addListenerRWGeschlossen() {
        PlatformUI.getWorkbench().addWorkbenchListener(new IWorkbenchListener() {
            @Override
            public void postShutdown(IWorkbench workbench) {}
            @Override
            public boolean preShutdown(IWorkbench workbench, boolean forced) {
                try {

                    // Ermittle die aktuelle Perspektive:
                    IPerspectiveDescriptor persAktiv = workbench.getActiveWorkbenchWindow().getActivePage().getPerspective();

                    // Falls aktuelle Perspektive die inovat-Perspektive ist, setze die zurck:
                    if (persAktiv.getId().equals(Aktionen.PERSPECTIVE_INOVAT_START)) {
                        PlatformUI.getWorkbench().getPerspectiveRegistry().revertPerspective(persAktiv);
                        workbench.getActiveWorkbenchWindow().getActivePage().resetPerspective();
                    }
                }
                catch (Exception e) {
                    e.printStackTrace();
                }

                return true;
            }
        });
    }

    @Override
    public void earlyStartup() {

        /*
        // Warte bis Bundesland geladen wird:
        try {
            while (!BundeslandVew.getInstanz().isBundeslandGeladen()) {
                Thread.sleep(1000);
            }
        }
        catch (InterruptedException e) {
            Log.zeigeInterneMeldung(Activator.PLUGIN_ID, e);
        }

         */

        // --------------------------------------------------------------------
        // Lsche die Dateien im TempOrdner:
        OrdnerEinstellungen.loescheTempOrdner();

        // --------------------------------------------------------------------
        // Addiere IWorkbenchListener um die Perspective beim Schlieen zurckzusetzen.:
        addListenerRWGeschlossen();
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 29.10.13
