/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.projektlib.konstanten;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.projektlib.Activator;
import de.inovat.buv.projektlib.dav.DavDatenVew;
import de.inovat.buv.projektlib.konstanten.Zustaende.BundesLaender;

import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;

import static de.inovat.buv.inovat.lib.konstanten.Konstanten.FILESEPARATOR;

//~ JDK IMPORTE ===============================================================

import java.util.HashMap;
import java.util.Map;

//~ KLASSEN ===================================================================

/**
 * Klasse sammelt alle GUI-Resource (Fonts, Image...).
 *
 * TODO Alle Resource hier definieren!
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 38 $ / $Date: 2013-10-08 15:30:34 +0200 (Di, 08 Okt 2013) $ / ($Author: LG $)
 */
public class KonstantenGUIResource {
    public static final Font FONT_ARIAL_6_NORMAL = new Font(Display.getCurrent(), "Arial", 6, SWT.NORMAL);

    /*
public static final Font FONT_ARIAL_7_BOLD   = new Font(Display.getCurrent(), "Arial", 7, SWT.BOLD);
public static final Font FONT_ARIAL_7_NORMAL = new Font(Display.getCurrent(), "Arial", 7, SWT.NORMAL);
public static final Font FONT_ARIAL_8_BOLD   = new Font(Display.getCurrent(), "Arial", 8, SWT.BOLD);
public static final Font FONT_ARIAL_16_BOLD = new Font(Display.getCurrent(), "Arial", 16, SWT.BOLD);
public static final Font FONT_ARIAL_12_BOLD = new Font(Display.getCurrent(), "Arial", 12, SWT.BOLD);
public static final Font FONT_ARIAL_10_BOLD = new Font(Display.getCurrent(), "Arial", 10, SWT.BOLD);
public static final Font FONT_LUCIDA_SANS_TW_7_BOLD = new Font(Display.getCurrent(),"Lucida Sans Typewriter",7,SWT.BOLD);
public static final Font FONT_ARIAL_9_NORMAL = new Font(Display.getCurrent(), "Arial", 9, SWT.NORMAL);
*/
    public static final Color FARBE_WEIS            = new Color(Display.getCurrent(), 255, 255, 255);
    public static final Color FARBE_VIOLET          = new Color(Display.getCurrent(), 130, 70, 250);
    public static final Color FARBE_SCHWARZ         = new Color(Display.getCurrent(), 0, 0, 0);
    public static final Color FARBE_ROT_HELL_2      = new Color(Display.getCurrent(), 255, 210, 210);
    public static final Color FARBE_ROT_HELL        = new Color(Display.getCurrent(), 255, 125, 125);
    public static final Color FARBE_ROT             = new Color(Display.getCurrent(), 255, 0, 0);
    public static final Color FARBE_ORANGE          = new Color(Display.getCurrent(), 255, 140, 36);
    public static final Color FARBE_MAGENDA         = new Color(Display.getCurrent(), 255, 0, 255);
    public static final Color FARBE_GRUEN_PALE      = new Color(Display.getCurrent(), 152, 251, 152);
    public static final Color FARBE_GRUEN_DUNKEL2   = new Color(Display.getCurrent(), 0, 100, 0);
    public static final Color FARBE_GRUEN           = new Color(Display.getCurrent(), 0, 255, 0);
    public static final Color FARBE_GRAU_GRUEN_HELL = new Color(Display.getCurrent(), 200, 235, 200);
    public final static Color FARBE_GRAU            = new Color(Display.getCurrent(), 190, 190, 190);
    public static final Color FARBE_GOLD            = new Color(Display.getCurrent(), 255, 215, 0);
    public static final Color FARBE_GELB            = new Color(Display.getCurrent(), 255, 255, 0);
    public static final Color FARBE_CYAN            = new Color(Display.getCurrent(), 210, 255, 255);
    public static final Color FARBE_BLAU            = new Color(Display.getCurrent(), 0, 0, 255);

    /** Logo aus dem Aufrufparameter {@link AufrufParameter#BUNDESLAND_LOGO} oder null. */
    public static Image       ICON_LOGO_BUNDESLAND_AUS_PARAMETER;
    public static final Image ICON_LOGO_INOVAT;
    public static final Image ICON_LOGO_UNBEKANNT;
    public static final Image ICON_STATUS_ARCHIV_ERROR;
    public static final Image ICON_STATUS_ARCHIV_ERROR_ROT;
    public static final Image ICON_STATUS_ARCHIV_OK;
    public static final Image ICON_STATUS_FEHLER;
    public static final Image ICON_STATUS_INFO;
    public static final Image ICON_STATUS_OK;
    public static final Image ICON_STATUS_UNBEKANNT;
    public static final Image ICON_VEW_ALLE_AUFKLAPEN;
    public static final Image ICON_VEW_ALLE_ZUKLAPEN;
    public static final Image ICON_VEW_KOPIEREN;
    public static final Image ICON_VEW_LOESCHEN;
    public static final Image ICON_VEW_PFEIL_HOCH;
    public static final Image ICON_VEW_PFEIL_LINKS;
    public static final Image ICON_VEW_PFEIL_RECHTS;
    public static final Image ICON_VEW_PFEIL_RUNTER;

    /**
     * Map der LogoIcons fr die Bundeslnder.
     * Das Map wird automatisch initialisiert fr alle Bundeslnder aus Enum Zustaende.BundesLaender.
     * Als Key wird die Abkrzung des Bundeslandes benutzt.
     * Als Icons werden die Datei ..icons/logos/Logo<Abkrzung>.png gesucht.
     * Kann null-Werte enthalten, falls das Icon nicht gefunden wird.
     */
    public static final Map<String, Image> MAP_ICON_LOGO_BUNDESLAND;
    private static final String            PFAD_ICONS_LOGOS;
    private static final String            PFAD_ICONS_STATUS;
    private static final String            PFAD_ICONS_VEW;

    //~ STATISCHE INITIALISIERER ==============================================

    static {

        // Initialisiere die Pfade:
        PFAD_ICONS_LOGOS  = "icons" + FILESEPARATOR + "logos" + FILESEPARATOR;
        PFAD_ICONS_STATUS = "icons" + FILESEPARATOR + "status" + FILESEPARATOR;
        PFAD_ICONS_VEW    = "icons" + FILESEPARATOR + "vew" + FILESEPARATOR;

        // Initialisiere das Logo Unbekannt:
        ICON_LOGO_UNBEKANNT = Activator.getImageDescriptorInovat(PFAD_ICONS_LOGOS + "LogoUnbekannt.png").createImage();

        // Initialisiere das Map der LogoIcons:
        MAP_ICON_LOGO_BUNDESLAND = new HashMap<String, Image>();

        StringBuilder datei;
        Image         image;

        for (BundesLaender bl : Zustaende.BundesLaender.values()) {

            // ..icons/logos/Logo<bl>.png
            datei = new StringBuilder(PFAD_ICONS_LOGOS);
            datei.append("Logo").append(bl.getAbkuerzung()).append(".png");

            try {
                image = Activator.getImageDescriptorInovat(datei.toString()).createImage();
            }
            catch (Exception e) {
                image = ICON_LOGO_UNBEKANNT;
            }

            MAP_ICON_LOGO_BUNDESLAND.put(bl.getAbkuerzung(), image);
        }

        // Initialisiere das Logo aus dem Aufrufparameter:
        String param = DavDatenVew.getInstanz().getAufrufParameterAlsString(AufrufParameter.BUNDESLAND_LOGO);

        if (param != null) {
            ICON_LOGO_BUNDESLAND_AUS_PARAMETER = new Image(Display.getCurrent(), param);
        } else {
            ICON_LOGO_BUNDESLAND_AUS_PARAMETER = null;
        }

        // Initialisiere die Icons:
        ICON_LOGO_INOVAT             = Activator.getImageDescriptorInovat(PFAD_ICONS_LOGOS + "inovat_200x74.gif").createImage();
        ICON_STATUS_ARCHIV_OK        = Activator.getImageDescriptorInovat(PFAD_ICONS_STATUS + "archivStatusOK_16x16.png").createImage();
        ICON_STATUS_ARCHIV_ERROR_ROT = Activator.getImageDescriptorInovat(PFAD_ICONS_STATUS + "archivStatusErrorROT_16x16.png").createImage();
        ICON_STATUS_ARCHIV_ERROR     = Activator.getImageDescriptorInovat(PFAD_ICONS_STATUS + "archivStatusERROR_16x16.png").createImage();
        ICON_STATUS_FEHLER           = Activator.getImageDescriptorInovat(PFAD_ICONS_STATUS + "fehler.png").createImage();
        ICON_STATUS_INFO             = Activator.getImageDescriptorInovat(PFAD_ICONS_STATUS + "info.gif").createImage();
        ICON_STATUS_OK               = Activator.getImageDescriptorInovat(PFAD_ICONS_STATUS + "ok.png").createImage();
        ICON_STATUS_UNBEKANNT        = Activator.getImageDescriptorInovat(PFAD_ICONS_STATUS + "unbekannt.png").createImage();
        ICON_VEW_ALLE_AUFKLAPEN      = Activator.getImageDescriptorInovat(PFAD_ICONS_VEW + "alleAufKlappen.png").createImage();
        ICON_VEW_ALLE_ZUKLAPEN       = Activator.getImageDescriptorInovat(PFAD_ICONS_VEW + "alleZuKlappen.png").createImage();
        ICON_VEW_KOPIEREN            = Activator.getImageDescriptorInovat(PFAD_ICONS_VEW + "kopieren.gif").createImage();
        ICON_VEW_LOESCHEN            = Activator.getImageDescriptorInovat(PFAD_ICONS_VEW + "loeschen.gif").createImage();
        ICON_VEW_PFEIL_LINKS         = Activator.getImageDescriptorInovat(PFAD_ICONS_VEW + "pfeil_links.gif").createImage();
        ICON_VEW_PFEIL_RECHTS        = Activator.getImageDescriptorInovat(PFAD_ICONS_VEW + "pfeil_rechts.gif").createImage();
        ICON_VEW_PFEIL_HOCH          = Activator.getImageDescriptorInovat(PFAD_ICONS_VEW + "arrow-up.gif").createImage();
        ICON_VEW_PFEIL_RUNTER        = Activator.getImageDescriptorInovat(PFAD_ICONS_VEW + "arrow-down.gif").createImage();
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 08.10.13
