/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */



package de.inovat.pat.datkat2html;

//~ NICHT JDK IMPORTE =========================================================

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

//~ KLASSEN ===================================================================

/**
 * Die Klasse Perspective implementiert die BasisPerspektive des PlugIns.
 *
 * @author inovat, innovative systeme - verkehr - tunnel - technik
 * @author Dipl.-Ing. Hans Christian Kni (HCK)
 * @version $Revision: 584 $ / $Date: 2012-03-30 12:19:37 +0200 (Fr, 30. Mrz 2012) $ / ($Author: LG $)
 */
public class Perspective implements IPerspectiveFactory {
    public void createInitialLayout(IPageLayout layout) {

        //
        String editorArea = layout.getEditorArea();

        layout.setEditorAreaVisible(false);

        // layout.setFixed(true);

        IFolderLayout topCenter = layout.createFolder("topCenter", IPageLayout.BOTTOM, 0.18f, editorArea);

        //
        // topCenter.addPlaceholder(ViewVerwaltung.ID);
        topCenter.addView(ViewVerwaltung.ID);

        // LogView:
        // layout.addStandaloneView(Log.LogViewID, true, IPageLayout.BOTTOM, 0.902f, "topCenter");
        IFolderLayout untenCenter = layout.createFolder("untenCenter", IPageLayout.BOTTOM, 0.82f, "topCenter");

        untenCenter.addView(Log.LogViewID);

    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 30.03.12
