/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */

package de.inovat.pat.datkat2html;

import de.inovat.pat.datkat2html.gui.DatKat2HTML;
import de.inovat.pat.datkat2html.html.DateiAusgabe;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.part.ViewPart;

/**
 * ffnet die Sicht 'Konvertierung des Datenkatalogs'.
 *
 * @author inovat, innovative systeme - verkehr - tunnel - technik
 * @author Dipl.-Ing. Hans Christian Kni (HCK)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class ViewVerwaltung extends ViewPart {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

	/** ID der Sicht. */
	public static final String ID = "de.inovat.pat.datkat2html.view";
// Private ----------------------------------------------------------------
	/** Instanz der Klasse DatKat2HTML. */
	private DatKat2HTML _gui;

// ------------------------------------------------------------------------
// STATISCHE METHODEN
// ------------------------------------------------------------------------

	/**
	 * Zeige den Text in der Statusleiste.
	 *
	 * @param text Text, der in der Statusleiste angezeigt wird.
	 */
	public static void zeigeStatusleisteText(String text){
		Text txt=StatusleistenElementDatKat.getInstanz().getTxtStatusleistenElement();
		if(txt!=null){
			txt.setText(text);
			txt.update();
		}
	}

// ------------------------------------------------------------------------
// INTERFACE METHODEN
// ------------------------------------------------------------------------


// --------------------- Interface IWorkbenchPart ---------------------

	/* (non-Javadoc)
	 * @see org.eclipse.ui.part.WorkbenchPart#createPartControl(org.eclipse.swt.widgets.Composite)
	 */
	public void createPartControl(Composite parent) {
		_gui = new DatKat2HTML(parent, 0);

		parent.addDisposeListener(new DisposeListener(){
			@Override
			public void widgetDisposed(DisposeEvent e) {
				// Leere die Statusleiste:
				zeigeStatusleisteText("");
				// Von KonvertierungListener abmelden:
				DateiAusgabe.removeKonvertierungListener(_gui);
			}
		});
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.part.WorkbenchPart#setFocus()
	 */
	public void setFocus() {
		if(_gui!=null){
			_gui.setFocus();

			if(_gui.getSelektionAuswahlListe()==null){
				zeigeStatusleisteText("Datenkatalogkonvertierung");
			}
			else{
				zeigeStatusleisteText("Konvertierungsvorgabe: "+_gui.getSelektionAuswahlListe());
			}
		}
	}
}