/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;

/**
 * Klasse verwaltet dtd-Element attributliste.
 * 
 * <!ELEMENT attributliste ( info? ) >
 * <!ATTLIST attributliste
 * 		pid NMTOKEN #REQUIRED
 * 		anzahl NMTOKEN #IMPLIED
 * 		anzahlIst (variabel|fest) "fest"
 * 		name NMTOKEN #REQUIRED
 * >
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class AttributlistenBeschreibung {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Private ----------------------------------------------------------------
	/** bersicht der AttributlistenBeschreibung. */
	private Uebersicht _uebersicht;

	/** Anzahl (kann null sein). */
	private String _anzahl;

	/** AnzahlIst (variabel|fest) */
	private String _anzahlIst;

	/** Die Definition vom Attributliste (kann null sein). */
	private AttributlistenDefinitionBeschreibung _attListenDefinitionBeschreibung;

// ------------------------------------------------------------------------
// KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
// ------------------------------------------------------------------------

	/**
	 * Erzeugt eine Instanz der Klasse AttributlistenBeschreibung.
	 *
	 * @param uebersicht
	 * @param anzahl
	 * @param anzahlIst
	 * @param attListenDefinitionBeschreibung
	 */
	public AttributlistenBeschreibung(Uebersicht uebersicht, String anzahl,
			String anzahlIst,
			AttributlistenDefinitionBeschreibung attListenDefinitionBeschreibung) {
		_uebersicht = uebersicht;
		_anzahl = anzahl;
		_anzahlIst = anzahlIst;
		_attListenDefinitionBeschreibung = attListenDefinitionBeschreibung;
	}

// ------------------------------------------------------------------------
// GETTER / SETTER METHODEN
// ------------------------------------------------------------------------

	/**
	 * Getter fr Eigenschaft 'anzahl'.
	 *
	 * @return Wert der Eigenschaft 'anzahl'.
	 *
	 * @see  {#link _anzahl}
	 */
	public String getAnzahl() {
		return _anzahl;
	}

	/**
	 * Getter fr Eigenschaft 'anzahlIst'.
	 *
	 * @return Wert der Eigenschaft 'anzahlIst'.
	 *
	 * @see  {#link _anzahlIst}
	 */
	public String getAnzahlIst() {
		return _anzahlIst;
	}

	/**
	 * Getter fr Eigenschaft 'attListenDefinitionBeschreibung'.
	 *
	 * @return Wert der Eigenschaft 'attListenDefinitionBeschreibung'.
	 *
	 * @see  {#link _attListenDefinitionBeschreibung}
	 */
	public AttributlistenDefinitionBeschreibung getAttListenDefinitionBeschreibung() {
		return _attListenDefinitionBeschreibung;
	}

	/**
	 * Getter fr Eigenschaft 'uebersicht'.
	 *
	 * @return Wert der Eigenschaft 'uebersicht'.
	 *
	 * @see  {#link _uebersicht}
	 */
	public Uebersicht getUebersicht() {
		return _uebersicht;
	}
}
