/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;

import java.util.ArrayList;
import java.util.List;

/**
 * Klasse verwaltet dtd-Element datenliste.
 * 
 * <!ELEMENT datenliste ((datum|datenliste|datenfeld)+) >
 * <!ATTLIST datenliste
 * 			name CDATA #REQUIRED
 * >
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class DatenlisteBeschreibung {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Private ----------------------------------------------------------------
	/** Name. */
	private String _name;

	/** Liste der DatumBeschreibungen. */
	private List<DatumBeschreibung> _listeDatumBeschreibung=new ArrayList<DatumBeschreibung>();

	/** Liste der DatenlisteBeschreibungen. */
	private List<DatenlisteBeschreibung> _listeDatenlisteBeschreibung=new ArrayList<DatenlisteBeschreibung>();

	/** Liste der DatenfeldBeschreibungen. */
	private List<DatenfeldBeschreibung> _listeDatenfeldBeschreibung=new ArrayList<DatenfeldBeschreibung>();

// ------------------------------------------------------------------------
// KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
// ------------------------------------------------------------------------

	/**
	 * Erzeugt eine Instanz der Klasse DatenlisteBeschreibung.
	 *
	 * @param name
	 * @param listeDatumBeschreibung
	 * @param listeDatenlisteBeschreibung
	 * @param listeDatenfeldBeschreibung
	 */
	public DatenlisteBeschreibung(String name,
			List<DatumBeschreibung> listeDatumBeschreibung,
			List<DatenlisteBeschreibung> listeDatenlisteBeschreibung,
			List<DatenfeldBeschreibung> listeDatenfeldBeschreibung) {
		_name = name;
		if(listeDatumBeschreibung!=null){
			_listeDatumBeschreibung = listeDatumBeschreibung;
		}
		if(listeDatenlisteBeschreibung!=null){
			_listeDatenlisteBeschreibung = listeDatenlisteBeschreibung;
		}
		if(listeDatenfeldBeschreibung!=null){
			_listeDatenfeldBeschreibung = listeDatenfeldBeschreibung;
		}
	}

// ------------------------------------------------------------------------
// GETTER / SETTER METHODEN
// ------------------------------------------------------------------------

	/**
	 * Getter fr Eigenschaft 'listeDatenfeldBeschreibung'.
	 *
	 * @return Wert der Eigenschaft 'listeDatenfeldBeschreibung'.
	 *
	 * @see  {#link _listeDatenfeldBeschreibung}
	 */
	public List<DatenfeldBeschreibung> getListeDatenfeldBeschreibung() {
		return _listeDatenfeldBeschreibung;
	}

	/**
	 * Getter fr Eigenschaft 'listeDatenlisteBeschreibung'.
	 *
	 * @return Wert der Eigenschaft 'listeDatenlisteBeschreibung'.
	 *
	 * @see  {#link _listeDatenlisteBeschreibung}
	 */
	public List<DatenlisteBeschreibung> getListeDatenlisteBeschreibung() {
		return _listeDatenlisteBeschreibung;
	}

	/**
	 * Getter fr Eigenschaft 'listeDatumBeschreibung'.
	 *
	 * @return Wert der Eigenschaft 'listeDatumBeschreibung'.
	 *
	 * @see  {#link _listeDatumBeschreibung}
	 */
	public List<DatumBeschreibung> getListeDatumBeschreibung() {
		return _listeDatumBeschreibung;
	}

	/**
	 * Getter fr Eigenschaft 'name'.
	 *
	 * @return Wert der Eigenschaft 'name'.
	 *
	 * @see  {#link _name}
	 */
	public String getName() {
		return _name;
	}
}
