/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;

import java.util.ArrayList;
import java.util.List;

/**
 * Klasse verwaltet dtd-Element modell.
 * 
 * <!ELEMENT modell (
 * 	(	typDefinition |
 * 		attributgruppenDefinition |
 * 		aspektDefinition |
 * 		attributDefinition |
 * 		attributlistenDefinition |
 * 		attributauswahlDefinition |
 *         mengenDefinition )*
 * ) >
 * 
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class ModellBeschreibung {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Private ----------------------------------------------------------------
	/** Liste der TypDefinitionBeschreibungen. */
	private List<TypDefinitionBeschreibung> _listeTypDefinitionB=new ArrayList<TypDefinitionBeschreibung>();

	/** Liste der AttributgruppenDefinitionBeschreibungen. */
	private List<AttributgruppenDefinitionBeschreibung> _listeAttributgruppenDefinitionB=new ArrayList<AttributgruppenDefinitionBeschreibung>();

	/** Liste der AspektDefinitionBeschreibungen. */
	private List<AspektDefinitionBeschreibung> _listeAspektDefinitionB=new ArrayList<AspektDefinitionBeschreibung>();

	/** Liste der AttributDefinitionBeschreibungen. */
	private List<AttributDefinitionBeschreibung> _listeAttributDefinitionB=new ArrayList<AttributDefinitionBeschreibung>();

	/** Liste der AttributlistenDefinitionBeschreibungen. */
	private List<AttributlistenDefinitionBeschreibung> _listeAttributlistenDefinitionB=new ArrayList<AttributlistenDefinitionBeschreibung>();

	/** Liste der AttributauswahlDefinitionBeschreibungen. */
	private List<AttributauswahlDefinitionBeschreibung> _listeAttributauswahlDefinitionB=new ArrayList<AttributauswahlDefinitionBeschreibung>();

	/** Liste der MengenDefinitionBeschreibungen. */
	private List<MengenDefinitionBeschreibung> _listeMengeDefinitionB=new ArrayList<MengenDefinitionBeschreibung>();

// ------------------------------------------------------------------------
// KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
// ------------------------------------------------------------------------

	/**
	 * Erzeugt eine Instanz der Klasse ModellBeschreibung.
	 *
	 * @param listeTypDefinitionB
	 * @param listeAttributgruppenDefinitionB
	 * @param listeAspektDefinitionB
	 * @param listeAttributDefinitionB
	 * @param listeAttributlistenDefinitionB
	 * @param listeAttributauswahlDefinitionB
	 * @param listeMengeDefinitionB
	 */
	public ModellBeschreibung(
			List<TypDefinitionBeschreibung> listeTypDefinitionB,
			List<AttributgruppenDefinitionBeschreibung> listeAttributgruppenDefinitionB,
			List<AspektDefinitionBeschreibung> listeAspektDefinitionB,
			List<AttributDefinitionBeschreibung> listeAttributDefinitionB,
			List<AttributlistenDefinitionBeschreibung> listeAttributlistenDefinitionB,
			List<AttributauswahlDefinitionBeschreibung> listeAttributauswahlDefinitionB,
			List<MengenDefinitionBeschreibung> listeMengeDefinitionB) {
		if(listeTypDefinitionB!=null){
			_listeTypDefinitionB = listeTypDefinitionB;
		}
		if(listeAttributgruppenDefinitionB!=null){
			_listeAttributgruppenDefinitionB = listeAttributgruppenDefinitionB;
		}
		if(listeAspektDefinitionB!=null){
			_listeAspektDefinitionB = listeAspektDefinitionB;
		}
		if(listeAttributDefinitionB!=null){
			_listeAttributDefinitionB = listeAttributDefinitionB;
		}
		if(listeAttributlistenDefinitionB!=null){
			_listeAttributlistenDefinitionB = listeAttributlistenDefinitionB;
		}
		if(listeAttributauswahlDefinitionB!=null){
			_listeAttributauswahlDefinitionB = listeAttributauswahlDefinitionB;
		}
		if(listeMengeDefinitionB!=null){
			_listeMengeDefinitionB = listeMengeDefinitionB;
		}
	}

// ------------------------------------------------------------------------
// GETTER / SETTER METHODEN
// ------------------------------------------------------------------------

	/**
	 * Getter fr Eigenschaft 'listeAspektDefinitionB'.
	 *
	 * @return Wert der Eigenschaft 'listeAspektDefinitionB'.
	 *
	 * @see  {#link _listeAspektDefinitionB}
	 */
	public List<AspektDefinitionBeschreibung> getListeAspektDefinitionB() {
		return _listeAspektDefinitionB;
	}

	/**
	 * Getter fr Eigenschaft 'listeAttributDefinitionB'.
	 *
	 * @return Wert der Eigenschaft 'listeAttributDefinitionB'.
	 *
	 * @see  {#link _listeAttributDefinitionB}
	 */
	public List<AttributDefinitionBeschreibung> getListeAttributDefinitionB() {
		return _listeAttributDefinitionB;
	}

	/**
	 * Getter fr Eigenschaft 'listeAttributauswahlDefinitionB'.
	 *
	 * @return Wert der Eigenschaft 'listeAttributauswahlDefinitionB'.
	 *
	 * @see  {#link _listeAttributauswahlDefinitionB}
	 */
	public List<AttributauswahlDefinitionBeschreibung> getListeAttributauswahlDefinitionB() {
		return _listeAttributauswahlDefinitionB;
	}

	/**
	 * Getter fr Eigenschaft 'listeAttributgruppenDefinitionB'.
	 *
	 * @return Wert der Eigenschaft 'listeAttributgruppenDefinitionB'.
	 *
	 * @see  {#link _listeAttributgruppenDefinitionB}
	 */
	public List<AttributgruppenDefinitionBeschreibung> getListeAttributgruppenDefinitionB() {
		return _listeAttributgruppenDefinitionB;
	}

	/**
	 * Getter fr Eigenschaft 'listeAttributlistenDefinitionB'.
	 *
	 * @return Wert der Eigenschaft 'listeAttributlistenDefinitionB'.
	 *
	 * @see  {#link _listeAttributlistenDefinitionB}
	 */
	public List<AttributlistenDefinitionBeschreibung> getListeAttributlistenDefinitionB() {
		return _listeAttributlistenDefinitionB;
	}

	/**
	 * Getter fr Eigenschaft 'listeMengeDefinitionB'.
	 *
	 * @return Wert der Eigenschaft 'listeMengeDefinitionB'.
	 *
	 * @see  {#link _listeMengeDefinitionB}
	 */
	public List<MengenDefinitionBeschreibung> getListeMengeDefinitionB() {
		return _listeMengeDefinitionB;
	}

	/**
	 * Getter fr Eigenschaft 'listeTypDefinitionB'.
	 *
	 * @return Wert der Eigenschaft 'listeTypDefinitionB'.
	 *
	 * @see  {#link _listeTypDefinitionB}
	 */
	public List<TypDefinitionBeschreibung> getListeTypDefinitionB() {
		return _listeTypDefinitionB;
	}
}
