/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;

/**
 * Klasse verwaltet dtd-Element erweitert.
 * 
 * <!ELEMENT erweitert EMPTY >
 * <!ATTLIST erweitert pid NMTOKEN #REQUIRED >
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class TypBeschreibung {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Private ----------------------------------------------------------------
	/** PID des Typs. */
	private String _pid;

	/** Die Definition vom Typ (kann null sein). */
	private TypDefinitionBeschreibung _typDefinitionBeschreibung;

// ------------------------------------------------------------------------
// KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
// ------------------------------------------------------------------------

	/**
	 * Erzeugt eine Instanz der Klasse TypBeschreibung.
	 *
	 * @param pid
	 * @param typDefinitionBeschreibung
	 */
	public TypBeschreibung(String pid,
			TypDefinitionBeschreibung typDefinitionBeschreibung) {
		_pid = pid;
		_typDefinitionBeschreibung = typDefinitionBeschreibung;
	}

// ------------------------------------------------------------------------
// GETTER / SETTER METHODEN
// ------------------------------------------------------------------------

	/**
	 * Getter fr Eigenschaft 'pid'.
	 *
	 * @return Wert der Eigenschaft 'pid'.
	 *
	 * @see  {#link _pid}
	 */
	public String getPid() {
		return _pid;
	}

	/**
	 * Getter fr Eigenschaft 'typDefinitionBeschreibung'.
	 *
	 * @return Wert der Eigenschaft 'typDefinitionBeschreibung'.
	 *
	 * @see  {#link _typDefinitionBeschreibung}
	 */
	public TypDefinitionBeschreibung getTypDefinitionBeschreibung() {
		return _typDefinitionBeschreibung;
	}

	/**
	 * Setter fr Eigenschaft 'typDefinitionBeschreibung'.
	 *
	 * @param typDefinitionBeschreibung Wert zum Setzen der Eigenschaft 'typDefinitionBeschreibung'.
	 *
	 * @see {#link _typDefinitionBeschreibung}
	 */
	public void setTypDefinitionBeschreibung(
			TypDefinitionBeschreibung typDefinitionBeschreibung) {
		_typDefinitionBeschreibung = typDefinitionBeschreibung;
	}
}
