/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;


/**
 * Klasse enthlt die allgemeine Information (PID, Name Info) ber das dtd-Objekt.
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class Uebersicht {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Private ----------------------------------------------------------------
	/** PID des Objekts. */
	private String _pid;

	/** Name des Objekts. */
	private String _name;

	/** Information ber das Objekt. */
	private InfoBeschreibung _info;

// ------------------------------------------------------------------------
// KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
// ------------------------------------------------------------------------

	/**
	 * Erzeugt eine Instanz der Klasse Uebersicht.
	 *
	 * @param pid
	 * @param name
	 * @param info
	 */
	public Uebersicht(String pid, String name, InfoBeschreibung info) {
		_pid = pid;
		_name = name;
		_info = info;
	}

// ------------------------------------------------------------------------
// GETTER / SETTER METHODEN
// ------------------------------------------------------------------------

	/**
	 * Getter fr Eigenschaft 'info'.
	 *
	 * @return Wert der Eigenschaft 'info'.
	 *
	 * @see  {#link _info}
	 */
	public InfoBeschreibung getInfo() {
		return _info;
	}

	/**
	 * Getter fr Eigenschaft 'name'.
	 *
	 * @return Wert der Eigenschaft 'name'.
	 *
	 * @see  {#link _name}
	 */
	public String getName() {
		return _name;
	}

	/**
	 * Getter fr Eigenschaft 'pid'.
	 *
	 * @return Wert der Eigenschaft 'pid'.
	 *
	 * @see  {#link _pid}
	 */
	public String getPid() {
		return _pid;
	}

	/**
	 * Setter fr Eigenschaft 'name'.
	 *
	 * @param name Wert zum Setzen der Eigenschaft 'name'. 
	 *
	 * @see #_name
	 */
	public void setName(String name) {
		_name = name;
	}
}
