/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */



package de.inovat.pat.datkat2html.gui;

//~ NICHT JDK IMPORTE =========================================================

import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

import de.inovat.pat.datkat2html.Activator;
import de.inovat.pat.datkat2html.html.DateiAusgabe;
import de.inovat.pat.datkat2html.html.IKonvertierungsProzessAenderungen;
import de.inovat.pat.datkat2html.html.KonvertierungsProzessAenderungen;
import de.inovat.pat.datkat2html.html.KonvertierungsProzessAenderungen.MeldungsTyp;
import de.inovat.pat.datkat2html.Log;
import de.inovat.pat.datkat2html.vew.KonfigurationsBereich;
import de.inovat.pat.datkat2html.vew.KonvertierungsVorgabe;
import de.inovat.pat.datkat2html.vew.KonvertierungsVorgaben;
import de.inovat.pat.datkat2html.ViewVerwaltung;
import de.inovat.sys.funclib.bsvrzxml.BSVRZXML;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.custom.TableEditor;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.PlatformUI;

//~ JDK IMPORTE ===============================================================

import java.io.File;
import java.io.FileNotFoundException;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;

import javax.xml.bind.JAXBException;

//~ KLASSEN ===================================================================

/**
 * Klasse definiert das GUI fr die Datenkatalogkonvertierung und verwaltet das.
 *
 * @author inovat, innovative systeme - verkehr - tunnel - technik
 * @author Dipl.-Ing. Hans Christian Kni (HCK)
 * @version $Revision: 729 $ / $Date: 2008-09-17 10:18:40 +0200 (Mi, 17 Sep
 *          2008) $ / ($Author: LG $)
 */
public class DatKat2HTML extends org.eclipse.swt.widgets.Composite implements SelectionListener, KeyListener, FocusListener, MouseListener, IKonvertierungsProzessAenderungen {

    /** Systemunabhngiger Fileseparator. */
    public final static String FILESEPARATOR = System.getProperty("file.separator");

    //~ FELDER ================================================================

    /** Namen der TabellenSpalten. */
    private String[] _arSpalten = new String[] { "Modelle", "Objekte", "KV", "KonfigurationsBereich", "Pfad", "..." };

    /** Grer der TabellenSpalten. */
    private int[] _arSpaltenGroesse = new int[] { 57, 57, 120, 200, 200, 40 };

    /** Instanz der Klasse, wo alle Vorgaben in Map gespeichert sind. */
    private KonvertierungsVorgaben _konvertierungsVorgaben = new KonvertierungsVorgaben();

    /** Editors (CheckButtons) fr die Spalte 0 */
    private java.util.List<TableEditor> _listeEditor0 = new ArrayList<TableEditor>();

    /** Editors (CheckButtons) fr die Spalte 1 */
    private java.util.List<TableEditor> _listeEditor1 = new ArrayList<TableEditor>();

    /** Editors (Buttons ... ) fr die Spalte 5 */
    private java.util.List<TableEditor> _listeEditor5 = new ArrayList<TableEditor>();

    /** Liste der ausgewhlten Konfigurationsbereichen. */
    private java.util.List<KonfigurationsBereich> _listeKB                  = new ArrayList<KonfigurationsBereich>();
    private Image                                 _imageWarnung             = ResourceManager.getPluginImage(Activator.getDefault(), "icons/warnung.png");
    private Image                                 _imageOk                  = ResourceManager.getPluginImage(Activator.getDefault(), "icons/ok.png");
    private Image                                 _imageNochOffen           = ResourceManager.getPluginImage(Activator.getDefault(), "icons/nochOffen.png");
    private Image                                 _imageKeineTransformation = ResourceManager.getPluginImage(Activator.getDefault(), "icons/keineTransformation.png");
    private Image                                 _imageInBearbeitung       = ResourceManager.getPluginImage(Activator.getDefault(), "icons/inBearbeitung.png");
    private Image                                 _imageFehler              = ResourceManager.getPluginImage(Activator.getDefault(), "icons/fehler.png");

    /** StandartFont */
    private Font _fontNormal = JFaceResources.getDefaultFont();

    /**
     * Font wird benutzt um die gerade bearbeitete Zeile (konvertierten KB)
     * hervorheben
     */
    private Font _fontFett = SWTResourceManager.getFont("", 10, SWT.BOLD);

    /**
     * String wird in der Tabelle angezeigt, falls die entsprechende XMLDatei
     * nicht validieren werden knnen.
     */
    private String _ungueltig = "ungltiges Format";

    /** Definiert, ob die GUIDaten gendert sind. */
    private boolean _sindGUIDatenGeaendert = false;

    /** Definiert, ob der Konvertierung Prozess luft. */
    private boolean _istKonvertierungsProzessLaeuft = false;

    /** Contexthilfe fr die gesamte Anwendung */
    private final String HILFE_DatKat = Activator.PLUGIN_ID + ".start";

    /** Contexthilfe fr die Konvertierung */
    private final String HILFE_Konvertierung = Activator.PLUGIN_ID + ".konvertierung";

    /** Contexthilfe fr die Verwaltunf */
    private final String HILFE_Verwaltung = Activator.PLUGIN_ID + ".verwaltung";

    /** ber diese Instanz werden die Ausgabefunktionen und Listener aufgerufen. */
    private DateiAusgabe _ausgabe;

    // ------------------------------------------------------------------------
    // VARIABLENDEKLARATIONEN
    // ------------------------------------------------------------------------
    // Private ----------------------------------------------------------------
    private Browser   _browser;
    private Button    _btnKonvAbbruch;
    private Button    _btnKonvHilfe;
    private Button    _btnKonvKonvertierung;
    private Button    _btnVewHilfe;
    private Button    _btnVewKonfigurationsBereichEntfernen;
    private Button    _btnVewKonfigurationsBereichHinzufuegen;
    private Button    _btnVewKopieren;
    private Button    _btnVewLoeschen;
    private Button    _btnVewNeu;
    private Button    _btnVewUebernehmen;
    private Button    _btnVewZielOrdner;
    private Button    _btnVewZuruecksetzen;
    private Composite _compAnsicht;
    private Composite _compAuswahlBereich;
    private Composite _compDialogBereich;
    private Composite _compKonvertierung;
    private Composite _compKonvertierungSchaltFlaechen;
    private Composite _compKonvertierungTeilSchaltFlaechen;
    private Composite _compVerwaltung;
    private Composite _compVerwaltungSchaltFlaechen;
    private Composite _compVerwaltungTeilSchaltFlaechen;
    private Composite _compVewKonfigurationsbereicheSchaltflaechen;
    private Group     _grpKonvAllgemeineEigenschaften;
    private Group     _grpKonvFortschrittsAnzeige;
    private Group     _grpKonvKonfigurationsBrereiche;
    private Group     _grpVewAllgemeineEigenschaften;
    private Group     _grpVewKonfigurationsBrereiche;
    private Label     _lbKonvFortschrittGesamt;
    private Label     _lbKonvFortschrittKonfigurationsBereich;
    private Label     _lbKonvHorizontaleFeder;
    private Label     _lbKonvKommentar;
    private Label     _lbKonvKurzBezeichung;
    private Label     _lbKonvLangBezeichung;
    private Label     _lbKonvZielOrdner;
    private Label     _lbLogoBW;
    private Label     _lbLogoInovat;
    private Label     _lbVewHorizontaleFeder;
    private Label     _lbVewKommentar;
    private Label     _lbVewKonfigurationsbereichHorizontaleFeder;
    private Label     _lbVewKurzBezeichung;
    private Label     _lbVewLangBezeichung;
    private Label     _lbVewZielOrdner;

    /** Navigation. */
    private List        _listAuswahl;
    private ProgressBar _progressBarKonvGesamt;
    private ProgressBar _progressBarKonvKonfigurationsBereich;
    private SashForm    _sashFormAuswahlUndDialogBereich;

    /** Das in der Navigation 'Konvertierungsvorgaben' selektierte String. */
    private String _selektionAuswahlListe;

    /** Die in der Navigation selektierte Vorgabe. */
    private KonvertierungsVorgabe _selektionKonvertierungsVorgabe;
    private Shell                 _shell;
    private TabItem               _tabAnsicht;
    private TableViewer           _tabelVewTabelleKonfigurationsBereiche;
    private TabItem               _tabKonvertieren;
    private TableViewer           _tableViewerKonvKB;
    private TabFolder             _tabPluginDatKat2HTML;
    private TabItem               _tabVerwalten;
    private ToolBar               _tbarAnsichtNavigation;
    private ToolItem              _titemAnsichtNeuLaden;
    private ToolItem              _titemAnsichtOK;
    private ToolItem              _titemAnsichtStopp;
    private ToolItem              _titemAnsichtVorwaerts;
    private ToolItem              _titemAnsichtZurueck;
    private Text                  _txtAnsichtURL;
    private Text                  _txtAreaKonvKommentar;
    private Text                  _txtAreaVewKommentar;
    private Text                  _txtKonvKurzBezeichnung;
    private Text                  _txtKonvLangBezeichnung;
    private Text                  _txtKonvZielOrdner;
    private Text                  _txtVewKurzBezeichnung;
    private Text                  _txtVewLangBezeichnung;
    private Text                  _txtVewZielOrdner;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    // ------------------------------------------------------------------------
    // KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
    // ------------------------------------------------------------------------
    // ------------------------------------------------------------------------
    // KONSTRUKTOREN (und vom Konstruktor verwende Methoden)
    // ------------------------------------------------------------------------
    // KONSTRUKTOREN (und vom Konstruktor verwende Methoden)
    public DatKat2HTML(org.eclipse.swt.widgets.Composite parent, int style) {
        super(parent, style);
        setLayout(new FillLayout());
        DateiAusgabe.addKonvertierungListener(this);
        _shell = this.getShell();
        initGUI();
    }

    //~ METHODEN ==============================================================

    /**
     * ndere den logischen Wert von KonfigurationBereich (_modell oder _objekt)
     * entsprechend dem Wert aus dem CheckButton.
     *
     * @param modelObjekt
     *            Falls gleich 1 ist, ndere den Wert von _modell, sonst - von
     *            _objekt.
     * @param num
     *            Die Nummer des zu modifizierten KonfigurationBereichs in der
     *            Liste.
     * @param e
     */
    private void aendereBooleanListe(int modelObjekt, int num, SelectionEvent e) {
        boolean wert = ((Button) e.getSource()).getSelection();

        if (modelObjekt == 1) {
            _listeKB.get(num).setModell(wert);
        } else {
            _listeKB.get(num).setObjekt(wert);
        }

        _sindGUIDatenGeaendert = true;
        setzeEnabledFrGUI();
    }

    /**
     * Aktualisiere GUI.
     */
    private void aktualisiereGUIKonvertierung() {
        _progressBarKonvGesamt.redraw();
        _progressBarKonvGesamt.update();
        _progressBarKonvKonfigurationsBereich.redraw();
        _progressBarKonvKonfigurationsBereich.update();
        _tableViewerKonvKB.getTable().redraw();
        _tableViewerKonvKB.getTable().update();
        _compKonvertierung.update();
        _compKonvertierung.redraw();
    }

    /**
     * ffne den Dialog "Konfigurationsbereichdatei hinzufgen", erstelle
     * KonfigurationsBereiche aus den ausgewhlten XMLDateien und fge die in
     * der Liste ein.
     *
     */
    private void auswaehlenKbDatei() {

        // Auswahldialog fr XML-Dateien (Konfigurationsbereiche) anzeigen
        FileDialog fileDialog = new FileDialog(getShell(), SWT.MULTI);

        fileDialog.setText("Konfigurationsbereichdatei hinzufgen");

        // Nur XML-Dateien zulassen
        fileDialog.setFilterExtensions(new String[] { "*.xml" });

        // KonfigurationsBereiche definieren:
        if ((fileDialog.open()) != null) {
            KonfigurationsBereich kb;
            String                ordner = fileDialog.getFilterPath();

            for (String fileName : fileDialog.getFileNames()) {
                kb = erstelleKonfigurationsBereichAusXML(String.format("%s%s%s", ordner, FILESEPARATOR, fileName));

                if (kb != null) {
                    if (!isKBinListe(kb.getKb())) {
                        _listeKB.add(kb);
                        _sindGUIDatenGeaendert = true;
                        setzeEnabledFrGUI();
                    } else {
                        Log.zeige(Log.erzeugeMeldung(Log.WARNUNG, Activator.PLUGIN_ID, "Die Datei mit dem Konfigurationbereich [" + kb.getKb() + "] existieren schon in der Tabelle."));
                    }
                }
            }
        }

        setzeDatenVerwaltungTabelle();
    }

    /**
     * ffne den Dialog "Auswahl der Konfigurationsbereichdatei", erstelle
     * KonfigurationsBereich aus der ausgewhlten XMLDatei und fge den in der
     * Liste von KB statt des Elements mit der Nummer numItem ein.
     *
     * @param numItem
     *            Nummer des KonfigurationsBereich in der Liste,der gendert
     *            werden soll.
     */
    private void auswaehlenKbDatei(int numItem) {

        // Auswahldialog fr XML-Dateien (Konfigurationsbereiche) anzeigen
        FileDialog fileDialog = new FileDialog(getShell(), SWT.NONE);

        fileDialog.setText("Auswahl der Konfigurationsbereichdatei");

        // Pfad auf aktuell ausgewhlte Datei vorbelegen
        fileDialog.setFilterPath(_listeKB.get(numItem).getPfad());

        // Nur XML-Dateien zulassen
        fileDialog.setFilterExtensions(new String[] { "*.xml" });

        // KonfigurationsBereich definieren
        String pfad;

        if ((pfad = fileDialog.open()) != null) {

            // Falls die XMLDatei gelesen werden knnen,
            // erstelle kb und fge das in der Liste ein:
            KonfigurationsBereich kb = erstelleKonfigurationsBereichAusXML(pfad);

            if (kb != null) {
                KonfigurationsBereich kbAlt = _listeKB.get(numItem);

                _listeKB.remove(numItem);

                if (!isKBinListe(kb.getKb())) {
                    _listeKB.add(kb);
                    _sindGUIDatenGeaendert = true;
                    setzeEnabledFrGUI();
                } else {
                    _listeKB.add(kbAlt);
                    Log.zeige(Log.erzeugeMeldung(Log.WARNUNG, Activator.PLUGIN_ID, "Die Datei mit dem Konfigurationbereich [" + kb.getKb() + "] existieren schon in der Tabelle."));
                }
            }
        }

        setzeDatenVerwaltungTabelle();
    }

    /**
     * Die Schaltfl'che 'Abbruch' wird selektiert.
     */
    private void btnAbbruchSelektiert() {
        if (_ausgabe != null) {
            _ausgabe.setAbbruch(true);
            Log.zeige(Log.erzeugeMeldung(Log.INFO, Activator.PLUGIN_ID, "Konvertierung wurde durch den Benutzer unterbrochen!"));
        }
    }

    /**
     * Kopiere die gerade selektierte KonvertierungsVorgabe und selektiere die
     * neuerzeugte KonvertierungsVorgabe.
     */
    private void btnKopiereKonvertierungsVorgabe() {

        // 1. Neue Vorgabe kopieren und speichern:
        String neueVorgabe = _konvertierungsVorgaben.kopiereKonvertierungsVorgabe(_selektionKonvertierungsVorgabe).getKurzBezeichung();

        // 2. Liste der bereits definierten Konverteriungsvorgaben vorbesetzen.
        _listAuswahl.setItems(_konvertierungsVorgaben.getSortiereListeDerKonvertierungsVorgabenKurzBezeichungen());

        // 3. Neue Vorgabe selektierern:
        int indexNeu = Arrays.binarySearch(_listAuswahl.getItems(), neueVorgabe);

        if (indexNeu < 0) {
            indexNeu = 0;
        }

        _listAuswahl.setFocus();
        _listAuswahl.select(indexNeu);

        // neue Selektion in _listAuswahl:
        _selektionAuswahlListe = _listAuswahl.getSelection()[0];
        _sindGUIDatenGeaendert = false;
        setzeDatenGUI();
    }

    // ------------------------------------------------------------------------
    // SONSTIGE METHODEN
    // ------------------------------------------------------------------------

    /**
     * Gebe das Image entsprechend dem MeldungsTyp zurck, oder null, falls kein
     * richtiger MeldungsTyp angegeben ist.
     *
     * @param typ
     * @return
     */
    private Image ermittleImage(MeldungsTyp typ) {
        if (typ == null) {
            return null;
        }

        switch (typ) {
        case fehler :
            return _imageFehler;

        case keineTransformation :
            return _imageKeineTransformation;

        case inBearbeitung :
            return _imageInBearbeitung;

        case nochOffen :
            return _imageNochOffen;

        case ok :
            return _imageOk;

        case warnung :
            return _imageWarnung;

        default :
            return null;
        }
    }

    /**
     * Erstelle den KonfigurationsBereich aus der XMLDatei. Falls ein Fehler
     * beim Lesen aufgetreten ist, wird KB und KV auf "ungltiges Format"
     * eingesetzt.
     *
     * @param xmlDatei
     * @return KonfigurationsBereich.
     */
    private KonfigurationsBereich erstelleKonfigurationsBereichAusXML(String xmlDatei) {
        KonfigurationsBereich kb       = null;
        String                kbPid    = _ungueltig;
        String                kvPid    = _ungueltig;
        boolean               isModell = false;
        boolean               isObjekt = false;

        try {
            BSVRZXML kbDatei = new BSVRZXML(xmlDatei);

            kbPid    = kbDatei.getKb().getPid();
            kvPid    = kbDatei.getKb().getVerantwortlich();
            isModell = isModelleVorhanden(kbDatei);
            isObjekt = isObjekteVorhanden(kbDatei);
        }
        catch (FileNotFoundException e) {
            Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Die Datei [" + xmlDatei + "] wurde nicht gefunden!", e));
        }
        catch (JAXBException e) {
            Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Die Datei [" + xmlDatei + "] ist kein gltiger Konfigurationsbereich!", e));
        }

        kb = new KonfigurationsBereich(isModell, isObjekt, kvPid, kbPid, xmlDatei);

        return kb;
    }

    /**
     * erstelle neue KonvertierungsVorgabe und selektiere die.
     */
    private void erstelleNeueKonvertierungsVorgaben() {

        // Neu Vorgabe erzeugen:
        // 1. Vorgabe erzeugen
        // 2. Liste neu erzeugen und darstellen (neues Element hinzugekommen.)
        // 3. Listeneintrag selektieren
        // 4. Listeneintrag "auswhlen" --> Dialoge werden automatisch neu
        // aufgebaut.
        // zu 1.
        KonvertierungsVorgabe konvertierungsVorgabe = _konvertierungsVorgaben.erzeugeNeueKonvertierungsVorgabe();

        // zu 2. Liste neu erzeugen und darstellen (neues Element hinzugekommen)
        _listAuswahl.setItems(_konvertierungsVorgaben.getSortiereListeDerKonvertierungsVorgabenKurzBezeichungen());

        // zu 3. Listeneintrag selektieren
        _selektionAuswahlListe = konvertierungsVorgabe.getKurzBezeichung();

        String[] auswahl = new String[] { _selektionAuswahlListe };

        _listAuswahl.setSelection(auswahl);

        // zu 4. Listeneintrag "auswhlen" --> Dialoge werden automatisch neu
        // aufgebaut
        _sindGUIDatenGeaendert = false;
        setzeDatenGUI();
    }

    // ------------------------------------------------------------------------
    // INTERFACE METHODEN
    // ------------------------------------------------------------------------
    // --------------------- Interface FocusListener ---------------------
    public void focusGained(FocusEvent event) {

        // To change body of implemented methods use File | Settings | File
        // Templates.
    }

    public void focusLost(FocusEvent event) {
        if (event.getSource().equals(_txtAnsichtURL)) {
            _browser.setUrl(_txtAnsichtURL.getText());
        }
    }

    //~ GET METHODEN ==========================================================

    // ------------------------------------------------------------------------
    // GETTER / SETTER METHODEN
    // ------------------------------------------------------------------------

    /**
     * Getter fr Eigenschaft '_selektionAuswahlListe'.
     *
     * @return Wert der Eigenschaft '_selektionAuswahlListe'.
     *
     * @see {#link _selektionAuswahlListe}
     */
    public String getSelektionAuswahlListe() {
        return _selektionAuswahlListe;
    }

    //~ METHODEN ==============================================================

    /**
     * Drucke die Zeile mit der Nummer nummerZeile von der KonvertierungsTablle
     * fett. Andere werden normal dargestellt.
     *
     * Falls nummerZeile kleiner als 0 ist, werden alle Zeile normal
     * dargestellt.
     *
     * @param nummerZeile
     */
    private void hervorhebenZeile(int nummerZeile) {

        // Die Methode wird ber Display.syncExec ausgefhrt,
        // da die von nicht GUI-Thread aufgerufen wird
        // und man einen Zugriff auf GUI braucht.
        final int nummerZ = nummerZeile;

        getDisplay().syncExec(new Runnable() {
            @Override
            public void run() {
                int i = 0;

                for (TableItem item : _tableViewerKonvKB.getTable().getItems()) {
                    if (i == nummerZ) {
                        item.setFont(2, _fontFett);
                        item.setFont(3, _fontFett);
                        item.setFont(4, _fontFett);
                    } else {
                        item.setFont(2, _fontNormal);
                        item.setFont(3, _fontNormal);
                        item.setFont(4, _fontNormal);
                    }

                    i++;
                }

                aktualisiereGUIKonvertierung();
            }
        });
    }

    private void initGUI() {
        try {
            {
                _sashFormAuswahlUndDialogBereich = new SashForm(this, SWT.HORIZONTAL);
                _sashFormAuswahlUndDialogBereich.setSize(60, 30);
                _sashFormAuswahlUndDialogBereich.addDisposeListener(new DisposeListener() {
                    @Override
                    public void widgetDisposed(DisposeEvent e) {

                        // berprfe, ob die Daten im GUI gendert sind:
                        if (_sindGUIDatenGeaendert) {
                            if (MessageDialog.openQuestion(_shell, "Speichern?", "Die Daten in der Sicht 'Konvertierung des Datenkatalogs' wurden gendert. \n\nSollen die nderungen gespeichert werden?")) {
                                uebernehmeDatenAusVoreinstellung();
                            }
                        }
                    }
                });
                {
                    _compAuswahlBereich = new Composite(_sashFormAuswahlUndDialogBereich, SWT.NONE);

                    GridLayout _compAuswahlBereichLayout = new GridLayout();

                    _compAuswahlBereichLayout.makeColumnsEqualWidth = true;
                    _compAuswahlBereich.setLayout(_compAuswahlBereichLayout);
                    _compAuswahlBereich.setBounds(28, 24, 512, 768);
                    _compAuswahlBereich.setSize(-1, 768);
                    {
                        _lbLogoBW = new Label(_compAuswahlBereich, SWT.CENTER | SWT.BORDER);
                        _lbLogoBW.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/BW_200x74.gif"));
                        _lbLogoBW.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
                        _lbLogoBW.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));
                        _lbLogoBW.addMouseListener(this);
                    }
                    {
                        final Label konvertierungsvorgabenLabel = new Label(_compAuswahlBereich, SWT.NONE);

                        konvertierungsvorgabenLabel.setText("Konvertierungsvorgaben:");
                    }
                    {
                        _listAuswahl = new List(_compAuswahlBereich, SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER);
                        _listAuswahl.setToolTipText("Liste aller definierten Konvertierungsvorgaben.");
                        _listAuswahl.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
                        _listAuswahl.setBounds(5, 23, 197, 722);
                        _listAuswahl.setSize(197, 722);
                        _listAuswahl.addSelectionListener(new SelectionAdapter() {
                            public void widgetSelected(SelectionEvent evt) {
                                verarbeiteSelektionDerAuswahlListe();
                            }
                        });
                    }
                    {
                        _lbLogoInovat = new Label(_compAuswahlBereich, SWT.BORDER);
                        _lbLogoInovat.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/inovat_200x74.gif"));
                        _lbLogoInovat.setAlignment(SWT.CENTER);
                        _lbLogoInovat.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));
                        _lbLogoInovat.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/inovat_200x74.gif"));
                        _lbLogoInovat.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
                        _lbLogoInovat.addMouseListener(this);
                    }
                }
                {
                    {
                        {
                            {
                                {
                                    {
                                        GridData _progressBarGesamtLData = new GridData();

                                        _progressBarGesamtLData.grabExcessHorizontalSpace = true;
                                    }
                                }
                            }
                        }
                        {
                            {
                                {
                                    {
                                        GridData _tabelVewTabelleKonfigurationsBereicheLData = new GridData();

                                        _tabelVewTabelleKonfigurationsBereicheLData.grabExcessHorizontalSpace = true;
                                        _tabelVewTabelleKonfigurationsBereicheLData.grabExcessVerticalSpace   = true;
                                        _tabelVewTabelleKonfigurationsBereicheLData.horizontalAlignment       = GridData.FILL;
                                        _tabelVewTabelleKonfigurationsBereicheLData.verticalAlignment         = GridData.FILL;
                                    }

                                    /*
                                     * { GridData
                                     * _scompVewKonvertierungsBereichLData = new
                                     * GridData();
                                     * _scompVewKonvertierungsBereichLData.grabExcessHorizontalSpace =
                                     * true;
                                     * _scompVewKonvertierungsBereichLData.grabExcessVerticalSpace =
                                     * true;
                                     * _scompVewKonvertierungsBereichLData.horizontalAlignment =
                                     * GridData.FILL;
                                     * _scompVewKonvertierungsBereichLData.verticalAlignment =
                                     * GridData.FILL;
                                     * _scompVewKonvertierungsBereich = new
                                     * ScrolledComposite(_grpVewKonfigurationsBrereiche,
                                     * SWT.H_SCROLL | SWT.V_SCROLL |
                                     * SWT.BORDER);
                                     * _scompVewKonvertierungsBereich.setLayoutData(_scompVewKonvertierungsBereichLData); {
                                     * _lbVewBildMitTabellenDarstellung = new
                                     * Label(_scompVewKonvertierungsBereich,
                                     * SWT.NONE);
                                     * _scompVewKonvertierungsBereich.setContent(_lbVewBildMitTabellenDarstellung);
                                     * _lbVewBildMitTabellenDarstellung.setImage(SWTResourceManager.getImage("icons/Verwaltungs-Tabelle.png"));
                                     * _lbVewBildMitTabellenDarstellung.setBounds(0,
                                     * 0, 1032, 411);
                                     * _lbVewBildMitTabellenDarstellung.setSize(975,
                                     * 411); } }
                                     */
                                }
                            }
                        }
                    }
                }
                _compDialogBereich = new Composite(_sashFormAuswahlUndDialogBereich, SWT.NONE);

                GridLayout composite1Layout = new GridLayout();

                composite1Layout.makeColumnsEqualWidth = true;
                _compDialogBereich.setLayout(composite1Layout);
                _tabPluginDatKat2HTML = new TabFolder(_compDialogBereich, SWT.NONE);
                _tabPluginDatKat2HTML.addSelectionListener(new SelectionAdapter() {
                    public void widgetSelected(final SelectionEvent e) {
                        reiterNeuSelektiert();
                    }
                });
                _tabVerwalten = new TabItem(_tabPluginDatKat2HTML, SWT.NONE);
                _tabVerwalten.setToolTipText("Verwaltung der Konvertierungsvorgabe.");
                _tabVerwalten.setText("Verwaltung");
                _compVerwaltung = new Composite(_tabPluginDatKat2HTML, SWT.NONE);
                _tabVerwalten.setControl(_compVerwaltung);

                GridLayout _compVerwaltungLayout = new GridLayout();

                _compVerwaltungLayout.makeColumnsEqualWidth = true;
                _compVerwaltung.setLayout(_compVerwaltungLayout);
                {
                    _grpVewAllgemeineEigenschaften = new Group(_compVerwaltung, SWT.NONE);

                    GridLayout _grpAllgemeineEigenschaftenLayout = new GridLayout();

                    _grpAllgemeineEigenschaftenLayout.numColumns = 3;
                    _grpVewAllgemeineEigenschaften.setLayout(_grpAllgemeineEigenschaftenLayout);
                    _grpVewAllgemeineEigenschaften.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false));
                    _grpVewAllgemeineEigenschaften.setText("Allgemeine Konvertierungseigenschaften");
                    {
                        _lbVewKurzBezeichung = new Label(_grpVewAllgemeineEigenschaften, SWT.NONE);
                        _lbVewKurzBezeichung.setToolTipText("Kurzbezeichnung der Konvertierungsvorgabe.");
                        _lbVewKurzBezeichung.setText("Kurzbezeichnung");
                    }
                    {
                        _txtVewKurzBezeichnung = new Text(_grpVewAllgemeineEigenschaften, SWT.BORDER);
                        _txtVewKurzBezeichnung.setToolTipText("Kurzbezeichnung der Konvertierungsvorgabe.");
                        _txtVewKurzBezeichnung.addModifyListener(new ModifyListener() {
                            public void modifyText(final ModifyEvent e) {
                                if (_selektionKonvertierungsVorgabe != null) {
                                    pruefeTextAufAenderungen(_txtVewKurzBezeichnung.getText(), _selektionKonvertierungsVorgabe.getKurzBezeichung());
                                }
                            }
                        });

                        GridData _txtKurzBezeichnungLData = new GridData();

                        _txtKurzBezeichnungLData.horizontalSpan = 2;
                        _txtKurzBezeichnungLData.heightHint     = 13;
                        _txtKurzBezeichnungLData.widthHint      = 138;
                        _txtVewKurzBezeichnung.setLayoutData(_txtKurzBezeichnungLData);

                        // _txtVewKurzBezeichnung.setText("Datenkatalog BW");
                        _txtVewKurzBezeichnung.setSize(138, 13);
                    }
                    {
                        _lbVewLangBezeichung = new Label(_grpVewAllgemeineEigenschaften, SWT.NONE);
                        _lbVewLangBezeichung.setToolTipText("Langbezeichnung der Konvertierungsvorgabe.");
                        _lbVewLangBezeichung.setText("Langbezeichnung");
                    }
                    {
                        _txtVewLangBezeichnung = new Text(_grpVewAllgemeineEigenschaften, SWT.BORDER);
                        _txtVewLangBezeichnung.setToolTipText("Langbezeichnung der Konvertierungsvorgabe.");
                        _txtVewLangBezeichnung.addModifyListener(new ModifyListener() {
                            public void modifyText(final ModifyEvent e) {
                                if (_selektionKonvertierungsVorgabe != null) {
                                    pruefeTextAufAenderungen(_txtVewLangBezeichnung.getText(), _selektionKonvertierungsVorgabe.getLangBezeichung());
                                }
                            }
                        });

                        GridData _txtLangBezeichnungLData = new GridData();

                        _txtLangBezeichnungLData.grabExcessHorizontalSpace = true;
                        _txtLangBezeichnungLData.horizontalAlignment       = GridData.FILL;
                        _txtLangBezeichnungLData.horizontalSpan            = 2;
                        _txtVewLangBezeichnung.setLayoutData(_txtLangBezeichnungLData);

                        // _txtVewLangBezeichnung.setText("Datenkatalog-Zusammenstellung
                        // fr die VRZ 3 in Baden-Wrrtemberg");
                    }
                    {
                        _lbVewKommentar = new Label(_grpVewAllgemeineEigenschaften, SWT.NONE);
                        _lbVewKommentar.setToolTipText("Kommentar zur Konvertierungsvorgabe.");
                        _lbVewKommentar.setText("Kommentar");
                    }
                    {
                        _txtAreaVewKommentar = new Text(_grpVewAllgemeineEigenschaften, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER);
                        _txtAreaVewKommentar.setToolTipText("Kommentar zur Konvertierungsvorgabe.");
                        _txtAreaVewKommentar.addModifyListener(new ModifyListener() {
                            public void modifyText(final ModifyEvent e) {
                                if (_selektionKonvertierungsVorgabe != null) {
                                    pruefeTextAufAenderungen(_txtAreaVewKommentar.getText(), _selektionKonvertierungsVorgabe.getKommentar());
                                }
                            }
                        });

                        GridData _txtAreaKommentarLData = new GridData();

                        _txtAreaKommentarLData.grabExcessHorizontalSpace = true;
                        _txtAreaKommentarLData.horizontalAlignment       = GridData.FILL;
                        _txtAreaKommentarLData.horizontalSpan            = 2;
                        _txtAreaKommentarLData.heightHint                = 54;
                        _txtAreaVewKommentar.setLayoutData(_txtAreaKommentarLData);

                        // _txtAreaVewKommentar.setText("Hier kann ein
                        // beliebieger Kommentar mit <b>HTML-Elementen</b>
                        // stehen.\nAuch mehrere Zeilen sind mglich.\n\nDer
                        // Inhalt wird bei der Ausgabe in einen HTML-Paragraph
                        // <p>...</p> verpackt.");
                        _txtAreaVewKommentar.setSize(656, 54);
                    }
                    {
                        _lbVewZielOrdner = new Label(_grpVewAllgemeineEigenschaften, SWT.NONE);
                        _lbVewZielOrdner.setToolTipText("Ordner, in dem die Konvertierungsergebnisse (HTML-Dateien) gespeichert werden.");
                        _lbVewZielOrdner.setText("Zielordner");
                    }
                    {
                        _txtVewZielOrdner = new Text(_grpVewAllgemeineEigenschaften, SWT.BORDER);
                        _txtVewZielOrdner.setToolTipText("Ordner, in dem die Konvertierungsergebnisse (HTML-Dateien) gespeichert werden.");
                        _txtVewZielOrdner.addModifyListener(new ModifyListener() {
                            public void modifyText(final ModifyEvent e) {
                                if (_selektionKonvertierungsVorgabe != null) {
                                    pruefeTextAufAenderungen(_txtVewZielOrdner.getText(), _selektionKonvertierungsVorgabe.getZielOrdner());
                                }
                            }
                        });

                        GridData _txtZielOrdnerLData = new GridData();

                        _txtZielOrdnerLData.grabExcessHorizontalSpace = true;
                        _txtZielOrdnerLData.horizontalAlignment       = GridData.FILL;
                        _txtZielOrdnerLData.horizontalSpan            = 1;
                        _txtVewZielOrdner.setLayoutData(_txtZielOrdnerLData);

                        // _txtVewZielOrdner.setText("D:/Entwicklung/dav/bsvrz/konfiguration/kv.inovat/DatenkatalogHTML");
                    }
                    {
                        _btnVewZielOrdner = new Button(_grpVewAllgemeineEigenschaften, SWT.PUSH | SWT.CENTER);
                        _btnVewZielOrdner.setToolTipText("Auswahl des Ordners, in dem die Konvertierungsergebnisse (HTML-Dateien) gespeichert werden.");
                        _btnVewZielOrdner.setText("...");
                        _btnVewZielOrdner.addSelectionListener(new SelectionAdapter() {
                            public void widgetSelected(SelectionEvent evt) {

                                // Auswahldialog fr Ordnerauswahl
                                // anzeigen
                                DirectoryDialog directoryDialog = new DirectoryDialog(getShell());

                                directoryDialog.setMessage("Zielverzeichnis fr HTML-Ausgabe festlegen.\n" + "Legt den Ornder fest, in den die Ausgabedateien der Datenkatalogkonvertierung geschrieben werden.");

                                // Pfad auf aktuell ausgewhlten Ordner
                                // vorbelegen
                                directoryDialog.setFilterPath(_txtVewZielOrdner.getText());

                                String ordnerAuswahl;

                                if ((ordnerAuswahl = directoryDialog.open()) != null) {
                                    _txtVewZielOrdner.setText(ordnerAuswahl);
                                }
                            }
                        });
                    }
                }
                _grpVewKonfigurationsBrereiche = new Group(_compVerwaltung, SWT.NONE);

                GridLayout _grpKonfigurationsBrereicheLayout = new GridLayout();

                _grpKonfigurationsBrereicheLayout.makeColumnsEqualWidth = true;
                _grpVewKonfigurationsBrereiche.setLayout(_grpKonfigurationsBrereicheLayout);

                GridData _grpKonfigurationsBrereicheLData = new GridData();

                _grpKonfigurationsBrereicheLData.grabExcessHorizontalSpace = true;
                _grpKonfigurationsBrereicheLData.horizontalAlignment       = GridData.FILL;
                _grpKonfigurationsBrereicheLData.grabExcessVerticalSpace   = true;
                _grpKonfigurationsBrereicheLData.verticalAlignment         = GridData.FILL;
                _grpVewKonfigurationsBrereiche.setLayoutData(_grpKonfigurationsBrereicheLData);
                _grpVewKonfigurationsBrereiche.setText("Konfigurationsbereiche");
                _tabelVewTabelleKonfigurationsBereiche = new TableViewer(_grpVewKonfigurationsBrereiche, SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL | SWT.MULTI | SWT.FULL_SELECTION);

                // _tabelVewTabelleKonfigurationsBereiche.setColumnViewerEditor(null);
                _tabelVewTabelleKonfigurationsBereiche.addSelectionChangedListener(new ISelectionChangedListener() {
                    @Override
                    public void selectionChanged(SelectionChangedEvent event) {

                        // Die Schaltflche "Entfernen ist anwhlbar,
                        // nur wenn mind. ein kb in der Tabelle markiert
                        // ist:
                        if (_tabelVewTabelleKonfigurationsBereiche.getTable().getSelection().length > 0) {
                            _btnVewKonfigurationsBereichEntfernen.setEnabled(true);
                        } else {
                            _btnVewKonfigurationsBereichEntfernen.setEnabled(false);
                        }
                    }
                });
                _tabelVewTabelleKonfigurationsBereiche.setLabelProvider(new TableLabelProvider());
                _tabelVewTabelleKonfigurationsBereiche.setContentProvider(new TableContentProvider());

                final Table table_1 = _tabelVewTabelleKonfigurationsBereiche.getTable();

                table_1.addMouseListener(new MouseAdapter() {
                    public void mouseDoubleClick(final MouseEvent e) {

                        // Suche die Nummer des selektierten Items:
                        KonfigurationsBereich kbSelektiert = (KonfigurationsBereich) ((StructuredSelection) _tabelVewTabelleKonfigurationsBereiche.getSelection()).getFirstElement();

                        if (kbSelektiert != null) {
                            int num = 0;

                            for (KonfigurationsBereich kb : _listeKB) {
                                if (kb.getKb().equals(kbSelektiert.getKb())) {
                                    break;
                                }

                                num++;
                            }

                            auswaehlenKbDatei(num);
                        }
                    }
                });

                final GridData gd_table_1 = new GridData(SWT.FILL, SWT.TOP, true, true);

                gd_table_1.heightHint = 396;
                table_1.setLayoutData(gd_table_1);
                table_1.setHeaderVisible(true);
                table_1.setLinesVisible(true);
                {
                    _compVewKonfigurationsbereicheSchaltflaechen = new Composite(_grpVewKonfigurationsBrereiche, SWT.BORDER);

                    GridLayout _compVewKonfigurationsbereicheSchaltflaechenLayout = new GridLayout();

                    _compVewKonfigurationsbereicheSchaltflaechenLayout.numColumns = 3;
                    _compVewKonfigurationsbereicheSchaltflaechen.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false));
                    _compVewKonfigurationsbereicheSchaltflaechen.setLayout(_compVewKonfigurationsbereicheSchaltflaechenLayout);
                    {
                        _lbVewKonfigurationsbereichHorizontaleFeder = new Label(_compVewKonfigurationsbereicheSchaltflaechen, SWT.NONE);

                        GridData _lbVewKonfigurationsbereichHorizontaleFederLData = new GridData();

                        _lbVewKonfigurationsbereichHorizontaleFederLData.grabExcessHorizontalSpace = true;
                        _lbVewKonfigurationsbereichHorizontaleFederLData.horizontalAlignment       = GridData.FILL;
                        _lbVewKonfigurationsbereichHorizontaleFeder.setLayoutData(_lbVewKonfigurationsbereichHorizontaleFederLData);
                        _lbVewKonfigurationsbereichHorizontaleFeder.setText(" ");
                    }
                    {
                        _btnVewKonfigurationsBereichHinzufuegen = new Button(_compVewKonfigurationsbereicheSchaltflaechen, SWT.PUSH | SWT.CENTER);
                        _btnVewKonfigurationsBereichHinzufuegen.setToolTipText("Hinzufgen der XML-Dateien in die Tabelle 'Konfigurationbereiche'.");

                        GridData _btnVewKonfigurationsBereichHinzufuegenLData = new GridData();

                        _btnVewKonfigurationsBereichHinzufuegenLData.horizontalAlignment = GridData.FILL;
                        _btnVewKonfigurationsBereichHinzufuegen.setLayoutData(_btnVewKonfigurationsBereichHinzufuegenLData);
                        _btnVewKonfigurationsBereichHinzufuegen.setText("Hinzufgen...");
                        _btnVewKonfigurationsBereichHinzufuegen.addSelectionListener(new SelectionAdapter() {
                            public void widgetSelected(SelectionEvent evt) {
                                auswaehlenKbDatei();
                            }
                        });
                    }
                    {
                        _btnVewKonfigurationsBereichEntfernen = new Button(_compVewKonfigurationsbereicheSchaltflaechen, SWT.PUSH | SWT.CENTER);
                        _btnVewKonfigurationsBereichEntfernen.setToolTipText("Entfernen der selektierten XML-Dateien aus der Tabelle 'Konfigurationbereiche'.");
                        _btnVewKonfigurationsBereichEntfernen.setEnabled(false);

                        GridData _btnVewKonfigurationsBereichEntfernenLData = new GridData();

                        _btnVewKonfigurationsBereichEntfernenLData.horizontalAlignment = GridData.FILL;
                        _btnVewKonfigurationsBereichEntfernen.setLayoutData(_btnVewKonfigurationsBereichEntfernenLData);
                        _btnVewKonfigurationsBereichEntfernen.setText("Entfernen");
                        _btnVewKonfigurationsBereichEntfernen.addSelectionListener(new SelectionAdapter() {
                            public void widgetSelected(SelectionEvent evt) {
                                loescheKbAusListe();
                            }
                        });
                    }
                }
                {
                    _compVerwaltungSchaltFlaechen = new Composite(_compVerwaltung, SWT.BORDER);

                    GridLayout _compVerwaltungSchaltflchenLayout = new GridLayout();

                    _compVerwaltungSchaltflchenLayout.numColumns = 3;

                    GridData _compVerwaltungSchaltflchenLData = new GridData();

                    _compVerwaltungSchaltflchenLData.grabExcessHorizontalSpace = true;
                    _compVerwaltungSchaltflchenLData.horizontalAlignment       = GridData.FILL;
                    _compVerwaltungSchaltflchenLData.verticalAlignment         = GridData.END;
                    _compVerwaltungSchaltFlaechen.setLayoutData(_compVerwaltungSchaltflchenLData);
                    _compVerwaltungSchaltFlaechen.setLayout(_compVerwaltungSchaltflchenLayout);
                    _compVerwaltungSchaltFlaechen.setSize(789, -1);
                    {
                        _btnVewHilfe = new Button(_compVerwaltungSchaltFlaechen, SWT.FLAT);
                        _btnVewHilfe.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/hilfe.gif"));
                        _btnVewHilfe.setToolTipText("Hilfe zur Verwaltung der Konvertierungsvorgabe.");
                        _btnVewHilfe.addSelectionListener(new SelectionAdapter() {
                            public void widgetSelected(final SelectionEvent e) {
                                PlatformUI.getWorkbench().getHelpSystem().displayHelp(HILFE_Verwaltung);
                            }
                        });
                    }
                    {
                        _lbVewHorizontaleFeder = new Label(_compVerwaltungSchaltFlaechen, SWT.NONE);

                        GridData _lbHorizontaleFederLData = new GridData();

                        _lbHorizontaleFederLData.grabExcessHorizontalSpace = true;
                        _lbHorizontaleFederLData.horizontalAlignment       = GridData.FILL;
                        _lbVewHorizontaleFeder.setLayoutData(_lbHorizontaleFederLData);
                        _lbVewHorizontaleFeder.setText(" ");
                    }
                    {
                        _compVerwaltungTeilSchaltFlaechen = new Composite(_compVerwaltungSchaltFlaechen, SWT.NONE);

                        GridLayout _compTeilSchaltflaechenLayout = new GridLayout();

                        _compTeilSchaltflaechenLayout.makeColumnsEqualWidth = true;
                        _compTeilSchaltflaechenLayout.numColumns            = 5;
                        _compVerwaltungTeilSchaltFlaechen.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false));
                        _compVerwaltungTeilSchaltFlaechen.setLayout(_compTeilSchaltflaechenLayout);
                        _compVerwaltungTeilSchaltFlaechen.setSize(188, -1);
                        {
                            _btnVewNeu = new Button(_compVerwaltungTeilSchaltFlaechen, SWT.PUSH | SWT.CENTER);
                            _btnVewNeu.setToolTipText("Anlegen einer neuen Konvertierungsvorgabe.");

                            GridData _btnNeuLData = new GridData();

                            _btnNeuLData.grabExcessHorizontalSpace = true;
                            _btnNeuLData.horizontalAlignment       = GridData.FILL;
                            _btnVewNeu.setLayoutData(_btnNeuLData);
                            _btnVewNeu.setText("Neu");
                            _btnVewNeu.addSelectionListener(new SelectionAdapter() {
                                public void widgetSelected(SelectionEvent evt) {
                                    erstelleNeueKonvertierungsVorgaben();
                                }
                            });
                        }
                        {
                            _btnVewKopieren = new Button(_compVerwaltungTeilSchaltFlaechen, SWT.PUSH | SWT.CENTER);
                            _btnVewKopieren.setToolTipText("Kopieren der selektierten Konvertierungsvorgabe in eine neue Konvertierungsvorgabe.");

                            GridData _btnKopierenLData = new GridData();

                            _btnKopierenLData.grabExcessHorizontalSpace = true;
                            _btnKopierenLData.horizontalAlignment       = GridData.FILL;
                            _btnVewKopieren.setLayoutData(_btnKopierenLData);
                            _btnVewKopieren.setText("Kopieren");
                            _btnVewKopieren.addSelectionListener(new SelectionAdapter() {
                                public void widgetSelected(SelectionEvent evt) {
                                    btnKopiereKonvertierungsVorgabe();
                                }
                            });
                        }
                        {
                            _btnVewLoeschen = new Button(_compVerwaltungTeilSchaltFlaechen, SWT.PUSH | SWT.CENTER);
                            _btnVewLoeschen.setToolTipText("Lschen der selektierten Konvertierungsvorgabe.");

                            GridData _btnZuruecksetzenLData = new GridData();

                            _btnZuruecksetzenLData.grabExcessHorizontalSpace = true;
                            _btnZuruecksetzenLData.horizontalAlignment       = GridData.FILL;
                            _btnVewLoeschen.setLayoutData(_btnZuruecksetzenLData);
                            _btnVewLoeschen.setText("Lschen");
                            _btnVewLoeschen.addSelectionListener(new SelectionAdapter() {
                                public void widgetSelected(SelectionEvent evt) {
                                    loescheDatenAusVoreinstellung();
                                }
                            });
                        }
                        {
                            _btnVewZuruecksetzen = new Button(_compVerwaltungTeilSchaltFlaechen, SWT.PUSH | SWT.CENTER);
                            _btnVewZuruecksetzen.setToolTipText("Wiederherstellung des Zustands, der vor der letzten Anwahl von 'bernehmen' bestand.");

                            GridData _btnZuruecknehmenLData = new GridData();

                            _btnZuruecknehmenLData.grabExcessHorizontalSpace = true;
                            _btnZuruecknehmenLData.horizontalAlignment       = GridData.FILL;
                            _btnVewZuruecksetzen.setLayoutData(_btnZuruecknehmenLData);
                            _btnVewZuruecksetzen.setText("Zurcksetzen");
                            _btnVewZuruecksetzen.addSelectionListener(new SelectionAdapter() {
                                public void widgetSelected(SelectionEvent evt) {
                                    _sindGUIDatenGeaendert = false;
                                    setzeDatenGUI();
                                }
                            });
                        }
                        {
                            _btnVewUebernehmen = new Button(_compVerwaltungTeilSchaltFlaechen, SWT.PUSH | SWT.CENTER);
                            _btnVewUebernehmen.setToolTipText("Sicherung der aktuellen Einstellungen.");

                            GridData _btnUebernehmenLData = new GridData();

                            _btnUebernehmenLData.horizontalAlignment       = GridData.FILL;
                            _btnUebernehmenLData.grabExcessHorizontalSpace = true;
                            _btnVewUebernehmen.setLayoutData(_btnUebernehmenLData);
                            _btnVewUebernehmen.setText("bernehmen");
                            _btnVewUebernehmen.addSelectionListener(new SelectionAdapter() {
                                public void widgetSelected(SelectionEvent evt) {
                                    uebernehmeDatenAusVoreinstellung();
                                }
                            });
                        }
                    }
                }
                _tabKonvertieren = new TabItem(_tabPluginDatKat2HTML, SWT.NONE);
                _tabKonvertieren.setToolTipText("Konvertierung des Datenkatalogs.");
                _tabKonvertieren.setText("Konvertierung");
                _compKonvertierung = new Composite(_tabPluginDatKat2HTML, SWT.NONE);
                _tabKonvertieren.setControl(_compKonvertierung);

                GridLayout _compKonvertierungLayout = new GridLayout();

                _compKonvertierungLayout.makeColumnsEqualWidth = true;
                _compKonvertierung.setLayout(_compKonvertierungLayout);
                {
                    _grpKonvAllgemeineEigenschaften = new Group(_compKonvertierung, SWT.NONE);

                    GridLayout _grpAllgemeineEigenschaftenLayout = new GridLayout();

                    _grpAllgemeineEigenschaftenLayout.numColumns = 3;
                    _grpKonvAllgemeineEigenschaften.setLayout(_grpAllgemeineEigenschaftenLayout);
                    _grpKonvAllgemeineEigenschaften.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));
                    _grpKonvAllgemeineEigenschaften.setText("Allgemeine Konvertierungseigenschaften");
                    {
                        _lbKonvKurzBezeichung = new Label(_grpKonvAllgemeineEigenschaften, SWT.NONE);
                        _lbKonvKurzBezeichung.setToolTipText("Kurzbezeichnung der Konvertierungsvorgabe.");
                        _lbKonvKurzBezeichung.setLayoutData(new GridData(98, SWT.DEFAULT));
                        _lbKonvKurzBezeichung.setText("Kurzbezeichnung");
                    }
                    {
                        _txtKonvKurzBezeichnung = new Text(_grpKonvAllgemeineEigenschaften, SWT.BORDER);
                        _txtKonvKurzBezeichnung.setToolTipText("Kurzbezeichnung der Konvertierungsvorgabe.");

                        GridData _txtKurzBezeichnungLData = new GridData(SWT.LEFT, SWT.CENTER, false, false, 2, 1);

                        _txtKurzBezeichnungLData.heightHint = 13;
                        _txtKurzBezeichnungLData.widthHint  = 188;
                        _txtKonvKurzBezeichnung.setLayoutData(_txtKurzBezeichnungLData);
                        _txtKonvKurzBezeichnung.setText("Datenkatalog BW");
                        _txtKonvKurzBezeichnung.setSize(138, 13);
                        _txtKonvKurzBezeichnung.setEditable(false);
                    }
                    {
                        _lbKonvLangBezeichung = new Label(_grpKonvAllgemeineEigenschaften, SWT.NONE);
                        _lbKonvLangBezeichung.setToolTipText("Langbezeichnung der Konvertierungsvorgabe.");
                        _lbKonvLangBezeichung.setText("Langbezeichnung");
                    }
                    {
                        _txtKonvLangBezeichnung = new Text(_grpKonvAllgemeineEigenschaften, SWT.BORDER);
                        _txtKonvLangBezeichnung.setToolTipText("Langbezeichnung der Konvertierungsvorgabe.");

                        GridData _txtLangBezeichnungLData = new GridData();

                        _txtLangBezeichnungLData.grabExcessHorizontalSpace = true;
                        _txtLangBezeichnungLData.horizontalAlignment       = GridData.FILL;
                        _txtLangBezeichnungLData.horizontalSpan            = 2;
                        _txtKonvLangBezeichnung.setLayoutData(_txtLangBezeichnungLData);
                        _txtKonvLangBezeichnung.setText("Datenkatalog-Zusammenstellung fr die VRZ 3 in Baden-Wrrtemberg");
                        _txtKonvLangBezeichnung.setEditable(false);
                    }
                    {
                        _lbKonvKommentar = new Label(_grpKonvAllgemeineEigenschaften, SWT.NONE);
                        _lbKonvKommentar.setToolTipText("Kommentar zur Konvertierungsvorgabe.");
                        _lbKonvKommentar.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, false));
                        _lbKonvKommentar.setText("Kommentar");
                    }
                    {
                        _txtAreaKonvKommentar = new Text(_grpKonvAllgemeineEigenschaften, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER);
                        _txtAreaKonvKommentar.setToolTipText("Kommentar zur Konvertierungsvorgabe.");

                        GridData _txtAreaKommentarLData = new GridData(SWT.FILL, SWT.FILL, true, false, 2, 1);

                        _txtAreaKommentarLData.heightHint = 54;
                        _txtAreaKonvKommentar.setLayoutData(_txtAreaKommentarLData);
                        _txtAreaKonvKommentar.setText("Hier kann ein beliebieger Kommentar mit stehen.");
                        _txtAreaKonvKommentar.setSize(656, 54);
                        _txtAreaKonvKommentar.setEditable(false);
                    }
                    {
                        _lbKonvZielOrdner = new Label(_grpKonvAllgemeineEigenschaften, SWT.NONE);
                        _lbKonvZielOrdner.setToolTipText("Ordner, in dem das Konvertierungsergebnis gespeichert wird.");
                        _lbKonvZielOrdner.setText("Zielordner");
                    }
                    {
                        _txtKonvZielOrdner = new Text(_grpKonvAllgemeineEigenschaften, SWT.BORDER);
                        _txtKonvZielOrdner.setToolTipText("Ordner, in dem das Konvertierungsergebnis gespeichert wird.");

                        GridData _txtZielOrdnerLData = new GridData();

                        _txtZielOrdnerLData.grabExcessHorizontalSpace = true;
                        _txtZielOrdnerLData.horizontalAlignment       = GridData.FILL;
                        _txtZielOrdnerLData.horizontalSpan            = 2;
                        _txtKonvZielOrdner.setLayoutData(_txtZielOrdnerLData);
                        _txtKonvZielOrdner.setText("D:/Entwicklung/dav/bsvrz/konfiguration/kv.inovat/DatenkatalogHTML");
                        _txtKonvZielOrdner.setEditable(false);
                    }
                }
                {
                    _grpKonvKonfigurationsBrereiche = new Group(_compKonvertierung, SWT.NONE);

                    GridLayout gridLayout = new GridLayout();

                    gridLayout.makeColumnsEqualWidth = true;
                    _grpKonvKonfigurationsBrereiche.setLayout(gridLayout);

                    GridData gd_grpKonvKonfigurationsBrereiche = new GridData();

                    gd_grpKonvKonfigurationsBrereiche.grabExcessHorizontalSpace = true;
                    gd_grpKonvKonfigurationsBrereiche.horizontalAlignment       = GridData.FILL;
                    gd_grpKonvKonfigurationsBrereiche.grabExcessVerticalSpace   = true;
                    gd_grpKonvKonfigurationsBrereiche.verticalAlignment         = GridData.FILL;
                    _grpKonvKonfigurationsBrereiche.setLayoutData(gd_grpKonvKonfigurationsBrereiche);
                    _grpKonvKonfigurationsBrereiche.setText("Konfigurationsbereiche");
                    _tableViewerKonvKB = new TableViewer(_grpKonvKonfigurationsBrereiche, SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL);
                    _tableViewerKonvKB.setLabelProvider(new TableLabelProvider());
                    _tableViewerKonvKB.setContentProvider(new TableContentProvider());

                    final Table    table    = _tableViewerKonvKB.getTable();
                    final GridData gd_table = new GridData(SWT.FILL, SWT.TOP, true, true);

                    gd_table.heightHint = 396;
                    table.setLayoutData(gd_table);
                    table.setHeaderVisible(true);
                    table.setLinesVisible(true);

                    for (int i = 0; i < _arSpalten.length - 1; i++) {
                        final TableColumn newColumnTableColumn = new TableColumn(table, SWT.NONE);

                        newColumnTableColumn.setWidth(_arSpaltenGroesse[i]);
                        newColumnTableColumn.setText(_arSpalten[i]);
                    }
                }

                final Group grpLegende = new Group(_compKonvertierung, SWT.NONE);

                grpLegende.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
                grpLegende.setText("Legende");

                final GridLayout gridLayout = new GridLayout();

                gridLayout.numColumns = 4;
                grpLegende.setLayout(gridLayout);

                final Label lblIconKeineTransformation = new Label(grpLegende, SWT.NONE);

                lblIconKeineTransformation.setImage(_imageKeineTransformation);

                final Label lblKeineTransformation = new Label(grpLegende, SWT.NONE);

                lblKeineTransformation.setText("Keine Transformation (entsprechend Verwaltungsvorgabe)");

                final Label lblIconOk = new Label(grpLegende, SWT.NONE);

                lblIconOk.setImage(_imageOk);

                final Label lblOk = new Label(grpLegende, SWT.NONE);

                lblOk.setText("Transformation ok");

                final Label lblIconNochOffen = new Label(grpLegende, SWT.NONE);

                lblIconNochOffen.setImage(_imageNochOffen);

                final Label lblNochOffen = new Label(grpLegende, SWT.NONE);

                lblNochOffen.setText("Transformation wird noch durchgefhrt (entsprechend Verwaltungsvorgabe)     ");

                final Label lblIconWarnung = new Label(grpLegende, SWT.NONE);

                lblIconWarnung.setImage(_imageWarnung);

                final Label lblWarnung = new Label(grpLegende, SWT.NONE);

                lblWarnung.setText("Transformation mit Warnungen (siehe Ausgabe im View 'Error Log')");

                final Label lblIconInBearbeitung = new Label(grpLegende, SWT.NONE);

                lblIconInBearbeitung.setImage(_imageInBearbeitung);

                final Label lblInBearbeitung = new Label(grpLegende, SWT.NONE);

                lblInBearbeitung.setText("Eintrag wird gerade bearbeitet");

                final Label lblIconFehler = new Label(grpLegende, SWT.NONE);

                lblIconFehler.setImage(_imageFehler);

                final Label lblFehler = new Label(grpLegende, SWT.NONE);

                lblFehler.setText("Transformation mit Fehlern (siehe Ausgabe im View 'Error Log')");
                _grpKonvFortschrittsAnzeige = new Group(_compKonvertierung, SWT.NONE);

                GridLayout _grpFortschrittsAnzeigeLayout = new GridLayout();

                _grpFortschrittsAnzeigeLayout.numColumns = 2;
                _grpKonvFortschrittsAnzeige.setLayout(_grpFortschrittsAnzeigeLayout);

                GridData _grpFortschrittsAnzeigeLData = new GridData();

                _grpFortschrittsAnzeigeLData.grabExcessHorizontalSpace = true;
                _grpFortschrittsAnzeigeLData.horizontalAlignment       = GridData.FILL;
                _grpKonvFortschrittsAnzeige.setLayoutData(_grpFortschrittsAnzeigeLData);
                _grpKonvFortschrittsAnzeige.setText("Fortschrittsanzeige");
                {
                    _lbKonvFortschrittKonfigurationsBereich = new Label(_grpKonvFortschrittsAnzeige, SWT.NONE);
                    _lbKonvFortschrittKonfigurationsBereich.setToolTipText("Fortschritt der aktuell laufenden Konvertierung fr die Konvertierung des aktuellen Konfigurationsbereichs.");
                    _lbKonvFortschrittKonfigurationsBereich.setText("Fortschritt Konfigurationsbereich");
                }
                {
                    _progressBarKonvKonfigurationsBereich = new ProgressBar(_grpKonvFortschrittsAnzeige, SWT.NONE);
                    _progressBarKonvKonfigurationsBereich.setToolTipText("Fortschritt der aktuell laufenden Konvertierung fr die Konvertierung des aktuellen Konfigurationsbereichs.");

                    GridData _progressBarKonfigurationsBereichLData = new GridData();

                    _progressBarKonfigurationsBereichLData.grabExcessHorizontalSpace = true;
                    _progressBarKonfigurationsBereichLData.horizontalAlignment       = GridData.FILL;
                    _progressBarKonvKonfigurationsBereich.setLayoutData(_progressBarKonfigurationsBereichLData);
                }
                {
                    _lbKonvFortschrittGesamt = new Label(_grpKonvFortschrittsAnzeige, SWT.NONE);
                    _lbKonvFortschrittGesamt.setToolTipText("Fortschritt der aktuell laufenden Konvertierung fr die gesammte Konvertierung.");
                    _lbKonvFortschrittGesamt.setText("Fortschritt Gesamt");
                }
                _progressBarKonvGesamt = new ProgressBar(_grpKonvFortschrittsAnzeige, SWT.NONE);
                _progressBarKonvGesamt.setToolTipText("Fortschritt der aktuell laufenden Konvertierung fr die gesammte Konvertierung.");

                GridData _progressBarGesamtLData1 = new GridData();

                _progressBarGesamtLData1.grabExcessHorizontalSpace = true;
                _progressBarGesamtLData1.horizontalAlignment       = GridData.FILL;
                _progressBarKonvGesamt.setLayoutData(_progressBarGesamtLData1);
                {
                    _compKonvertierungSchaltFlaechen = new Composite(_compKonvertierung, SWT.BORDER);

                    GridLayout _compKonvertierungSchaltflchenLayout = new GridLayout();

                    _compKonvertierungSchaltflchenLayout.numColumns = 3;

                    GridData _compKonvertierungSchaltflchenLData = new GridData();

                    _compKonvertierungSchaltflchenLData.grabExcessHorizontalSpace = true;
                    _compKonvertierungSchaltflchenLData.horizontalAlignment       = GridData.FILL;
                    _compKonvertierungSchaltflchenLData.verticalAlignment         = GridData.END;
                    _compKonvertierungSchaltFlaechen.setLayoutData(_compKonvertierungSchaltflchenLData);
                    _compKonvertierungSchaltFlaechen.setLayout(_compKonvertierungSchaltflchenLayout);
                    _compKonvertierungSchaltFlaechen.setSize(789, -1);
                    {
                        _btnKonvHilfe = new Button(_compKonvertierungSchaltFlaechen, SWT.FLAT);
                        _btnKonvHilfe.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/hilfe.gif"));
                        _btnKonvHilfe.setToolTipText("Hilfe zur Konvertierung.");
                        _btnKonvHilfe.addSelectionListener(new SelectionAdapter() {
                            public void widgetSelected(final SelectionEvent e) {
                                PlatformUI.getWorkbench().getHelpSystem().displayHelp(HILFE_Konvertierung);
                            }
                        });
                    }
                    {
                        _lbKonvHorizontaleFeder = new Label(_compKonvertierungSchaltFlaechen, SWT.NONE);

                        GridData _lbHorizontaleFederLData = new GridData();

                        _lbHorizontaleFederLData.grabExcessHorizontalSpace = true;
                        _lbHorizontaleFederLData.horizontalAlignment       = GridData.FILL;
                        _lbKonvHorizontaleFeder.setLayoutData(_lbHorizontaleFederLData);
                        _lbKonvHorizontaleFeder.setText(" ");
                    }
                    {
                        _compKonvertierungTeilSchaltFlaechen = new Composite(_compKonvertierungSchaltFlaechen, SWT.NONE);

                        GridLayout _compTeilSchaltflaechenLayout = new GridLayout();

                        _compTeilSchaltflaechenLayout.makeColumnsEqualWidth = true;
                        _compTeilSchaltflaechenLayout.numColumns            = 2;

                        GridData _compTeilSchaltFlaechenLData = new GridData();

                        _compTeilSchaltFlaechenLData.widthHint           = 188;
                        _compTeilSchaltFlaechenLData.horizontalAlignment = GridData.END;
                        _compKonvertierungTeilSchaltFlaechen.setLayoutData(_compTeilSchaltFlaechenLData);
                        _compKonvertierungTeilSchaltFlaechen.setLayout(_compTeilSchaltflaechenLayout);
                        _compKonvertierungTeilSchaltFlaechen.setSize(188, -1);
                        {
                            _btnKonvKonvertierung = new Button(_compKonvertierungTeilSchaltFlaechen, SWT.PUSH | SWT.CENTER);
                            _btnKonvKonvertierung.setToolTipText("Konvertierung der in der Tabelle angegebenen Dateien.");
                            _btnKonvKonvertierung.addSelectionListener(new SelectionAdapter() {
                                public void widgetSelected(final SelectionEvent e) {
                                    konvertieren();
                                }
                            });

                            GridData _btnKonvertierungLData = new GridData();

                            _btnKonvertierungLData.grabExcessHorizontalSpace = true;
                            _btnKonvertierungLData.horizontalAlignment       = GridData.FILL;
                            _btnKonvKonvertierung.setLayoutData(_btnKonvertierungLData);
                            _btnKonvKonvertierung.setText("Konvertierung");
                        }
                        {
                            _btnKonvAbbruch = new Button(_compKonvertierungTeilSchaltFlaechen, SWT.PUSH | SWT.CENTER);
                            _btnKonvAbbruch.setToolTipText("Abbruch der aktuell laufenden Konvertierung.");
                            _btnKonvAbbruch.addSelectionListener(new SelectionAdapter() {
                                public void widgetSelected(final SelectionEvent e) {
                                    btnAbbruchSelektiert();
                                }
                            });

                            GridData _btnAbbruchLData = new GridData();

                            _btnAbbruchLData.horizontalAlignment       = GridData.FILL;
                            _btnAbbruchLData.grabExcessHorizontalSpace = true;
                            _btnKonvAbbruch.setLayoutData(_btnAbbruchLData);
                            _btnKonvAbbruch.setText("Abbruch");
                            _btnKonvAbbruch.setEnabled(false);
                        }
                    }
                }

                // _tabelVewTabelleKonfigurationsBereiche.getControl().setLayoutData(_tabelVewTabelleKonfigurationsBereicheLData);
                // _tabelVewTabelleKonfigurationsBereiche.getTable().setBounds(67,218,
                // 60, 30);
                for (int i = 0; i < _arSpalten.length; i++) {
                    final TableColumn newColumnTableColumn = new TableColumn(table_1, SWT.NONE);

                    newColumnTableColumn.setWidth(_arSpaltenGroesse[i]);
                    newColumnTableColumn.setText(_arSpalten[i]);
                }

                {
                    _tabAnsicht = new TabItem(_tabPluginDatKat2HTML, SWT.NONE);
                    _tabAnsicht.setToolTipText("Ansicht der konvertierten Datei im HTML-Browser.");
                    _tabAnsicht.setText("Ansicht");
                    {
                        _compAnsicht = new Composite(_tabPluginDatKat2HTML, SWT.NONE);

                        GridLayout _compAnsichtLayout = new GridLayout();

                        _compAnsichtLayout.numColumns = 2;
                        _compAnsicht.setLayout(_compAnsichtLayout);
                        _tabAnsicht.setControl(_compAnsicht);
                        {
                            _tbarAnsichtNavigation = new ToolBar(_compAnsicht, SWT.EMBEDDED);
                            {
                                _titemAnsichtZurueck = new ToolItem(_tbarAnsichtNavigation, SWT.NONE);
                                _titemAnsichtZurueck.setToolTipText("Rcksprung auf die letzte angesprungene Stelle im Dokument.");
                                _titemAnsichtZurueck.setText("Zurck");
                                _titemAnsichtZurueck.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/Pfeil_W.gif"));
                                _titemAnsichtZurueck.addSelectionListener(this);
                            }
                            {
                                _titemAnsichtVorwaerts = new ToolItem(_tbarAnsichtNavigation, SWT.NONE);
                                _titemAnsichtVorwaerts.setToolTipText("Sprung auf die nchste bereits vorher besuchte Stelle im Dokument.");
                                _titemAnsichtVorwaerts.setText("Vorwrts");
                                _titemAnsichtVorwaerts.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/Pfeil_O.gif"));
                                _titemAnsichtVorwaerts.addSelectionListener(this);
                            }
                            {
                                _titemAnsichtNeuLaden = new ToolItem(_tbarAnsichtNavigation, SWT.NONE);
                                _titemAnsichtNeuLaden.setToolTipText("Dokument wird erneut geladen (aktualisiert).");
                                _titemAnsichtNeuLaden.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/Rueckgaengig.gif"));
                                _titemAnsichtNeuLaden.setText("Neu Laden");
                                _titemAnsichtNeuLaden.addSelectionListener(this);
                            }
                            {
                                _titemAnsichtStopp = new ToolItem(_tbarAnsichtNavigation, SWT.NONE);
                                _titemAnsichtStopp.setToolTipText("Stoppt den Ladervorgang des Dokuments.");
                                _titemAnsichtStopp.setText("Stopp");
                                _titemAnsichtStopp.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/Stopp.gif"));
                                _titemAnsichtStopp.addSelectionListener(this);
                            }
                            {
                                _titemAnsichtOK = new ToolItem(_tbarAnsichtNavigation, SWT.NONE);
                                _titemAnsichtOK.setToolTipText("ffnet das Dokument mit der in der Adresszeile eingetragenen Adresse.");
                                _titemAnsichtOK.setText("OK");
                                _titemAnsichtOK.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/Start.gif"));
                                _titemAnsichtOK.addSelectionListener(this);
                            }
                        }
                        {
                            _txtAnsichtURL = new Text(_compAnsicht, SWT.BORDER);
                            _txtAnsichtURL.setToolTipText("Adresse des zu ladenden Dokuments.");

                            GridData _txtURLLData = new GridData();

                            _txtURLLData.grabExcessHorizontalSpace = true;
                            _txtURLLData.horizontalAlignment       = GridData.FILL;
                            _txtAnsichtURL.setLayoutData(_txtURLLData);

                            // _txtAnsichtURL.setText("file:///D:/Projekte%20(HCK)/nw.boschung.06.01-KEx-Boschung/Produkte/Technische%20Dokumentation/CD/Anlagen/Anlage%2007%20-%20Software%20KEx-Boschung-IS/KExBoschungIS/datenkatalogHTML/Datenkatalog.html");
                            _txtAnsichtURL.addKeyListener(this);
                            _txtAnsichtURL.addFocusListener(this);
                        }
                        {
                            GridData _browserLData = new GridData();

                            _browserLData.verticalAlignment         = GridData.FILL;
                            _browserLData.horizontalAlignment       = GridData.FILL;
                            _browserLData.grabExcessHorizontalSpace = true;
                            _browserLData.grabExcessVerticalSpace   = true;
                            _browserLData.horizontalSpan            = 2;

                            try {
                                _browser = new Browser(_compAnsicht, SWT.BORDER);
                            }
                            catch (Error e1) {
                                Log.zeigeInterneMeldung(Activator.PLUGIN_ID, e1);

                                try {
                                    _browser = new Browser(_compAnsicht, SWT.MOZILLA | SWT.BORDER);
                                }
                                catch (Error e2) {
                                    Log.zeigeInterneMeldung(Activator.PLUGIN_ID, e2);
                                }
                            }

                            FillLayout _browserLayout = new FillLayout(org.eclipse.swt.SWT.HORIZONTAL);

                            _browser.setLayout(_browserLayout);
                            _browser.setLayoutData(_browserLData);
                            _browser.setUrl(_txtAnsichtURL.getText());
                        }
                    }
                }

                GridData _tabPluginDatKat2HTMLLData = new GridData();

                _tabPluginDatKat2HTMLLData.grabExcessHorizontalSpace = true;
                _tabPluginDatKat2HTMLLData.grabExcessVerticalSpace   = true;
                _tabPluginDatKat2HTMLLData.horizontalAlignment       = GridData.FILL;
                _tabPluginDatKat2HTMLLData.verticalAlignment         = GridData.FILL;
                _tabPluginDatKat2HTML.setLayoutData(_tabPluginDatKat2HTMLLData);
                _tabPluginDatKat2HTML.setSelection(_tabVerwalten);
                _sashFormAuswahlUndDialogBereich.setWeights(new int[] { 235, 699 });
            }

            this.setSize(1024, 768);
            this.layout();
        }
        catch (Exception e) {
            Log.zeigeInterneMeldung(Activator.PLUGIN_ID, e);
        }

        // Beim Drucken auf F1 wird die Hilfe angezeigt:
        PlatformUI.getWorkbench().getHelpSystem().setHelp(this, HILFE_DatKat);
        initialisiereDaten();
    }

    /**
     * Inizialisiere die GUIDaten.
     */
    private void initialisiereDaten() {

        // Liste der bereits definierten Konverteriungsvorgaben vorbesetzen.
        _listAuswahl.setItems(_konvertierungsVorgaben.getSortiereListeDerKonvertierungsVorgabenKurzBezeichungen());

        // Es gibt die Vorgaben in der Navigation:
        if (_listAuswahl.getItems().length > 0) {

            // Reiter auf "Konvertieren" setzen und ersten Eintrag auswhlen.
            _tabPluginDatKat2HTML.setSelection(_tabKonvertieren);
            _listAuswahl.setFocus();
            _listAuswahl.select(0);

            // neue Selektion in _listAuswahl:
            _selektionAuswahlListe = _listAuswahl.getSelection()[0];
            setzeDatenGUI();
        }

        // Die Liste vonVorgaben ist leer:
        else {

            // Reiter auf "Verwalten" setzen:
            _tabPluginDatKat2HTML.setSelection(_tabVerwalten);

            // Alle GUIDaten auf "" initialisieren:
            _txtVewKurzBezeichnung.setText("");
            _txtVewLangBezeichnung.setText("");
            _txtAreaVewKommentar.setText("");
            _txtVewZielOrdner.setText("");
            _sindGUIDatenGeaendert = false;

            // Alle Buttons, auer Neu und Hilfe nicht aktiv:
            _btnVewZielOrdner.setEnabled(false);
            _btnVewKonfigurationsBereichHinzufuegen.setEnabled(false);
            _btnVewKopieren.setEnabled(false);
            _btnVewLoeschen.setEnabled(false);
            _btnVewZuruecksetzen.setEnabled(false);
            _btnVewUebernehmen.setEnabled(false);
            _btnVewNeu.setEnabled(true);
            _listeKB.clear();
            setzeDatenVerwaltungTabelle();
            setzeDatenKonvertierungTabelle();
        }
    }

    /**
     * Initialisiere die Liste alle KonfigurationsBereichen fr die selektierte
     * KonvertierungsVorgabe.
     */
    private void initialisiereListeKB() {
        _listeKB = new ArrayList<KonfigurationsBereich>();

        // Erstelle die Copy von jedem kb.
        // (die richtige kb werden beim bernehmen gespeichert).
        for (KonfigurationsBereich kb : _selektionKonvertierungsVorgabe.getMapKonfigurationsBereich().values()) {
            _listeKB.add(new KonfigurationsBereich(kb.isModell(), kb.isObjekt(), kb.getKv(), kb.getKb(), kb.getPfad()));
        }
    }

    //~ GET METHODEN ==========================================================

    /**
     * Definiert, ob der KonfiguratioBereich in der Liste liegt.
     *
     * @param kbPid
     * @return
     */
    private boolean isKBinListe(String kbPid) {
        boolean result = false;

        for (KonfigurationsBereich kb : _listeKB) {
            if (kb.getKb().equals(kbPid)) {
                result = true;

                break;
            }
        }

        return result;
    }

    /**
     * Prft, ob im Modellbereich berhaupt Definitionseintrge vorliegen.
     *
     * @param kbDatei
     *            Der Konfigurationsbereich.
     * @return <code>true</code>, wenn Definitionen vorliegen, sonst
     *         <code>false</code>.
     */
    boolean isModelleVorhanden(BSVRZXML kbDatei) {
        return (kbDatei.getMapAspektDefinition().size() > 0) || (kbDatei.getMapAttributauswahlDefinition().size() > 0) || (kbDatei.getMapAttributDefinition().size() > 0) || (kbDatei.getMapAttributgruppenDefinition().size() > 0) || (kbDatei.getMapTypDefinition().size() > 0) || (kbDatei.getMapAttributlistenDefinition().size() > 0) || (kbDatei.getMapMengenDefinition().size() > 0)
        ;
    }

    /**
     * Prft, ob im ObjektBereich berhaupt Objektdefinitionen vorliegen.
     *
     * @param kbDatei
     *            Der Konfigurationsbereich.
     * @return <code>true</code>, wenn Definitionen vorliegen, sonst
     *         <code>false</code>.
     */
    boolean isObjekteVorhanden(BSVRZXML kbDatei) {
        return (kbDatei.getMapKonfigurationsObjekt().size() > 0)
        ;
    }

    //~ METHODEN ==============================================================

    // --------------------- Interface KeyListener ---------------------
    public void keyPressed(KeyEvent event) {
        if (event.keyCode == 13) {
            _browser.setUrl(_txtAnsichtURL.getText());
        }
    }

    public void keyReleased(KeyEvent event) {}

    /**
     * Konvertiere Datei. Der Hauptteil der Methode wird in einem anderem
     * nicht-GUI Thread ausgefhrt, damit das GUI nicht gesperrt wird (um
     * 'Abbruch' drcken zu knnen).
     */
    private void konvertieren() {
        _istKonvertierungsProzessLaeuft = true;
        _btnKonvKonvertierung.setEnabled(false);
        _listAuswahl.setEnabled(false);
        _listAuswahl.update();

        // Setzte die GUIKomponente auf StartPosition:
        _progressBarKonvGesamt.setSelection(0);
        _progressBarKonvKonfigurationsBereich.setSelection(0);
        setzeDatenKonvertierungTabelle();
        aktualisiereGUIKonvertierung();
        _progressBarKonvGesamt.setSelection(1);

        // Falls Zielordner existiert, erstelle HTMLDatei:
        if (ueberpruefeZielordner(_selektionKonvertierungsVorgabe.getZielOrdner())) {

            // Die Daten Pfad, KB und KV berprfen
            // (kann sein, dass manche Dateien nicht mehr existieren oder
            // gendert werden).
            // Falls so ist, erzeugen neu die Tabelle.
            ueberpruefeKBMap(_selektionKonvertierungsVorgabe);

            // zuerst erstelle die Liste von KB ohne Fehler:
            final java.util.List<KonfigurationsBereich> listeKBohneFehler = new ArrayList<KonfigurationsBereich>();

            for (KonfigurationsBereich kb : _listeKB) {
                if (!kb.getKb().equals(_ungueltig)) {
                    listeKBohneFehler.add(kb);
                }
            }

            // Falls die Liste der zu bearbeiteten Datei nicht leer ist,
            // konvertiere die:
            if (listeKBohneFehler.size() > 0) {

                // Anderes Thread:
                Thread thread = new Thread(new Runnable() {
                    @Override
                    public void run() {
                        _ausgabe = new DateiAusgabe(listeKBohneFehler, _selektionKonvertierungsVorgabe);
                        _ausgabe.setAbbruch(false);
                        getDisplay().syncExec(new Runnable() {
                            @Override
                            public void run() {
                                _btnKonvAbbruch.setEnabled(true);
                            }
                        });

                        try {
                            _ausgabe.ausgebenFormatierteDatei();
                        }
                        catch (Throwable e) {
                            Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Es ist ein Fehler aufgetreten!", e));
                        }

                        // Drucke die Tabelle normal:
                        hervorhebenZeile(-1);
                        getDisplay().syncExec(new Runnable() {
                            @Override
                            public void run() {
                                _istKonvertierungsProzessLaeuft = false;
                                _btnKonvKonvertierung.setEnabled(true);
                                _btnKonvAbbruch.setEnabled(false);
                                _listAuswahl.setEnabled(true);
                                _listAuswahl.update();

                                // Setzte die StartDatei:
                                _selektionKonvertierungsVorgabe.setStartDatei(_ausgabe.getStartDatei());
                                _konvertierungsVorgaben.speichereKonvertierungsVorgaben();

                                if (_ausgabe.isAbbruch()) {
                                    _progressBarKonvGesamt.setSelection(0);
                                    _progressBarKonvKonfigurationsBereich.setSelection(0);
                                    _tableViewerKonvKB.getTable().deselectAll();
                                    aktualisiereGUIKonvertierung();
                                }
                            }
                        });
                    }
                });

                thread.start();
            } else {
                _istKonvertierungsProzessLaeuft = false;
                _progressBarKonvGesamt.setSelection(0);
                _listAuswahl.setEnabled(true);
                _listAuswahl.update();
                setzeDatenKonvertierung();
                aktualisiereGUIKonvertierung();
            }
        } else {
            _istKonvertierungsProzessLaeuft = false;
            _progressBarKonvGesamt.setSelection(0);
            _listAuswahl.setEnabled(true);
            _listAuswahl.update();
            setzeDatenKonvertierung();
            aktualisiereGUIKonvertierung();
            MessageDialog.openError(this.getShell(), "Fehler beim Anlegen des Zielornders", "Der Zielordner kann nicht erstellt werden!");
        }
    }

    // --------------------- Interface IKonvertierungsProzessAenderungen ---------------------
    @Override
    public void konvertierungsProzessGeaendert(KonvertierungsProzessAenderungen kpAenderungen) {

        // Die Methode wird ber Display.syncExec ausgefhrt,
        // da die von nicht GUI-Thread aufgerufen wird
        // und man einen Zugriff auf GUI braucht.
        final KonvertierungsProzessAenderungen kpA = kpAenderungen;

        getDisplay().syncExec(new Runnable() {
            @Override
            public void run() {

                // ProgressBar ndern:
                if (kpA.getProzentKb() != null) {
                    _progressBarKonvKonfigurationsBereich.setSelection(kpA.getProzentKb());
                }

                if (kpA.getProzentAll() != null) {
                    _progressBarKonvGesamt.setSelection(kpA.getProzentAll());
                }

                // Image ndern:
                String kbPid = kpA.getKbPid();
                Table  table = _tableViewerKonvKB.getTable();

                if (kbPid != null) {
                    Image imageModell = ermittleImage(kpA.getTypModell());
                    Image imageObjekt = ermittleImage(kpA.getTypObjekt());
                    int   i           = 0;

                    for (TableItem item : table.getItems()) {
                        if (item.getText(3).equals(kbPid)) {
                            if (imageModell != null) {
                                item.setImage(0, imageModell);
                            }

                            if (imageObjekt != null) {
                                item.setImage(1, imageObjekt);
                            }

                            if ((kpA.getTypModell() == MeldungsTyp.inBearbeitung) || (kpA.getTypObjekt() == MeldungsTyp.inBearbeitung)) {
                                hervorhebenZeile(i);

                                // mitscrollen:
                                table.setSelection(i);
                                table.showSelection();
                            }
                        }

                        i++;
                    }
                }

                aktualisiereGUIKonvertierung();
            }
        });
    }

    /**
     * Erstelle die KonvertierungsVorgabe mit den Wertren aus GUI.
     *
     * @return
     */
    private KonvertierungsVorgabe leseDatenVerwaltung() {
        KonvertierungsVorgabe konvertierungsVorgabe = new KonvertierungsVorgabe();

        konvertierungsVorgabe.setKurzBezeichung(_txtVewKurzBezeichnung.getText());
        konvertierungsVorgabe.setLangBezeichung(_txtVewLangBezeichnung.getText());
        konvertierungsVorgabe.setKommentar(_txtAreaVewKommentar.getText());
        konvertierungsVorgabe.setZielOrdner(_txtVewZielOrdner.getText());

        // Tabelle:
        leseDatenVerwaltungTabelle(konvertierungsVorgabe);

        return konvertierungsVorgabe;
    }

    /**
     * Speichere die Liste von KB im Map von KB aus der konvertierungsVorgabe.
     *
     * @param konvertierungsVorgabe
     */
    private void leseDatenVerwaltungTabelle(KonvertierungsVorgabe konvertierungsVorgabe) {
        konvertierungsVorgabe.getMapKonfigurationsBereich().clear();

        for (KonfigurationsBereich kb : _listeKB) {
            konvertierungsVorgabe.getMapKonfigurationsBereich().put(kb.getKb(), kb);
        }
    }

    /**
     * Lsche die selektierte KonvertierungsVorgabe und whle die erste aus der
     * Liste.
     */
    private void loescheDatenAusVoreinstellung() {
        if (MessageDialog.openQuestion(_shell, "Lschen besttigen", "Soll die Konvertierungsvorgabe " + _selektionAuswahlListe + " gelscht werden?")) {

            // 1. Eintrag lschen und Map speichern
            // 2. Initialisiere Daten im GUI
            // zu 1. Eintrag lschen und Map speichern
            _konvertierungsVorgaben.getMapKonvertierungsVorgaben().remove(_selektionAuswahlListe);
            _konvertierungsVorgaben.speichereKonvertierungsVorgaben();

            // zu 2. Initialisiere Daten im GUI:
            _sindGUIDatenGeaendert = false;
            initialisiereDaten();
            _tabPluginDatKat2HTML.setSelection(_tabVerwalten);
        }
    }

    /**
     * Lsche die selektierte Tabelleeintrge.
     */
    private void loescheKbAusListe() {
        int[] arrIndex = _tabelVewTabelleKonfigurationsBereiche.getTable().getSelectionIndices();

        if (arrIndex.length > 0) {
            Arrays.sort(arrIndex);

            java.util.List<KonfigurationsBereich> listeKB = new ArrayList<KonfigurationsBereich>();
            int                                   i       = 0;

            for (KonfigurationsBereich kb : _listeKB) {
                if (Arrays.binarySearch(arrIndex, i) < 0) {
                    listeKB.add(kb);
                }

                i++;
            }

            _listeKB               = listeKB;
            _sindGUIDatenGeaendert = true;
            setzeEnabledFrGUI();
            setzeDatenVerwaltungTabelle();
        }
    }

    // ------------------------------------------------------------------------
    // MAIN METHODE
    // ------------------------------------------------------------------------

    /**
     * Auto-generated main method to display this
     * org.eclipse.swt.widgets.Composite inside a new Shell.
     */
    public static void main(String[] args) {
        showGUI();
    }

    // --------------------- Interface MouseListener ---------------------
    public void mouseDoubleClick(MouseEvent event) {

        // Bearbeitet den Doppelklick auf das inovat-Logo.
        // - Ruft den Reiter "Anzeige" auf.
        // - Setzt die URL auf die Homepage von inovat und zeigt die Homepage
        // an.
        if (event.getSource().equals(_lbLogoInovat)) {
            _tabPluginDatKat2HTML.setSelection(_tabAnsicht);

            // URL erst setzen, damit diese auch in der Adresszeile angezeigt
            // wird...
            _txtAnsichtURL.setText("http://www.inovat.de");

            // ... dann erst die Seite aufrufen.
            _browser.setUrl(_txtAnsichtURL.getText());
        }

        // Bearbeitet den Doppelklick auf das BW-Logo.
        // - Ruft den Reiter "Anzeige" auf.
        // - Setzt die URL auf die Homepage von BW und zeigt die Homepage an.
        if (event.getSource().equals(_lbLogoBW)) {
            _tabPluginDatKat2HTML.setSelection(_tabAnsicht);

            // URL erst setzen, damit diese auch in der Adresszeile angezeigt
            // wird...
            _txtAnsichtURL.setText("http://www.rp.baden-wuerttemberg.de/servlet/PB/menu/1147041/index.html");

            // ... dann erst die Seite aufrufen.
            _browser.setUrl(_txtAnsichtURL.getText());
        }
    }

    public void mouseDown(MouseEvent e) {

        // TODO Auto-generated method stub
    }

    public void mouseUp(MouseEvent e) {

        // TODO Auto-generated method stub
    }

    /**
     * Vergleiche zwei Texten. Falls die nicht gleich sind, setzte
     * _sindGUIDatenGeaendert auf true.
     *
     * @param textNeu
     * @param textAlt
     */
    private void pruefeTextAufAenderungen(String textNeu, String textAlt) {

        // Falls die Daten gendert sind
        // (zwei Texte sind nicht gleich),
        // setzte _sindGUIDatenGeaendert auf true:
        if (!textNeu.equals(textAlt)) {
            _sindGUIDatenGeaendert = true;
        }

        setzeEnabledFrGUI();
    }

    /**
     * Neue Selektion von Reiter.
     */
    private void reiterNeuSelektiert() {
        if (_istKonvertierungsProzessLaeuft) {

            // Falls der Konvertierung luft, darf man nicht Reiter ndern:
            _tabPluginDatKat2HTML.setSelection(_tabKonvertieren);
        } else {

            // Falls Reiter 'Konvertierung' selektiert ist,
            // und noch keine Vorgaben definiert sind
            // oder die Daten im GUI gendert wurden und zuerst gespeichert
            // werden sollen,
            // selektiere Reiter 'Verwaltung'.
            if (_tabPluginDatKat2HTML.getSelectionIndex() == 1) {
                if (_listAuswahl.getItems().length == 0) {
                    _tabPluginDatKat2HTML.setSelection(_tabVerwalten);
                } else if (_sindGUIDatenGeaendert) {
                    _tabPluginDatKat2HTML.setSelection(_tabVerwalten);
                    MessageDialog.openInformation(this.getShell(), "Info", "Die Daten im GUI wurden gendert.\n" + " Die Daten erst speichern oder die nderungen zurcksetzen.");
                }
            }

            // Falls Reiter 'Ansicht' selektiert wird,
            // Setzte den Text (URL):
            else if (_tabPluginDatKat2HTML.getSelectionIndex() == 2) {
                _txtAnsichtURL.setText("file:///" + _selektionKonvertierungsVorgabe.getStartDatei());
                _browser.setUrl(_txtAnsichtURL.getText());
            }
        }
    }

    /**
     * Setzte die GUIDaten entsprechend der selektierten KonvertierungsVorgabe.
     */
    private void setzeDatenGUI() {
        _selektionKonvertierungsVorgabe = _konvertierungsVorgaben.getMapKonvertierungsVorgaben().get(_selektionAuswahlListe);
        _txtAnsichtURL.setText("file:///" + _selektionKonvertierungsVorgabe.getStartDatei());

        if (_tabPluginDatKat2HTML.getSelectionIndex() == 2) {
            _browser.setUrl(_txtAnsichtURL.getText());
        }

        initialisiereListeKB();
        setzeDatenKonvertierung();
        setzeDatenVerwaltung();
    }

    /**
     * Setzte die GUIDaten im Reiter 'Konvertierung' entsprechend der
     * selektierten KonvertierungsVorgabe.
     */
    private void setzeDatenKonvertierung() {
        _txtKonvKurzBezeichnung.setText(_selektionKonvertierungsVorgabe.getKurzBezeichung());
        _txtKonvLangBezeichnung.setText(_selektionKonvertierungsVorgabe.getLangBezeichung());
        _txtAreaKonvKommentar.setText(_selektionKonvertierungsVorgabe.getKommentar());
        _txtKonvZielOrdner.setText(_selektionKonvertierungsVorgabe.getZielOrdner());

        // Button Konvertieren ist aktiv, nur falls KBListe nicht leer ist.
        if (_listeKB.isEmpty()) {
            _btnKonvKonvertierung.setEnabled(false);
        } else {
            _btnKonvKonvertierung.setEnabled(true);
        }

        // Tabelle:
        setzeDatenKonvertierungTabelle();
    }

    /**
     * Setzte die GUIDaten in der KonvertierungTabelle.
     */
    private void setzeDatenKonvertierungTabelle() {
        _listeKB = sortiereListeKB(_listeKB);
        _tableViewerKonvKB.setInput(_listeKB);

        Table table = _tableViewerKonvKB.getTable();
        int   i     = 0;

        for (TableItem item : table.getItems()) {
            KonfigurationsBereich kb = _listeKB.get(i);

            // Modell:
            if (kb.isModell()) {

                // Spalte 0
                if (kb.getKb().equals(_ungueltig)) {
                    item.setImage(0, _imageFehler);
                } else {
                    item.setImage(0, _imageNochOffen);
                }
            } else {
                item.setImage(0, _imageKeineTransformation);
            }

            // Objekt:
            if (_listeKB.get(i).isObjekt()) {
                if (kb.getKb().equals(_ungueltig)) {
                    item.setImage(1, _imageFehler);
                } else {
                    item.setImage(1, _imageNochOffen);
                }
            } else {
                item.setImage(1, _imageKeineTransformation);
            }

            i++;
        }

        // Gre der Spalten anpassen:
        for (TableColumn column : table.getColumns()) {
            column.pack();
        }
    }

    /**
     * Setzte die GUIDaten im Reiter 'Verwaltung' entsprechend der selektierten
     * KonvertierungsVorgabe.
     */
    private void setzeDatenVerwaltung() {
        _txtVewKurzBezeichnung.setText(_selektionKonvertierungsVorgabe.getKurzBezeichung());
        _txtVewLangBezeichnung.setText(_selektionKonvertierungsVorgabe.getLangBezeichung());
        _txtAreaVewKommentar.setText(_selektionKonvertierungsVorgabe.getKommentar());
        _txtVewZielOrdner.setText(_selektionKonvertierungsVorgabe.getZielOrdner());
        setzeEnabledFrGUI();

        // Tabelle:
        setzeDatenVerwaltungTabelle();
    }

    /**
     * Initialisiere die Tabelle VerwaltungKB. Eine Zeile entspricht einem KB
     * aus der Liste _listeKB.
     */
    private void setzeDatenVerwaltungTabelle() {
        _listeKB = sortiereListeKB(_listeKB);
        _tabelVewTabelleKonfigurationsBereiche.setInput(_listeKB);

        Table table = _tabelVewTabelleKonfigurationsBereiche.getTable();

        // Lsche alle alte Editors:
        if (!_listeEditor0.isEmpty()) {
            for (TableEditor editor : _listeEditor0) {
                if (editor.getEditor() != null) {
                    editor.getEditor().dispose();
                }
            }

            _listeEditor0.clear();
        }

        if (!_listeEditor1.isEmpty()) {
            for (TableEditor editor : _listeEditor1) {
                if (editor.getEditor() != null) {
                    editor.getEditor().dispose();
                }
            }

            _listeEditor1.clear();
        }

        if (!_listeEditor5.isEmpty()) {
            for (TableEditor editor : _listeEditor5) {
                if (editor.getEditor() != null) {
                    editor.getEditor().dispose();
                }
            }

            _listeEditor5.clear();
        }

        int numItem = 0;

        for (TableItem item : table.getItems()) {
            final int numItemFinal = numItem;

            // Spalte 0
            TableEditor editor0 = new TableEditor(table);
            Button      button0 = new Button(table, SWT.CHECK);

            button0.addSelectionListener(new SelectionAdapter() {
                @Override
                public void widgetSelected(SelectionEvent e) {
                    aendereBooleanListe(1, numItemFinal, e);
                }
            });
            button0.setSelection(_listeKB.get(numItem).isModell());
            button0.pack();
            editor0.minimumWidth        = button0.getSize().x;
            editor0.horizontalAlignment = SWT.LEFT;
            editor0.setEditor(button0, item, 0);
            _listeEditor0.add(editor0);

            // Spalte 1
            TableEditor editor1 = new TableEditor(table);
            Button      button1 = new Button(table, SWT.CHECK);

            button1.addSelectionListener(new SelectionAdapter() {
                @Override
                public void widgetSelected(SelectionEvent e) {
                    aendereBooleanListe(2, numItemFinal, e);
                }
            });
            button1.setSelection(_listeKB.get(numItem).isObjekt());
            button1.pack();
            editor1.minimumWidth        = button1.getSize().x;
            editor1.horizontalAlignment = SWT.LEFT;
            editor1.setEditor(button1, item, 1);
            _listeEditor1.add(editor1);

            // Spalte 5
            TableEditor editor5 = new TableEditor(table);
            Button      button5 = new Button(table, SWT.PUSH);

            button5.setText("...");
            button5.addSelectionListener(new SelectionAdapter() {
                @Override
                public void widgetSelected(SelectionEvent evt) {
                    auswaehlenKbDatei(numItemFinal);
                }
            });
            button5.pack();
            editor5.minimumWidth        = button5.getSize().x;
            editor5.horizontalAlignment = SWT.LEFT;
            editor5.setEditor(button5, item, 5);
            _listeEditor5.add(editor5);

            //
            numItem++;
        }

        // Anpasse die Gre der Spalten:
        for (TableColumn column : table.getColumns()) {
            column.pack();
        }
    }

    /**
     * Setze die Buttons und Navigation aktiv/unaktiv entsprechend dem Wert von
     * _sindGUIDatenGeaendert.
     */
    private void setzeEnabledFrGUI() {
        if (_sindGUIDatenGeaendert) {
            _btnVewNeu.setEnabled(false);
            _btnVewKopieren.setEnabled(false);
            _btnVewLoeschen.setEnabled(true);
            _btnVewZuruecksetzen.setEnabled(true);
            _btnVewUebernehmen.setEnabled(true);
            _listAuswahl.setEnabled(false);
        } else {
            _btnVewNeu.setEnabled(true);
            _btnVewKopieren.setEnabled(true);
            _btnVewLoeschen.setEnabled(true);
            _btnVewZuruecksetzen.setEnabled(false);
            _btnVewUebernehmen.setEnabled(false);
            _listAuswahl.setEnabled(true);
        }

        _btnVewZielOrdner.setEnabled(true);
        _btnVewKonfigurationsBereichHinzufuegen.setEnabled(true);
    }

    /**
     * Auto-generated method to display this org.eclipse.swt.widgets.Composite
     * inside a new Shell.
     */
    public static void showGUI() {
        Display     display = Display.getDefault();
        Shell       shell   = new Shell(display);
        DatKat2HTML inst    = new DatKat2HTML(shell, SWT.NULL);
        Point       size    = inst.getSize();

        shell.setLayout(new FillLayout());
        shell.layout();

        if ((size.x == 0) && (size.y == 0)) {
            inst.pack();
            shell.pack();
        } else {
            Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);

            shell.setSize(shellBounds.width, shellBounds.height);
        }

        shell.open();

        while (!shell.isDisposed()) {
            if (!display.readAndDispatch()) {
                display.sleep();
            }
        }
    }

    /**
     * Sortiere Liste von KB nach KV und KB.
     *
     * @return Nach KV und KB sortierte Liste.
     */
    private java.util.List<KonfigurationsBereich> sortiereListeKB(java.util.List<KonfigurationsBereich> listeKB) {
        KonfigurationsBereich[] arrayKB = listeKB.toArray(new KonfigurationsBereich[0]);

        Arrays.sort(arrayKB, new Comparator<KonfigurationsBereich>() {
            @Override
            public int compare(KonfigurationsBereich o1, KonfigurationsBereich o2) {
                int sortKV = o1.getKv().compareTo(o2.getKv());

                if (sortKV != 0) {
                    return sortKV;
                } else {
                    return o1.getKb().compareTo(o2.getKb());
                }
            }
        });
        listeKB.clear();
        listeKB.addAll(Arrays.asList(arrayKB));

        return listeKB;
    }

    /**
     * speichere die GUIDaten in KonvertierungsVorgabe.
     */
    public void uebernehmeDatenAusVoreinstellung() {

        // bernahme der genderten Daten:
        // 1. Daten aus Dialog in Datenstruktur bertragen
        // 2. Liste neu erzeugen und darstellen (Kurzbezeichnung kann sich
        // gendert haben) und Map von KonfVorgaben speichern
        // Hier auch Prfe, ob solche Kurzbezeichnung schon existiert.
        // Falls ja: FrageDialog: speichern?
        // Falls 'speichern': weiter zu 3-5,
        // sonst das vom Map gelschte Element zurck liegen.
        // 3. Listeneintrag selektieren
        // 4. Listeneintrag "auswhlen" --> Dialoge werden automatisch neu
        // aufgebaut.
        // 5. Die Buttons bernehmen und Zurcksetzen sind unaktiv
        boolean speichern = true;

        // zu 1.
        KonvertierungsVorgabe konvertierungsVorgabe = leseDatenVerwaltung();

        // zu 2. Liste neu erzeugen und darstellen (Kurzbezeichnung kann sich
        // gendert haben)
        // bisherigen Eintrag lschen, neuen Eintrag hinzufgen, Liste neu
        // darstellen
        // _konvertierungsVorgaben.getMapKonvertierungsVorgaben().remove(_selektionAuswahlListe);
        // Prfe, ob solche Kurzbezeichnung schon existiert
        if ((!konvertierungsVorgabe.getKurzBezeichung().equals(_selektionAuswahlListe)) && (_konvertierungsVorgaben.getMapKonvertierungsVorgaben().get(konvertierungsVorgabe.getKurzBezeichung()) != null)) {
            if (!MessageDialog.openQuestion(this.getShell(), "Duplikat der Vorgabenamen", "Die Konvertierungsvorgabe mit dem Namen " + konvertierungsVorgabe.getKurzBezeichung() + " existiert schon in der Navigation.\n" + "Soll die bestehende Vorgabe berschrieben werden?")) {
                speichern = false;
            }
        }

        if (speichern) {
            _konvertierungsVorgaben.getMapKonvertierungsVorgaben().remove(_selektionAuswahlListe);
            _konvertierungsVorgaben.getMapKonvertierungsVorgaben().put(konvertierungsVorgabe.getKurzBezeichung(), konvertierungsVorgabe);
            _konvertierungsVorgaben.speichereKonvertierungsVorgaben();
            _listAuswahl.setItems(_konvertierungsVorgaben.getSortiereListeDerKonvertierungsVorgabenKurzBezeichungen());

            // zu 3. Listeneintrag selektieren
            _selektionAuswahlListe = konvertierungsVorgabe.getKurzBezeichung();

            String[] auswahl = new String[] { _selektionAuswahlListe };

            _listAuswahl.setSelection(auswahl);

            // zu 4. Listeneintrag "auswhlen" --> Dialoge werden automatisch
            // neu
            // aufgebaut
            _progressBarKonvGesamt.setSelection(0);
            _progressBarKonvKonfigurationsBereich.setSelection(0);
            _sindGUIDatenGeaendert = false;
            setzeDatenGUI();
        } else {

            // _konvertierungsVorgaben.getMapKonvertierungsVorgaben().put(_selektionAuswahlListe,
            // _selektionKonvertierungsVorgabe);
            // setzeDatenGUI();
        }
    }

    /**
     * Prfe die Datei der Map von KonfigurationsBereich aus der
     * KonvertierungsVorgabe, ob den Pfad noch existiert und ob KB und KV nicht
     * gendert sind. Falls ntig ist, korrigiere das Map.
     */
    private void ueberpruefeKBMap(KonvertierungsVorgabe konfVorgabe) {

        // Key: pid von altem KB, Value: neuer KonfigurationsBereich
        Map<String, KonfigurationsBereich> mapAendern = new HashMap<String, KonfigurationsBereich>();
        int                                anzahlKB   = konfVorgabe.getMapKonfigurationsBereich().size();
        int                                i          = 0;

        for (KonfigurationsBereich kb : konfVorgabe.getMapKonfigurationsBereich().values()) {
            KonfigurationsBereich kbGeprueft = erstelleKonfigurationsBereichAusXML(kb.getPfad());

            if ((!kb.getKb().equals(kbGeprueft.getKb())) || (!kb.getKv().equals(kbGeprueft.getKv()))) {
                mapAendern.put(kb.getKb(), kbGeprueft);
            }

            // Berechne FortschrittGesammt fr dieses Prozess (max=9%):
            Float prozentAll = 9f / anzahlKB * i;

            _progressBarKonvGesamt.setSelection(prozentAll.intValue() + 1);
            i++;
        }

        // ndere das Map
        String messageGeaendert = "";

        for (String kbPid : mapAendern.keySet()) {
            konfVorgabe.getMapKonfigurationsBereich().remove(kbPid);
        }

        for (KonfigurationsBereich kbNeu : mapAendern.values()) {
            if (konfVorgabe.getMapKonfigurationsBereich().get(kbNeu.getKb()) != null) {
                Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Die Datei mit dem KB [" + kbNeu.getKb() + "] existieren schon in der Tabelle!"));
            } else {
                messageGeaendert = messageGeaendert + kbNeu.getPfad() + ", ";
                konfVorgabe.getMapKonfigurationsBereich().put(kbNeu.getKb(), kbNeu);
            }
        }

        if (!messageGeaendert.equals("")) {
            Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "In den folgenden Tabelleeintrgen werden KV bzw. KB gendert: " + messageGeaendert + "!"));
        }

        // Falls das Map gendert wurde, initialisiere neu das GUI:
        if (!mapAendern.isEmpty()) {
            setzeDatenGUI();
        }
    }

    /**
     * Erzeugt den Ordner, falls der noch nicht existiert oder gibt false
     * zurck, falls ein Fehler aufgetreten ist.
     *
     * @param ordner
     *            Absoluter Name vom Ordner, der erzeugt werden soll.
     *
     * @return true, falls Ordner erfolgreich erzeugt wurde, false sonst.
     */
    private boolean ueberpruefeZielordner(String ordner) {
        boolean existiert = true;

        // Erzeuge den Ordner, falls der noch nicht existiert und als abs.Pfad
        // angegeben ist:
        File file = new File(ordner);

        if (ordner.equals(file.getAbsolutePath())) {
            if (!file.exists()) {
                try {
                    file.mkdirs();
                }
                catch (SecurityException e) {
                    Log.zeigeInterneMultiMeldung(Activator.PLUGIN_ID, "Der Ordner [" + ordner + "] kann nicht erstellt werden!", e);
                    existiert = false;
                }
            }
        } else {
            Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Der Ordner [" + ordner + "] kann nicht erstellt werden!"));
            existiert = false;
        }

        return existiert;
    }

    /**
     * Verarbeite die neue Selektion in der AuswahlListe.
     */
    private void verarbeiteSelektionDerAuswahlListe() {

        /*
         * // Dialog 'Speichere Daten?', falls die Daten im GUI gendert sind:
         * if(_sindGUIDatenGeaendert){
         * if(MessageDialog.openQuestion(this.getShell(), "Speichern?", "Die
         * Daten im Dialog sind gendert. Speichern die?" + "\n Sonst werden die
         * verloren.")){ uebernehmeDatenAusVoreinstellung();// falsch! } }
         */
        _selektionAuswahlListe = _listAuswahl.getSelection()[0];

        // Setzte GUI:
        _progressBarKonvGesamt.setSelection(0);
        _progressBarKonvKonfigurationsBereich.setSelection(0);
        setzeDatenGUI();
        ViewVerwaltung.zeigeStatusleisteText("Konvertierungsvorgabe: " + _selektionAuswahlListe);
    }

    public void widgetDefaultSelected(SelectionEvent event) {
        if (event.getSource().equals(_titemAnsichtZurueck)) {
            _browser.back();
        }

        if (event.getSource().equals(_titemAnsichtVorwaerts)) {
            _browser.forward();
        }

        if (event.getSource().equals(_titemAnsichtNeuLaden)) {
            _browser.refresh();
        }

        if (event.getSource().equals(_titemAnsichtStopp)) {
            _browser.stop();
        }

        if (event.getSource().equals(_titemAnsichtOK)) {
            _browser.setUrl(_txtAnsichtURL.getText());
        }
    }

    // --------------------- Interface SelectionListener ---------------------
    public void widgetSelected(SelectionEvent event) {
        if (event.getSource().equals(_titemAnsichtZurueck)) {
            _browser.back();
        }

        if (event.getSource().equals(_titemAnsichtVorwaerts)) {
            _browser.forward();
        }

        if (event.getSource().equals(_titemAnsichtNeuLaden)) {
            _browser.refresh();
        }

        if (event.getSource().equals(_titemAnsichtStopp)) {
            _browser.stop();
        }

        if (event.getSource().equals(_titemAnsichtOK)) {
            _browser.setUrl(_txtAnsichtURL.getText());
        }
    }

    //~ INNERE KLASSEN ========================================================

    /*
     * Klasse verwaltet den Inhalt den Tabelle.
     */
    class TableContentProvider implements IStructuredContentProvider {
        @Override
        public void dispose() {}

        //~ GET METHODEN ======================================================

        @SuppressWarnings("unchecked")
        @Override
        public Object[] getElements(Object inputElement) {
            return ((java.util.List<KonfigurationsBereich>) inputElement).toArray();
        }

        //~ METHODEN ==========================================================

        @Override
        public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {}
    }


    // ------------------------------------------------------------------------
    // INNERE KLASSEN
    // ------------------------------------------------------------------------

    /*
     * Klasse verwaltet die Beschriftung der Tabelle.
     */
    class TableLabelProvider extends LabelProvider implements ITableLabelProvider {
        public Image getColumnImage(Object element, int columnIndex) {
            return null;
        }

        public String getColumnText(Object element, int columnIndex) {
            if (element instanceof KonfigurationsBereich) {
                KonfigurationsBereich kb = (KonfigurationsBereich) element;

                if (columnIndex == 2) {
                    return kb.getKv();
                } else if (columnIndex == 3) {
                    return kb.getKb();
                } else if (columnIndex == 4) {
                    return kb.getPfad();
                }
            }

            return "";
        }
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 05.02.13
