/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.gtm.datvew.konstanten;

//~ NICHT JDK IMPORTE =========================================================

import de.bsvrz.dav.daf.main.config.ObjectSet;
import de.bsvrz.dav.daf.main.config.SystemObject;

import de.inovat.buv.gtm.datvew.Activator;

import org.eclipse.swt.graphics.Image;

import static de.inovat.buv.inovat.lib.konstanten.Konstanten.FILESEPARATOR;

//~ KLASSEN ===================================================================

/**
 * Klasse sammelt alle GTM-GUI-Resource (Fonts, Image...).
 *
 * TODO Alle Resource hier definieren!
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public class KonstantenGTMGUIResource {
    public static final String  TYP_128     = "typ.de128";
    public static final String  TYP_253     = "typ.de253";
    public static final String  TYP_AMQ     = "typ.auswerteQuerschnitt";
    public static final String  TYP_AXL     = "typ.deAxl";
    public static final String  TYP_EAK     = "typ.eak";
    public static final String  TYP_FS      = "typ.fahrStreifen";
    public static final String  TYP_KB      = "typ.konfigurationsBereich";
    public static final String  TYP_KRI     = "typ.kri";
    public static final String  TYP_KRI2_b  = "typ.kri2_b";
    public static final String  TYP_KRI2b   = "typ.kri2b";
    public static final String  TYP_LVE     = "typ.deLve";
    public static final String  TYP_LZZ     = "typ.langZeitZhlstelle";
    public static final String  TYP_MENGE   = "typ.mengenTyp";
    public static final String  TYP_MQ      = "typ.messQuerschnitt";
    public static final String  TYP_SM      = "typ.steuerModul";
    public static final String  TYP_STRASSE = "typ.strae";
    public static final String  TYP_SYS     = "typ.deSys";
    public static final String  TYP_TYP     = "typ.typ";
    public static final String  TYP_UFD     = "typ.deUfd";
    public static final String  TYP_UZ      = "typ.uz";
    public static final String  TYP_VIZ     = "typ.viz";
    public static final String  TYP_VLT     = "typ.deVlt";
    public static final String  TYP_VRZ     = "typ.vrz";
    public static final String  TYP_WWW     = "typ.deWww";
    public static final String  TYP_WZG     = "typ.deWzg";
    public static final Image   ICON_GTM_AMQ;
    public static final Image   ICON_GTM_De128;
    public static final Image   ICON_GTM_De253;
    public static final Image   ICON_GTM_DeAxl;
    public static final Image   ICON_GTM_DeLve;
    public static final Image   ICON_GTM_DeSys;
    public static final Image   ICON_GTM_DeUfd;
    public static final Image   ICON_GTM_DeVlt;
    public static final Image   ICON_GTM_deWww;
    public static final Image   ICON_GTM_deWzg;
    public static final Image   ICON_GTM_EAK;
    public static final Image   ICON_GTM_FS;
    public static final Image   ICON_GTM_KB;
    public static final Image   ICON_GTM_KRI;
    public static final Image   ICON_GTM_KRI2_B;
    public static final Image   ICON_GTM_KRI2B;
    public static final Image   ICON_GTM_LZZ;
    public static final Image   ICON_GTM_MENGE;
    public static final Image   ICON_GTM_MQ;
    public static final Image   ICON_GTM_OBJ;
    public static final Image   ICON_GTM_OBJ_TYPE;
    public static final Image   ICON_GTM_SM;
    public static final Image   ICON_GTM_STRASSE;
    public static final Image   ICON_GTM_UZ;
    public static final Image   ICON_GTM_VIZ;
    public static final Image   ICON_GTM_VRZ;
    public static final Image   ICON_INFO;
    private static final String PFAD_ICONS_GTM;

    //~ STATISCHE INITIALISIERER ==============================================

    static {
        ICON_INFO = Activator.getImageDescriptorInovat(String.format("icons%sinfo.gif", FILESEPARATOR)).createImage();

        // Initialisiere den Pfad:
        PFAD_ICONS_GTM = String.format("icons%siGTM%s", FILESEPARATOR, FILESEPARATOR);

        // Initialisiere die Icons:
        ICON_GTM_AMQ      = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "auswerteQuerschnitt.png")).createImage();
        ICON_GTM_De128    = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "de128.gif")).createImage();
        ICON_GTM_De253    = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "de253.gif")).createImage();
        ICON_GTM_DeAxl    = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "deAxl.gif")).createImage();
        ICON_GTM_DeLve    = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "deLve.gif")).createImage();
        ICON_GTM_DeSys    = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "deSys.gif")).createImage();
        ICON_GTM_DeUfd    = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "deUfd.gif")).createImage();
        ICON_GTM_DeVlt    = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "deVlt.gif")).createImage();
        ICON_GTM_deWww    = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "deWww.gif")).createImage();
        ICON_GTM_deWzg    = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "deWzg.gif")).createImage();
        ICON_GTM_EAK      = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "eak.gif")).createImage();
        ICON_GTM_KRI      = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "kri.gif")).createImage();
        ICON_GTM_KRI2B    = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "kri2b.gif")).createImage();
        ICON_GTM_KRI2_B   = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "kri2_b.gif")).createImage();
        ICON_GTM_SM       = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "steuerModul.gif")).createImage();
        ICON_GTM_UZ       = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "uz.gif")).createImage();
        ICON_GTM_VIZ      = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "viz.gif")).createImage();
        ICON_GTM_VRZ      = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "vrz.gif")).createImage();
        ICON_GTM_STRASSE  = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "strasse.png")).createImage();
        ICON_GTM_OBJ_TYPE = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "objektTyp.png")).createImage();
        ICON_GTM_OBJ      = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "objekt.png")).createImage();
        ICON_GTM_MQ       = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "messQuerschnitt.png")).createImage();
        ICON_GTM_MENGE    = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "menge.png")).createImage();
        ICON_GTM_LZZ      = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "langZeitZhlstelle.png")).createImage();
        ICON_GTM_KB       = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "konfigurationsBereich.png")).createImage();
        ICON_GTM_FS       = Activator.getImageDescriptorInovat(String.format("%s%s", PFAD_ICONS_GTM, "fahrStreifen.png")).createImage();
    }

    //~ METHODEN ==============================================================

    /**
     * Ermittle Image abhngig vom Typ des  fr angegebenen SystemObjects.
     *
     * @param so SystemObject.
     *
     * @return Image abhngig vom Typ des  fr angegebenen SystemObjects.
     */
    public static Image ermittleImage(SystemObject so) {

        // DEs:
        if (so.getType().isOfType(TYP_128)) {
            return ICON_GTM_De128;
        } else if (so.isOfType(TYP_253)) {
            return ICON_GTM_De253;
        } else if (so.isOfType(TYP_AXL)) {
            return ICON_GTM_DeAxl;
        } else if (so.isOfType(TYP_LVE)) {
            return ICON_GTM_DeLve;
        } else if (so.isOfType(TYP_SYS)) {
            return ICON_GTM_DeSys;
        } else if (so.isOfType(TYP_UFD)) {
            return ICON_GTM_DeUfd;
        } else if (so.isOfType(TYP_VLT)) {
            return ICON_GTM_DeVlt;
        } else if (so.isOfType(TYP_WWW)) {
            return ICON_GTM_deWww;
        } else if (so.isOfType(TYP_WZG)) {
            return ICON_GTM_deWzg;
        }

        // Gerte:
        else if (so.isOfType(TYP_VIZ)) {
            return ICON_GTM_VIZ;
        } else if (so.isOfType(TYP_UZ)) {
            return ICON_GTM_UZ;
        } else if (so.isOfType(TYP_VRZ)) {
            return ICON_GTM_VRZ;
        } else if (so.isOfType(TYP_KRI)) {
            return ICON_GTM_KRI;
        } else if (so.isOfType(TYP_KRI2b)) {
            return ICON_GTM_KRI2B;
        } else if (so.isOfType(TYP_KRI2_b)) {
            return ICON_GTM_KRI2_B;
        } else if (so.isOfType(TYP_SM)) {
            return ICON_GTM_SM;
        }

        // EAK:
        else if (so.isOfType(TYP_EAK)) {
            return ICON_GTM_EAK;
        }

        // LZZ:
        else if (so.isOfType(TYP_STRASSE)) {
            return ICON_GTM_STRASSE;
        } else if (so.isOfType(TYP_LZZ)) {
            return ICON_GTM_LZZ;
        } else if (so.isOfType(TYP_AMQ)) {
            return ICON_GTM_AMQ;
        } else if (so.isOfType(TYP_MQ)) {
            return ICON_GTM_MQ;
        } else if (so.isOfType(TYP_FS)) {
            return ICON_GTM_FS;
        }

        // Konfigurationsbereich:
        else if (so.isOfType(TYP_KB)) {
            return ICON_GTM_KB;
        }

        // Mengen:
        else if (so.isOfType(TYP_MENGE)) {
            return ICON_GTM_MENGE;
        } else if (so instanceof ObjectSet) {
            return ICON_GTM_MENGE;
        }

        // Typ:
        else if (so.isOfType(TYP_TYP)) {
            return ICON_GTM_OBJ_TYPE;
        }

        // SystemObject:
        return ICON_GTM_OBJ;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 08.03.13
