/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.gtm.rw;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.inovat.lib.debug.Log;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

//~ KLASSEN ===================================================================

/**
 * Die Klasse Perspective implementiert die BasisPerspektive des RahmenWerks.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public class Perspective implements IPerspectiveFactory {

    /**
     * ID der Perspektive.
     */
    public static final String ID = "de.inovat.buv.gtm.rw.Perspective";

    //~ METHODEN ==============================================================

    @Override
    public void createInitialLayout(IPageLayout layout) {

        // -------------------------------------------------------
        // Setze den Anwendungstitel:
        // PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell().setText("Datenunterzentrale");
        // -------------------------------------------------------
        // Baue die Perspektive
        String editorArea = layout.getEditorArea();

        layout.setEditorAreaVisible(false);

        // TODO topCenter fr andere Views..
        IFolderLayout topCenter = layout.createFolder("topCenter", IPageLayout.RIGHT, 0.35f, editorArea);

        // inovatTools:
        topCenter.addPlaceholder("de.inovat.buv.plugin.*");
        topCenter.addPlaceholder("de.inovat.buv.plugin.rechtevew.*");
        topCenter.addPlaceholder("de.inovat.buv.plugin.speichervew.export.*");
        topCenter.addPlaceholder("de.inovat.buv.plugin.speichervew.import.*");

        // gtm:
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.*");
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.navigation.tabellendarstellung.view:*");
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.navigation.filter.view");
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.navigation.sortierung.view");
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.navigation.spalten.view");
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.navigation.tabellenverwaltung.view");

        // lzzs:
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.bast.export.view");
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.bast.import.view");
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.bast.importpruef.view");
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.lzzs.pufferLZZ.view");
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.lzzs.pufferAXL.view");
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.lzzs.aggregation.view");
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.visualisierung.karte.view");
        topCenter.addPlaceholder("de.inovat.buv.plugin.gtm.visualisierung.ganglinien.view");

        //
        IFolderLayout mitteLeft = layout.createFolder("mitteLeft", IPageLayout.LEFT, 0.22f, editorArea);

        // Navigation:
        String navigationID = "de.inovat.buv.plugin.gtm.navigation.view";

        mitteLeft.addView(navigationID);
        layout.getViewLayout(navigationID).setCloseable(false);
        layout.getViewLayout(navigationID).setMoveable(false);

        // Logos:
        layout.addStandaloneView("de.inovat.buv.projektlib.views.viewLogoBundesland", false, IPageLayout.TOP, 0.11f, "mitteLeft");
        layout.addStandaloneView("de.inovat.buv.projektlib.views.viewLogoInovat", false, IPageLayout.BOTTOM, 0.89f, "mitteLeft");

        // LogView:
        // layout.addStandaloneView(Log.LogViewID, true, IPageLayout.BOTTOM, 0.8f, "topCenter");
        IFolderLayout untenCenter = layout.createFolder("untenCenter", IPageLayout.BOTTOM, 0.8f, "topCenter");

        untenCenter.addView(Log.LogViewID);
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 12.12.13
