/*
 * @(#)GTMDialogGUIVerwaltung.java   08.03.13
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.navigation.gtmdiag;

//~ NICHT JDK IMPORTE =========================================================

import com.swtdesigner.SWTResourceManager;

import de.bsvrz.buv.rw.basislib.listendarstellung.DataTableObjectErweitert;
import de.bsvrz.buv.rw.basislib.tabellen.ContentProviderTabellenDatenStruktur;
import de.bsvrz.buv.rw.basislib.tabellen.DragAdapter;
import de.bsvrz.buv.rw.basislib.tabellen.DropAdapter;
import de.bsvrz.buv.rw.basislib.tabellen.ElementFilter;
import de.bsvrz.buv.rw.basislib.tabellen.ElementRegEx;
import de.bsvrz.buv.rw.basislib.tabellen.ITabellenZeile;
import de.bsvrz.buv.rw.basislib.tabellen.SpaltenElement;
import de.bsvrz.buv.rw.basislib.tabellen.TabellenDatenStruktur;
import de.bsvrz.buv.rw.basislib.tabellen.TabellenDatenStruktur.FilterAusdruck;
import de.bsvrz.buv.rw.basislib.tabellen.TabellenDatenStruktur.TabellenFilter;
import de.bsvrz.buv.rw.basislib.tabellen.XmlFilterVerwaltung;
import de.bsvrz.dav.daf.main.archive.ArchiveData;
import de.bsvrz.dav.daf.main.archive.ArchiveDataKind;
import de.bsvrz.dav.daf.main.archive.ArchiveDataQueryResult;
import de.bsvrz.dav.daf.main.archive.ArchiveDataSpecification;
import de.bsvrz.dav.daf.main.archive.ArchiveDataStream;
import de.bsvrz.dav.daf.main.archive.ArchiveRequestManager;
import de.bsvrz.dav.daf.main.archive.ArchiveTimeSpecification;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dav.daf.main.config.SystemObjectType;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.Data.Array;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.DataState;
import de.bsvrz.dav.daf.main.ReceiveOptions;
import de.bsvrz.dav.daf.main.ReceiverRole;
import de.bsvrz.dav.daf.main.ResultData;

import de.inovat.buv.gtm.datvew.aktionen.AktionenGTM;
import de.inovat.buv.gtm.datvew.lib.BaumHilfsFunktionen;
import de.inovat.buv.gtm.datvew.lib.BaumVerwaltung;
import de.inovat.buv.inovat.lib.aktionen.StandardAktionen;
import de.inovat.buv.inovat.lib.debug.Log;
import de.inovat.buv.inovat.lib.funktionen.datum.DatumFunktionen;
import de.inovat.buv.inovat.lib.gui.GuiFunktionen;
import de.inovat.buv.plugin.gtm.navigation.Activator;
import de.inovat.buv.plugin.gtm.navigation.archiv.ArchivanfrageDaten;
import de.inovat.buv.plugin.gtm.navigation.archiv.ArchivanfrageDatenGUIVew;
import de.inovat.buv.plugin.gtm.navigation.archiv.IArchivanfrageGUIVew;
import de.inovat.buv.plugin.gtm.navigation.datenidentifikation.Datenidentifikation;
import de.inovat.buv.plugin.gtm.navigation.export.CsvExport;
import de.inovat.buv.plugin.gtm.navigation.export.HtmlExport;
import de.inovat.buv.plugin.gtm.navigation.filter.AlleFilter;
import de.inovat.buv.plugin.gtm.navigation.filter.Filter;
import de.inovat.buv.plugin.gtm.navigation.filter.FilterEintrag;
import de.inovat.buv.plugin.gtm.navigation.sortierung.AlleSortierungen;
import de.inovat.buv.plugin.gtm.navigation.sortierung.SortierObjekt;
import de.inovat.buv.plugin.gtm.navigation.sortierung.Sortierung;
import de.inovat.buv.plugin.gtm.navigation.sortierung.SortierungEintrag;
import de.inovat.buv.plugin.gtm.navigation.tabellen.LabelProviderTabellenDatenStrukturGTM;
import de.inovat.buv.plugin.gtm.navigation.tabellen.TabellenObjekt;
import de.inovat.buv.plugin.gtm.navigation.tabellen.ZeilenObjekt;
import de.inovat.buv.plugin.gtm.navigation.tabellenverwaltung.AlleTabellenVerwaltungen;
import de.inovat.buv.plugin.gtm.navigation.tabellenverwaltung.TabellenVerwaltung;
import de.inovat.buv.plugin.gtm.navigation.tabellenverwaltung.TabellenVerwaltungEintrag;
import de.inovat.buv.plugin.gtm.navigation.ViewTabellenVerwaltung;
import de.inovat.buv.projektlib.dav.DavDatenVew;
import de.inovat.buv.projektlib.rechtevew.aktionen.AktionenVew;
import de.inovat.buv.projektlib.rechtevew.lib.RechteVew;
import de.inovat.buv.projektlib.speicher.OrdnerEinstellungen;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IInputValidator;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.dialogs.ProgressMonitorDialog;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.ui.PlatformUI;

import static de.inovat.buv.inovat.lib.konstanten.Konstanten.FILESEPARATOR;
import static de.inovat.buv.inovat.lib.konstanten.Konstanten.NEWLINE;

//~ JDK IMPORTE ===============================================================

import java.io.FileWriter;
import java.io.IOException;

import java.lang.reflect.InvocationTargetException;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;

//~ KLASSEN ===================================================================

public class GTMDialogGUIVerwaltung implements IArchivanfrageGUIVew {

    /** Array mit statischen Spaltenanmen Archivdaten. */
    private static final String[] _arArchivSpaltenAuswahl = { "Art", "Datenzeit", "Archivzeit", "Objekt" };

    /** Array mit statischen Spaltennamen Normale Daten. */
    private static final String[] _arNormalSpaltenAuswahl = { "Art", "Datenzeit", "Objekt" };

    /**
     * Konstante die zum Lschen der Tabellenzeilen verwendet wird. Ist diese Konstante ausgewhlt
     * werden alle Tabellenzeilen gelscht.
     */
    protected static final String ALLE = "alle";

    /**
     * Konstante die zum Lschen der Tabellenzeilen verwendet wird. Ist diese Konstante ausgewhlt,
     * werden 50 Prozent der Tabellenzeilen gelscht, da es sich um eine Archivanfrage handelt.
     */
    private static final String ARCHIV_50_PROZENT = "archiv";

    /** Konstante die angibt, dass die Tabellenzeilen benutzerdefiniert gelscht werden. */
    protected static final String BENUTZERDEFINIERT = "benutzerdefiniert";

    /** Konstante die die Sicht benutzerspezifisch reprsentiert. */
    protected static final String BENUTZERSPEZIFISCH = "Benutzerspezifisch";

    /** Konstante die angibt, dass keine Darstellungsoption ausgewhlt wurde. */
    protected static final String KEINE_DARSTELLUNG = "Keine Darstellung ausgewhlt";

    /** Konstante die angibt, dass keine Sortierung ausgewhlt wurde. */
    private static final String KEINE_SORTIERUNG = "Keine Sortierung";

    /** Konstante die angibt, dass keine Spaltenauwahl ausgewhlt wurde. */
    private static final String KEINE_SPALTENAUSWAHL = "Keine Spaltenauswahl";

    /** Konstante die angibt, dass kein Filter ausgewhlt wurde. */
    private static final String KEINEN_FILTER = "Kein Filter";

    /** Konstante Nutzdaten. */
    private static final String NUTZDATEN = "Nutzdaten";

    /** Trennzeichen fr die CSV-Datei. */
    private static final String TRENN_ZEICHEN = ";";

    //~ FELDER ================================================================

    /** Anzahl der ResultData, dieses Attribut wird fr die Archivanfrage bentigt. */
    private int _resultDataCount = 0;

    /** Liste die die Auswahl der Spalten enthlt. */
    List<SortierObjekt> _spaltenWahl = new ArrayList<SortierObjekt>();

    /**
     * Gibt an, ob die Tabelle schon mal belegt gewesen ist, diese Information wird bentigt
     * um den Drag und Drop support fr die Tabelle nicht ein zweites mal anzumelden.
     */
    private boolean _tabelleNeu = true;

    /** Instanz der Klasse AlleTabellenVerwaltungen. */
    private AlleTabellenVerwaltungen _alleTabellenVerwaltungen = AlleTabellenVerwaltungen.getTabellenVerwaltungInstanz();

    /** Anzahl der aktuell angefragten Archivdatenstze. */
    private int _zaehlerArchivDatenAbfrageIndex = 0;

    /** Attribut das angibt, dass eine Unterbrechung durch den Benutzer bzgl. der online Tabellendaten statt gefunden hat. */
    private boolean _unterbrechungDurchBenutzer = false;

    /** Tabellendatenstruktur. */
    private TabellenDatenStruktur _tabellenDatenStruktur = new TabellenDatenStruktur(0);

    /**
     * Variable die angibt ob die Statusinformation schon erzeugt wurde, diese wird bentigt, um in der Tabelle die
     * Statusinformation, die durch den Benutzer mittels des Start/Stopp Buttons ausgelst wird, in der richtigen Reihenfogle
     * anzuzeigen, da sonst eine Mischung der Datenstze - die vom Datenverteiler kommen - passieren kann.
     */
    private boolean _statusInfoErzeugt = false;

    /** Liste aller Spaltennamen. */
    private List<String> _spaltenNamenTyp = new ArrayList<String>();

    /** Liste aller Spaltennamen. */
    private List<String> _spaltenNamenArrayList = new ArrayList<String>();

    /**
     * RingBufferObjektliste, die Maximale Anzahl die in dem RingBuffer
     * gespeichert wird entspricht der Anzahl die mittels des Spinners
     * eingegeben wird. D.h. es werden immer genau so viele objekte im
     * RingBuffer vorgehalten.
     */
    private List<RingBufferObjekt> _ringBufferListe         = new ArrayList<RingBufferObjekt>();
    private AlleSortierungen       _instanzAlleSpalten      = AlleSortierungen.getSpaltenAuswahlInstanz();
    private AlleSortierungen       _instanzAlleSortierungen = AlleSortierungen.getSortierInstanz();
    private AlleFilter             _instanzAlleFilter       = AlleFilter.getInstanz();

    /** Variable die angibt ob weitere Datenstze aus dem Archiv angefordert werden knnen. */
    private boolean _endeArchivDatenErreicht = false;

    /**
     * Stellt fest, ob die Werte der DaV-Daten ohne Einheiten ausgegeben werden sollen.
     * (wird nur fr Archiv-Exporte verwendet.)
     */
    private boolean _datenOhneEinheit = false;

    /** ArrayList der gewhlten Knoten im Baum. */
    private List<String> _arListGewaehltenObjImBaum = new ArrayList<String>();

    /**
     * In der Map _angemeldeteSystemObjekteMapMitDatenbeschreibung sind alle
     * aktuell betrachteten Systemobjekte als Schlssel, und ihren
     * Datenbeschreibungen als Wert enthalten.
     */
    private Map<SystemObject, DataDescription> _angemeldeteSystemObjekteMapMitDatenbeschreibung = new HashMap<SystemObject, DataDescription>();

    /** Array Archivdatastream. */
    private ArchiveDataStream[] _archiveDataStream;
    private boolean             _archivErfolgreichBearbeitet;

    /** Gewhlte Attributgruppenliste. */
    private List<AttributeGroup> _atgListe;

    /** Datenverteilerverbindung. */
    private ClientDavInterface _dav;

    /** Die Datenverteiler-Konfiguration. */
    private DataModel _davKonf;

    /** Elementfilter. */
    private ElementFilter _elementFilter;

    /** GUI Instanz */
    private GTMDialogGUI _gui;

    /**
     * Tabellenverwaltungseintrag GUI Vergleichsobjekt enthlt die gerade im GUI
     * vollzogenen nderungen.
     */
    private TabellenVerwaltungEintrag _guiTabellenVerwaltungEintragVergleichsObj;
    private ArchivanfrageDatenGUIVew  _instanzArchivVew;

    /**
     * Tabellenveraltungseintag keineDarstellungGewaehltObj enthlt ein
     * initiales Vergleichsobjekt. Dieses Vergleichsobjekt wird beim initialen
     * Aufruf bentigt, um aus der Tabellendarstellung heraus direkt
     * Tabellendarstellungen speichern zu knnen.
     */
    private TabellenVerwaltungEintrag _keineDarstellungGewaehltObj;

    /** Maximalwert der Tabellenzeilen fr die dargestellten Archivdaten. */
    private int _maxAnzTabellenZeilenFuerArchiv;

    /** StringBuffer mit den gewhlten Knoten. */
    private StringBuffer _stringGewaehlteKnoten;

    /** Tabellendatenstruktur, die den aktuellen Inhalt der Tabelle reprsentiert. */
    private TabellenDatenStruktur _tabellenInhaltAktuell;

    /** Tabellenobjekt. */
    private TabellenObjekt _tabellenObjekt;

    /** Tabellendatenstruktur. */
    private TabellenDatenStruktur _tabellenStruktur;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Konstruktor.
     *
     * @param gui
     *            aufrufendes GUI
     */
    public GTMDialogGUIVerwaltung(GTMDialogGUI gui) {
        _tabellenStruktur          = _tabellenDatenStruktur;
        _ringBufferListe           = new ArrayList<RingBufferObjekt>();
        _gui                       = gui;
        _dav                       = DavDatenVew.getInstanz().getDav();
        _davKonf                   = _dav.getDataModel();
        _arListGewaehltenObjImBaum = BaumHilfsFunktionen.getPidSelektierterObj(BaumHilfsFunktionen.getListeObjekte());
    }

    //~ METHODEN ==============================================================

    /**
     * Die Methode meldet Objekte, die am Datenverteiler angemeldet sind von diesem ab.
     */
    public void abmeldenDav() {
        SystemObject systemObject;

        for (String obj : _arListGewaehltenObjImBaum) {
            systemObject = _davKonf.getObject(obj);

            if (_angemeldeteSystemObjekteMapMitDatenbeschreibung.get(systemObject) != null) {
                try {
                    _dav.unsubscribeReceiver(_gui, systemObject, _angemeldeteSystemObjekteMapMitDatenbeschreibung.get(systemObject));
                    _angemeldeteSystemObjekteMapMitDatenbeschreibung.remove(systemObject);
                }
                catch (Exception e) {
                    Log.zeigeInterneMultiMeldung(Activator.PLUGIN_ID, "Probleme beim Abmelden der Systemobejkte vom Datenverteiler.", e);

                    Shell shell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();

                    MessageDialog.openError(shell, "Fehler", "Probleme beim Abmelden der Systemobejkte vom Datenverteiler.");
                }
            }
        }
    }

    /**
     * Es wird ein RingBufferObjekt aus den bergebenen Parametern erzeugt.
     *
     * @param online  ArchiveDataKind der Daten.
     *
     * @param data
     *            Daten die aus dem Datenverteiler zu dem Objekt bergeben
     *            wurden.
     * @param attributeGroup
     *            Die Attributgruppe des Objektes.
     * @param aspect
     *            Der Aspekt.
     * @param datenZaehler
     *            Der Datenzhler des Objektes.
     * @param pidOrNameOrId
     *            Die Pid oder der Name oder die Id des Objektes.
     * @param datenZeit    datenzeit
     * @param archivDatenZeit
     *            Archivdatenzeit.
     */
    public void addObjekteRingBuffer(ArchiveDataKind online, Data data, AttributeGroup attributeGroup, Aspect aspect, int datenZaehler, String pidOrNameOrId, long datenZeit, int archivDatenZeit) {
        RingBufferObjekt ringBufferObj = new RingBufferObjekt(online, data, attributeGroup, aspect, datenZaehler, pidOrNameOrId, datenZeit, archivDatenZeit);

        _ringBufferListe.add(ringBufferObj);
    }

    /**
     * Die Methode addObjektRingBufferMitStatusInformation fgt ein Objekt dem
     * RingBuffer mit Statusinformation hinzu.
     *
     * @param statusText
     *            Statustext.
     * @param attributeGroup
     *            Attributgruppe.
     * @param aspect
     *            Aspekt.
     * @param datenZaehler
     *            Datenzhler.
     * @param pidOrNameOrId
     *            Pid oder Name oder Id des Objektes.
     * @param date
     *            Datum.
     */
    public void addObjekteRingBufferMitStatusInformation(String statusText, AttributeGroup attributeGroup, Aspect aspect, int datenZaehler, String pidOrNameOrId, long date) {
        RingBufferObjekt ringBufferObj = new RingBufferObjekt(statusText, attributeGroup, aspect, datenZaehler, pidOrNameOrId, date);

        _ringBufferListe.add(ringBufferObj);
    }

    /**
     * Die Methode prft ob sich das aktuelle GUI mit gewhltem Darstellungsnamen von dem gespeicherten GUI
     * unterscheidet.
     * @return true wenn eine nderung an der gespeicherten Darstellung im GUI statt gefunden hat, false wenn die
     * aktuelle Darstellung gleich der gespeicherten Darstellung ist.
     */
    public boolean aenderungenEinerGespeichertenDarstellung() {
        boolean aenderung = false;

        if (_alleTabellenVerwaltungen != null) {
            String dartsellung = _gui.getComboDarstellungsName().getText();

            if ((!dartsellung.equals(KEINE_DARSTELLUNG)) && (!dartsellung.equals(BENUTZERSPEZIFISCH))) {
                TabellenVerwaltung tabellenVerwaltung = _alleTabellenVerwaltungen.getTabellenVerwaltungsObjekt(dartsellung);

                if (tabellenVerwaltung != null) {
                    List<TabellenVerwaltungEintrag> tabellenVerwaltungEintrageListe = tabellenVerwaltung.getTabellenVerwaltungsEintrag();

                    guiVergleichsObjFuellen();

                    for (TabellenVerwaltungEintrag tblEintrag : tabellenVerwaltungEintrageListe) {
                        aenderung = !_guiTabellenVerwaltungEintragVergleichsObj.equals(tblEintrag);
                    }
                }
            }
        }

        return aenderung;
    }

    /**
     * Die Methode aenderungErfolgt prft fr die aktuelle Darstellung, ob sich
     * etwas bzgl. der unter dem aktuellen Darstellungsnamen gespeicherten
     * Darstellung verndert hat. Die Methode wird bei jeglicher Benutzeraktion
     * aufgerufen. Wenn eine nderung bzgl. der gespeicherten Darstellung
     * existiert wird das Button Speichern anwhlbar.
     */
    public void aenderungErfolgt() {
        boolean aenderung = false;

        if (_alleTabellenVerwaltungen != null) {
            guiVergleichsObjFuellen();

            String dartsellung = _gui.getComboDarstellungsName().getText();

            // KEINE_DARSTELLUNG
            if (dartsellung.equals(KEINE_DARSTELLUNG)) {
                if (!_guiTabellenVerwaltungEintragVergleichsObj.equals(_keineDarstellungGewaehltObj)) {
                    _gui.getComboDarstellungsName().select(_gui.getComboDarstellungsName().getItemCount() - 1);
                }
            }

            // BENUTZERSPEZIFISCH
            else if (dartsellung.equals(BENUTZERSPEZIFISCH)) {

                // guiVergleichsObjFuellen();
                System.out.println("");
            }

            // andere
            else {
                TabellenVerwaltung tabellenVerwaltung = _alleTabellenVerwaltungen.getTabellenVerwaltungsObjekt(dartsellung);

                if (tabellenVerwaltung != null) {
                    List<TabellenVerwaltungEintrag> tabellenVerwaltungEintrageListe = tabellenVerwaltung.getTabellenVerwaltungsEintrag();

                    for (TabellenVerwaltungEintrag tblEintrag : tabellenVerwaltungEintrageListe) {
                        aenderung = !_guiTabellenVerwaltungEintragVergleichsObj.equals(tblEintrag);
                    }
                }
            }

            //
            _gui.getBtnSpeichern().setEnabled(aenderung);
        }
    }

    /**
     * Die Methode aktionOeffneAbfrageDialogKnotenAuswahl ffnet einen Dialog,
     * wenn die Menge der Selektierten Objekte in der ausgewhlten
     * Darstellungsoption nicht leer ist. Dann hat der Benutzer die Mglichkeit
     * zu whlen, ob er die gespeicherten Objekte fr die aktuelle Tabelle
     * verwenden mchte oder die vorher selektierten Objekte im Baum.
     *
     * @param gewaehlteKnotenBaum
     *            Gewhlten Knoten im Baum.
     *            @param isSelektionUebernehmen Stellt fest, ob die Selektion ohne
     *                                          die Anfrage bernommen werden soll.
     */
    private void aktionOeffneAbfrageDialogKnotenAuswahl(List<String> gewaehlteKnotenBaum, boolean isSelektionUebernehmen) {
        boolean selektionAusVewUebernehmen = isSelektionUebernehmen;

        // Falls die Selektion nicht immer bernommen werden soll - Anfrage:
        if (!isSelektionUebernehmen) {

            // Dialog:
            Shell      shell      = new Shell();
            MessageBox messageBox = new MessageBox(shell, SWT.ICON_QUESTION | SWT.YES | SWT.NO);

            messageBox.setText("Knotenauswahl");
            messageBox.setMessage("Mchten Sie die Knotenauswahl der gespeicherten Darstellung bernehmen?");
            selektionAusVewUebernehmen = (messageBox.open() == SWT.YES);
        }

        //
        if (selektionAusVewUebernehmen) {
            _arListGewaehltenObjImBaum.clear();
            _arListGewaehltenObjImBaum.addAll(gewaehlteKnotenBaum);

            SystemObjectType objTypNeuGewaehlt = BaumHilfsFunktionen.bestimmeTypDerListePid(_arListGewaehltenObjImBaum);

            if (objTypNeuGewaehlt == null) {
                objTypNeuGewaehlt = BaumHilfsFunktionen.bestimmeTypDesObjektes(_davKonf.getObject(_gui.getObjTyp()));
            }

            if (objTypNeuGewaehlt != null) {
                _gui.getTxtObjTyp().setText(objTypNeuGewaehlt.getPidOrId());
            }
        }

        //
        String atg = _gui.getComboAtg().getText();
        String asp = _gui.getComboAsp().getText();

        fuelleCombo(_gui.getComboAtg(), atg);
        fuelleCombo(_gui.getComboAsp(), asp);
        fuelleTextFeldGewaehlteKnotenImBaum(_arListGewaehltenObjImBaum);
    }

    /**
     * Die Methode aktionSortierenDurchfuehren fhrt die ausgewhlte Sortierung
     * auf die Tabelle aus.
     *
     * @param sortieren
     *            Flag das angibt, ob die Checkbox ausgewhlt ist oder nicht,
     *            d.h. ob die Sortierung angewendet werden soll oder nicht.
     */
    private void aktionSortierenDurchfuehren(boolean sortieren) {
        LinkedList<SpaltenElement> listeSpaltenElemente = new LinkedList<SpaltenElement>();
        String                     sortierungsName      = _gui.getComboSortierung().getItem(_gui.getComboSortierung().getSelectionIndex());
        Sortierung                 sortierung           = _instanzAlleSortierungen.getSortierungObjekt(sortierungsName);

        if (sortierung != null) {
            for (SortierungEintrag sortierEintrag : sortierung.getSortierungEintraege()) {
                _spaltenWahl = sortierEintrag.getGewaehlteSortierObj();
            }

            for (SortierObjekt sortierObj : _spaltenWahl) {
                for (int i = 0; i < _tabellenDatenStruktur.getAlleSpaltenTitelAlsListe().size(); i++) {
                    if (_tabellenDatenStruktur.getSpaltenTitel(i).toString().equals(sortierObj.getSortierWahl())) {
                        SpaltenElement spaltenElement = _tabellenDatenStruktur.getSpaltenTitel(i);

                        spaltenElement.setAufsteigend(sortierObj.isAufsteigend());
                        listeSpaltenElemente.add(spaltenElement);
                    }
                }
            }
        }

        if (sortieren) {
            _tabellenDatenStruktur.setSortieren(true);
            _tabellenDatenStruktur.setSortierung(listeSpaltenElemente);
            _tabellenInhaltAktuell = _tabellenDatenStruktur;
            setzeTabellenInput();
        } else {
            _tabellenDatenStruktur.setSortieren(false);

            if (_gui.getTableViewer() != null) {
                if (getAnzahlZeilen(_tabellenDatenStruktur) > 0) {
                    _tabellenInhaltAktuell = _tabellenDatenStruktur;
                    setzeTabellenInput();
                }
            }
        }
    }

    /**
     * Fllt die Tabelle mit Daten. Es werden Kopfzeilen erstellt und Content-
     * bzw. LabelProvider an den {@link TableViewer} gebunden.
     */
    protected void aktionTabelleFuellen() {

        // Initialisieren der Liste der SpaltenNamen.
        _spaltenNamenArrayList = new ArrayList<String>();

        // Erzeugen eines neuen Tabellenobjektes fr die bergebenen Knoten im
        // Baum.
        _tabellenObjekt = erzeugeTabellenObj(_arListGewaehltenObjImBaum);

        // Erzeugen der ArrayList mit allen Spaltennamen.
        _spaltenNamenArrayList = _tabellenObjekt.getSpaltenNamen();

        // Initialisieren der Tabellendatenstruktur.
        _tabellenDatenStruktur = new TabellenDatenStruktur(_tabellenObjekt.getSpaltenNamen().size());

        if (!_tabelleNeu) {

            // Neu-Initialisieren der HashMap fr die Datenbernahme in ein
            // Zeilenobjekt.
            if (_tabellenObjekt.getSpo() != null) {
                _tabellenObjekt.getSpo().getMapAttributMaxWertDarzustellenderAttribute().clear();
            }
        }

        if (_gui.isTabelleSchonMalGefuellt()) {
            if (_tabellenStruktur != null) {
                loescheTabellenZeilen(ALLE);
            }
        }

        // Die Tabellendatenstruktur wird fr die gewhlten Objekte im Baum
        // sowie das tabellenobjekt erzeugt.
        _tabellenDatenStruktur = erzeugeTabellenDatenStruktur(_tabellenObjekt);

        // Die Eigenschaft ob es sich um eine nderungsdarstellung handelt oder
        // nicht wird bergeben.
        _tabellenDatenStruktur.setAenderungsDarstellung(_gui.getBtnAenderungsDarstellung().getSelection());

        // Bevor die Kopfzeile aufgebaut wird, muss sie vollstndig gelscht
        // werden.
        loescheKopfzeile();

        // erzeuge eine Kopfzeile fr die Tabelle:
        _tabellenDatenStruktur.erzeugeTabellenKopfzeile(_gui.getTableViewer(), true);

        // Beim ersten erzeugen der Tabelle muss der Content und Labelprovider
        // an die Tabelle gebunden werden.
        if (_tabelleNeu) {

            // Anbinden des ContentProviders an den TableViewer
            _gui.getTableViewer().setContentProvider(new ContentProviderTabellenDatenStruktur());

            // Anbinden des LabelProviders an den TableViewer
            _gui.getTableViewer().setLabelProvider(new LabelProviderTabellenDatenStrukturGTM());

            // Folgende Deklarationen dienen der Ermgilchung des drag und drops
            // von Tabellenspalten in der Tabelle.
            int         ops           = DND.DROP_MOVE;
            Transfer[]  dragTransfers = new Transfer[] { TextTransfer.getInstance() };
            DragAdapter dragAdapter   = new DragAdapter(_gui.getTableViewer(), _tabellenDatenStruktur);
            Transfer[]  dropTransfers = new Transfer[] { TextTransfer.getInstance() };
            DropAdapter dropAdapter   = new DropAdapter(_gui.getTableViewer(), _tabellenDatenStruktur);

            _gui.getTableViewer().addDragSupport(ops, dragTransfers, dragAdapter);
            _gui.getTableViewer().addDropSupport(ops, dropTransfers, dropAdapter);

            // Setzen des Flags ob die Tabelle schon mal gefllt wurde.
            _gui.setTabelleSchonMalGefuellt(true);

            // Setzen des Flags ob die Tabelle ganz neu aufgebaut wurde.
            _tabelleNeu = false;
        }

        // Erzeugen des Inhaltes fr konfigurierende Daten.
        if (_gui.getCheckKonfDaten().getSelection()) {
            bestimmeKonfigurierendeDaten();
        }

        setzeTabellenInputErneut();
        aktualisiereDarstellungBzglGewaehlterFilter();
        aktualisiereDarstellungBzglGewaehlterSortierung();
        aktualisiereDarstellungBzglGewaehlterSpalten();
    }

    /**
     * Die Methode aktionTabelleAktualisieren wird von dem Spinner bzgl. der
     * Anzahl der Variablen Attribute aufgerufen. Die Methode lscht alle Zeilen
     * in der aufgebauten Tabelle und baut diese vollstndig mittels des
     * RingBuffers wieder auf.
     */
    protected void aktionTabelleMitRingBufferAufbauen() {
        _tabellenObjekt        = erzeugeTabellenObj(_arListGewaehltenObjImBaum);
        _tabellenDatenStruktur = new TabellenDatenStruktur(_tabellenObjekt.getSpaltenNamen().size());
        _tabellenDatenStruktur = erzeugeTabellenDatenStruktur(_tabellenObjekt);
        _tabellenDatenStruktur.setAenderungsDarstellung(_gui.getBtnAenderungsDarstellung().getSelection());

        int anzahlSpalten = _gui.getTableViewer().getTable().getColumnCount();

        for (int i = 0; i < anzahlSpalten; i++) {
            _gui.getTableViewer().getTable().getColumn(0).dispose();
        }

        _tabellenDatenStruktur.erzeugeTabellenKopfzeile(_gui.getTableViewer(), true);

        // Anbinden des ContentProviders an den TableViewer
        _gui.getTableViewer().setContentProvider(new ContentProviderTabellenDatenStruktur());

        // Anbinden des LabelProviders an den TableViewer
        _gui.getTableViewer().setLabelProvider(new LabelProviderTabellenDatenStrukturGTM());
        _gui.setTabelleSchonMalGefuellt(true);

        // bernehme die Daten aus dem RingBuffer:
        // (for dem bernehmen muss die alte Tabelle vollstndig gelscht werden)
        loescheTabellenZeilen(ALLE);

        for (RingBufferObjekt rbObj : _ringBufferListe) {
            if (rbObj.getData() == null) {
                konvertiereDavDatenMitStatusInformation(rbObj.getStatusText(), rbObj.getPidOrNameOrId(), rbObj.getDate(), true, _gui.getCheckArchiv().getSelection());
            } else {
                konvertiereDavDatenZuZeilenObjekt(rbObj.getDataKind(), rbObj.getData(), rbObj.getPidOrNameOrId(), rbObj.getDate(), rbObj.getDateDatenArchiv(), true, _gui.getCheckArchiv().getSelection(), _gui.getSpinnerAnzahlVarAtt().getSelection());
            }
        }
    }

    /**
     * Die Methode aktualisiereDarstellungBeiFocuserhalt sorgt dafr, dass das
     * gesamte GUI mit den aktuellsten Daten verstehen wird, sobald das GUI den
     * Focus erhlt. Dazu zhlen alle Einstellungen bzgl. der Darstellung, sowie
     * auch die Anwendung der aktuellen Darstellung auf das aktuell geffnete
     * GUI.
     */
    protected void aktualisiereDarstellungBeiFocuserhalt() {
        fuelleGUIElemente(false);
        aktualisiereDarstellungBzglGewaehlterFilter();
        aktualisiereDarstellungBzglGewaehlterSortierung();
        aktualisiereDarstellungBzglGewaehlterSpalten();
    }

    /**
     * Die Methode sorgt dafr, dass basierend auf der gewhlten Filter die
     * Tabelle aktualisiert wird.
     */
    protected void aktualisiereDarstellungBzglGewaehlterFilter() {

        // Beim allerersten initialen Aufbau des Views ist der Selection Index aller Comboboxen == -1.
        if (_gui.getComboFilter().getSelectionIndex() >= 0) {

            // Initialisiere den Filter bzgl. eines selektierten Filters:
            int                 count     = 0;
            XmlFilterVerwaltung xmlFilter = new XmlFilterVerwaltung();

            _elementFilter = new ElementFilter(xmlFilter.bestimmeNaechsteFreieIdElementFilter(), _gui.getComboFilter().getItem(_gui.getComboFilter().getSelectionIndex()));

            // Einlesen des selektierten Filters.
            // Fr jede Zeile des Selektierten Filters, lege einen Regex an.
            // id = Zeilenindex, Bezeichnung = Spaltenname, RegEx = Inhalt der
            // dritten Tabellenspalte im Filter.
            Filter filter = _instanzAlleFilter.getFilterObjekt(_gui.getComboFilter().getItem(_gui.getComboFilter().getSelectionIndex()));

            if (filter != null) {
                List<FilterEintrag> filterEintraege = filter.getFilterEintraege();

                for (FilterEintrag fe : filterEintraege) {
                    ArrayList<ZeilenObjekt> tabellenZeilen = new ArrayList<ZeilenObjekt>();

                    tabellenZeilen.addAll(fe.getTabellenZeilen());

                    for (ZeilenObjekt zeile : tabellenZeilen) {
                        _elementFilter.addRegEx(new ElementRegEx(count, zeile.getAttribut(1).toString(), zeile.getAttribut(2).toString()));
                        count++;
                    }
                }

                xmlFilter.addElementFilter(_elementFilter);
            }

            // Filtere:
            if (_gui.getTableViewer() != null) {
                if ((getAnzahlZeilen(_tabellenDatenStruktur) >= 0) && (_tabellenDatenStruktur.getAnzahlAttribute()) > 0) {

                    // Setze den Filter:
                    TabellenFilter tabellenFilter = _tabellenDatenStruktur.new TabellenFilter(_tabellenDatenStruktur.getAnzahlAttribute(), _tabellenDatenStruktur);

                    for (ElementRegEx elementRegEx : _elementFilter.getRegex()) {
                        try {
                            ElementRegEx regEx;

                            regEx = elementRegEx;

                            int    id          = regEx.getId();
                            String stringRegEx = regEx.getRegEx();

                            if (stringRegEx.isEmpty()) {
                                stringRegEx = ".*";
                            }

                            FilterAusdruck filterAusdruck = _tabellenDatenStruktur.new FilterAusdruck(id, stringRegEx, _tabellenDatenStruktur);

                            tabellenFilter.setFilterAusdruck(id, filterAusdruck);
                        }
                        catch (Exception e) {
                            Shell shell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();

                            MessageDialog.openError(shell, "Fehler", String.format(  //
                                "Es sind Probleme bei der Filteranwendung aufgetreten,%s%s", NEWLINE, "bitte kontrollieren Sie die Filterangaben!"));
                        }
                    }

                    _tabellenDatenStruktur.setTabellenFilter(tabellenFilter);

                    //
                    boolean filtern = (_gui.getComboFilter().getSelectionIndex() > 0);

                    _tabellenDatenStruktur.setGefiltert(filtern);

                    try {
                        _tabellenInhaltAktuell = _tabellenDatenStruktur;
                        setzeTabellenInput();
                    }
                    catch (Exception ignored) {}
                }
            }
        }
    }

    /**
     * Die Methode sorgt dafr, dass die Tabelle basierend auf der ausgewhlten
     * Sortierungen der Combobox aktualisiert wird.
     */
    protected void aktualisiereDarstellungBzglGewaehlterSortierung() {
        if (_gui.getComboSortierung().getSelectionIndex() == 0) {
            aktionSortierenDurchfuehren(false);
        } else if (_gui.getComboSortierung().getSelectionIndex() > 0) {
            aktionSortierenDurchfuehren(true);
        }
    }

    /**
     * Die Methode sorgt dafr, dass basierend auf der Auswahl mittels der
     * Combobox Spalten die Tabelle dementsprechend angepasst wird.
     */
    protected void aktualisiereDarstellungBzglGewaehlterSpalten() {
        if (_gui.getComboSpalten().getSelectionIndex() == 0) {
            spaltenAuswahl(false);
        } else if (_gui.getComboSpalten().getSelectionIndex() > 0) {
            spaltenAuswahl(false);
            spaltenAuswahl(true);
        }
    }

    /**
     * Jedes ausgewhlte Objekt im Baum muss beim Datenverteiler angemeldet
     * werden, was ber diese Methode realisiert wird.
     *
     * @param aspPid
     *            Pid des Aspektes.
     * @param atgPid
     *            Pid der Attributgruppe.
     */
    private void anmeldenDav(String atgPid, String aspPid) {
        SystemObject   systemObject = null;
        AttributeGroup attributgruppe;
        Aspect         aspekt;

        // ReceiveOptions  anmeldeoptionen = ReceiveOptions.normal();
        ReceiveOptions  anmeldeoptionen = ReceiveOptions.delayed();
        ReceiverRole    empfaengerrolle = ReceiverRole.receiver();
        DataDescription datenbeschreibung;

        _angemeldeteSystemObjekteMapMitDatenbeschreibung.clear();

        for (String obj : _arListGewaehltenObjImBaum) {
            long gewaehlteObjId = 0;

            try {
                gewaehlteObjId = Long.parseLong(obj);
            }
            catch (NumberFormatException ignored) {}

            if (_davKonf.getObject(gewaehlteObjId) != null) {
                systemObject = _davKonf.getObject(gewaehlteObjId);
            } else if (_davKonf.getObject(obj) != null) {
                systemObject = _davKonf.getObject(obj);
            } else {
                Log.zeige(Log.erzeugeMeldung(Log.WARNUNG, Activator.PLUGIN_ID, String.format("Das Objekt existiert nicht: %s", obj)));
            }

            attributgruppe    = _davKonf.getAttributeGroup(atgPid);
            aspekt            = _davKonf.getAspect(aspPid);
            datenbeschreibung = new DataDescription(attributgruppe, aspekt);

            // Anmelden zum Empfang der Daten
            Shell shell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();

            if (systemObject == null) {
                MessageDialog.openError(shell, "Fehler", "Das angegebene SystemObjekt existiert nicht!");
            } else {
                try {
                    _dav.subscribeReceiver(_gui, systemObject, datenbeschreibung, anmeldeoptionen, empfaengerrolle);
                    _angemeldeteSystemObjekteMapMitDatenbeschreibung.put(systemObject, datenbeschreibung);
                }
                catch (Exception e) {
                    MessageDialog.openError(shell, "Fehler", "Die Objekte konnten nicht beim Datenverteiler angemeldet werden! ");
                }
            }
        }
    }

    @Override
    public void archivGuiDatenGeaendert() {
        aenderungErfolgt();
    }

    /**
     * Bearbeite die Archivdaten aus dem Ergebnis-Array der Archivanfrage {@link #_archiveDataStream}.
     * Es werden die Daten ab dem Index {@link #_zaehlerArchivDatenAbfrageIndex}} bearbeitet
     * bis das Ende des Arrays erreicht wird oder die Anzahl der bearbeiteten Daten das Maximum
     * (s.Parameter) erreicht hat.
     *
     * @param maxAnzDaten Maximale Anzahl der Archiv-Daten, die aus dem Archiv abgeholt werden.
     * @param istTabelleNeuLaden Stellt fest, ob die Tabelle neu geladen werden soll
     * (d.h. die Archivdaten in der Tabelle dargestellt werden sollen).
     *
     * @return true, falls die Aktion erfolgreich war, false - sonst.
     */
    private boolean bearbeiteArchiveDaten(final int maxAnzDaten, final boolean istTabelleNeuLaden) {
        _archivErfolgreichBearbeitet = false;

        // --------------------------------------------------------------------------------
        // Erstelle den WartenDialog:
        final ProgressMonitorDialog dialog = new ProgressMonitorDialog(Display.getDefault().getActiveShell()) {
            @Override
            protected void createCancelButton(Composite parent) {

                // super.createCancelButton(parent);
                // getButton(CANCEL).setText("Abbrechen");
            }
        };

        // GUI-Wert hier abgeholt, damit Exception (Invalid thread access) nicht auftritt:
        final int anzahlVarAtt = _gui.getSpinnerAnzahlVarAtt().getSelection();

        // --------------------------------------------------------------------------------
        //
        IRunnableWithProgress run = new IRunnableWithProgress() {
            @Override
            public void run(IProgressMonitor monitor) throws InvocationTargetException, InterruptedException {
                try {
                    monitor.beginTask("Bearbeitung der Archivdaten...", IProgressMonitor.UNKNOWN);

                    // --------------------------------------------------------------------------------
                    // Ermittle die Daten aus dem Archiv und speichere die intern in der Liste:
                    monitor.subTask("Ermittle die Archivdaten...");

                    List<ArchiveData> listeArchiveData = new ArrayList<ArchiveData>();

                    // Jedes aus dem Archiv empfangene Objekt wird in der Liste gespeichert:
                    if (_archiveDataStream != null) {
                        for (int i = _zaehlerArchivDatenAbfrageIndex; i < _archiveDataStream.length; i++) {
                            ArchiveData archivDaten;

                            archivDaten = _archiveDataStream[i].take();

                            while ((archivDaten != null) && (listeArchiveData.size() < maxAnzDaten)) {
                                listeArchiveData.add(archivDaten);
                                archivDaten = _archiveDataStream[i].take();
                            }

                            if ((i == _archiveDataStream.length - 1) && (archivDaten == null)) {
                                _endeArchivDatenErreicht = true;
                            }

                            if ((_endeArchivDatenErreicht) || (listeArchiveData.size() == maxAnzDaten)) {
                                _zaehlerArchivDatenAbfrageIndex = i;
                                _gui.setStart(false);

                                break;
                            }
                        }
                    }

                    // --------------------------------------------------------------------------------
                    // Fr jedes aus dem Archiv empfangene Objekt wird ein Zeilenobjekt erzeugt:
                    monitor.subTask("Konvertiere die Archivdaten in die Tabellenobjekte...");

                    for (ArchiveData archivDaten : listeArchiveData) {
                        if (!(archivDaten.getDataType().toString().equals(NUTZDATEN))) {
                            String statusText = DavDatenVew.getInstanz().bestimmeStatusText(archivDaten.getDataType());

                            konvertiereDavDatenMitStatusInformation(statusText, archivDaten.getObject().getPidOrNameOrId(), archivDaten.getDataTime(), false, true);
                        } else {
                            konvertiereDavDatenZuZeilenObjekt(archivDaten.getDataKind(), archivDaten.getData(), archivDaten.getObject().getPidOrNameOrId(), archivDaten.getDataTime(), archivDaten.getArchiveTime(), false, true, anzahlVarAtt);
                        }
                    }

                    // --------------------------------------------------------------------------------
                    // Aktualisiere das GUI:
                    if (istTabelleNeuLaden) {
                        monitor.subTask("Aktualisiere die Tabelle...");

                        // Falls der Archiv in Teilen in der Tabelle dargestellt wird und ber das Button 'Start' nachgeliefert:
                        Display.getDefault().syncExec(new Runnable() {
                            @Override
                            public void run() {
                                _gui.getBtnStartStopp().setEnabled(!_endeArchivDatenErreicht);
                            }
                        });

                        // Zeige die Archivdaten in der Tabelle:
                        tabelleNeuLaden();
                    }

                    _archivErfolgreichBearbeitet = true;
                }
                catch (Exception e) {
                    Log.zeigeInterneMultiMeldung(Activator.PLUGIN_ID, "Probleme bei der Archivdatenverarbeitung.", e);
                    Display.getDefault().syncExec(new Runnable() {
                        @Override
                        public void run() {
                            MessageDialog.openError(_gui.getShell(), "Fehler", "Probleme bei der Archivdatenverarbeitung.");
                        }
                    });
                }
            }
        };

        // --------------------------------------------------------------------------------
        // ffne den WartenDialog:
        try {
            dialog.run(true, true, run);
        }
        catch (Exception e) {
            Log.zeigeInterneMultiMeldung(Activator.PLUGIN_ID, "Probleme bei der Archivdatenverarbeitung.", e);
            MessageDialog.openError(_gui.getShell(), "Fehler", "Probleme bei der Archivdatenverarbeitung.");
        }

        return _archivErfolgreichBearbeitet;
    }

    /**
     * Auswertung der Konfigurationsdaten.
     */
    private void bestimmeKonfigurierendeDaten() {
        DataModel      konfiguration = DavDatenVew.getInstanz().getDav().getDataModel();
        Data[]         konfigurierendeDaten;
        AttributeGroup atgSelektiert = konfiguration.getAttributeGroup(_gui.getComboAtg().getText());
        int            zaehler       = 0;
        Date           date          = new Date();

        // Wenn alle ausgewhlt werden sollen.
        List<SystemObject> gewaehlteSystemObjekte = new ArrayList<SystemObject>();

        for (String gewaehlteObj : _arListGewaehltenObjImBaum) {
            _davKonf.getObject(gewaehlteObj);
            gewaehlteSystemObjekte.add(_davKonf.getObject(gewaehlteObj));
        }

        for (SystemObject so : gewaehlteSystemObjekte) {
            Aspect             aspGewaehlt = null;
            List<SystemObject> listSo      = new ArrayList<SystemObject>();

            listSo.add(so);

            for (Aspect asp : BaumHilfsFunktionen.bestimmeAspekte(atgSelektiert, true)) {
                if (asp.getPid().equals(_gui.getComboAsp().getText())) {
                    aspGewaehlt = asp;
                }
            }

            if ((atgSelektiert != null) && (aspGewaehlt != null)) {
                konfigurierendeDaten = konfiguration.getConfigurationData(listSo, atgSelektiert, aspGewaehlt);

                if (konfigurierendeDaten != null) {
                    for (Data konfData : konfigurierendeDaten) {
                        if (konfData != null) {
                            zaehler++;
                            konvertiereDavDatenZuZeilenObjekt(ArchiveDataKind.ONLINE, konfData, so.getPidOrNameOrId(), date.getTime(), 0, true, _gui.getCheckArchiv().getSelection(), _gui.getSpinnerAnzahlVarAtt().getSelection());
                            addObjekteRingBuffer(ArchiveDataKind.ONLINE, konfData, atgSelektiert, aspGewaehlt, zaehler++, so.getPidOrNameOrId(), date.getTime(), 0);
                        } else {
                            konvertiereDavDatenMitStatusInformation("keine Daten", so.getPidOrNameOrId(), date.getTime(), true, _gui.getCheckArchiv().getSelection());
                        }
                    }
                } else {
                    konvertiereDavDatenMitStatusInformation("keine Daten", so.getPidOrNameOrId(), date.getTime(), true, _gui.getCheckArchiv().getSelection());
                }
            }
        }
    }

    /**
     * Die Methode bestimmeSpaltenAuswahl bestimmt die Spaltenauswahl fr die
     * aktuell gewhlte Sortierung.
     *
     * @return Liste der aktuell gewhlten Spaltennamen.
     */
    private List<String> bestimmeSpaltenAuswahl() {
        List<String> spaltenAuswahl = new ArrayList<String>();
        String       soName         = _gui.getSelektierteSpalte();

        if ((soName.equals(KEINE_SPALTENAUSWAHL)) && (_spaltenNamenArrayList != null)) {
            if (_gui.getCheckArchiv().getSelection()) {
                spaltenAuswahl.addAll(Arrays.asList(_arArchivSpaltenAuswahl));
            } else {
                spaltenAuswahl.addAll(Arrays.asList(_arNormalSpaltenAuswahl));
            }

            spaltenAuswahl.addAll(_spaltenNamenArrayList);
        } else {
            for (String spaltenName : _instanzAlleSpalten.getSortierungArray()) {
                Sortierung spalte = _instanzAlleSpalten.getSortierungObjekt(spaltenName);

                if (spalte.getSortierungName().equals(soName)) {
                    List<SortierungEintrag> spaltenEintraege = spalte.getSortierungEintraege();

                    for (SortierungEintrag se : spaltenEintraege) {
                        spaltenAuswahl.addAll(se.getGewaehlteZeilen());
                    }
                }
            }
        }

        return spaltenAuswahl;
    }

    /**
     * Die Methode bestimmt anhand der gewhlten Objekte die zugehrigen Datenverteiler
     * Systemobjekte.
     * @return Collection der gewhlten Objekte.
     */
    private Collection<Object> bestimmeSystemObjekteDerGewaehltenObjekte() {
        Collection<Object> gewaehlteSystemObjekte = new ArrayList<Object>();
        long               gewaehlteObjId         = 0;

        for (String gewaehlteObj : _arListGewaehltenObjImBaum) {
            try {
                gewaehlteObjId = Long.parseLong(gewaehlteObj);
            }
            catch (NumberFormatException ignored) {}

            if (_davKonf.getObject(gewaehlteObjId) != null) {
                gewaehlteSystemObjekte.add(_davKonf.getObject(gewaehlteObjId));
            } else if (_davKonf.getObject(gewaehlteObj) != null) {
                gewaehlteSystemObjekte.add(_davKonf.getObject(gewaehlteObj));
            } else {
                Log.zeige(Log.erzeugeMeldung(Log.WARNUNG, Activator.PLUGIN_ID, String.format("Das Objekt existiert nicht: %s", gewaehlteObj)));
            }
        }

        return gewaehlteSystemObjekte;
    }

    /**
     * Die Methode bestimmeZeilenObjekt bestimmt fr die gegebenen Daten das
     * zugehrige Zeilenobjekt.
     *
     * @param data
     *            Dataobjekt.
     * @param listZeilenInhalt
     *            die Liste die alle Werte der Zeile enthlt und jeweils
     *            erweitert wird.
     * @param pref
     *            Prfix der zur Bestimmung der Attributanzahl im Array
     *            verwendet wird. Das Prfix wird analog zum Prfix der
     *            Spaltennamen aufgebaut, so dass hier auf Informationen die
     *            beim Spaltenaufbau zur Verfgung stehen (Ob es sich bei dem
     *            Attribut um ein variables oder festes Attribut handelt)
     *            insofern verwendet werden knnen, dass sie aus der HashMap
     *            ausgelesen werden knnen, in der diese Information enthalten
     *            ist.
     * @param ersterDurchlauf
     *            Kennzeichnung die angibt, ob es sich um den ersten durchlauf
     *            handelt, diese Information wird bentigt, um den ersten Prfix
     *            zu eliminieren, da dieser bei der Spaltenerzeugung nicht
     *            verwendet wird.
     * @param teilStringNichtRelevant
     *            der initial bestimmte Teilstring, der bei jedem neu erzeugten
     *            Prfix eliminiert werden muss.
     * @param anzahlVarAtt
     *                    Anzahl der variablen Attributte (Parameter muss angegeben werden,
     *                    damit in der Methode kein Zugriff auf GUI passiert).
     *
     * @return die Liste mit dem gesatmen Zeileninhalt.
     */
    private ArrayList<String> bestimmeZeilenObjektInhaltAlsListe(Data data, ArrayList<String> listZeilenInhalt, String pref, boolean ersterDurchlauf, String teilStringNichtRelevant, int anzahlVarAtt) {

        // Initialisieren des Schleifenabbruchkriteriums fr Array Elemente.
        int maximum_AnzuzeigenderVariablerAttribute_DatenArrayLength;

        // Beim ersten Aufruf der Methode wird der Prfix mit dem Namen der
        // Attributgruppe gebildet, z.B. atg.tlsAxlErgnzendeDeFehlerMeldung,
        // der fr die Betrachtung der Prfixe der Spalten nicht relevant ist.
        // Dementsprechend muss dieser erste Prfix aus der Betrachtung
        // eliminiert werden.
        if (ersterDurchlauf) {
            teilStringNichtRelevant = data.getName() + ".";
        }

        if (data.isArray()) {
            Array datenArray = data.asArray();

            // Bestimmung des relevante Teilstrings - d.h. ohne das erste
            // Attribut - mit Erzeugung des in diesem Schleifendurchlauf
            // relevanten Prfixes.
            String relevanteTeilString = pref.replace(teilStringNichtRelevant, "");

            relevanteTeilString = BaumVerwaltung.getInstanz().erzeugePrefixFuerSpaltenNamen(relevanteTeilString, data.getName());

            Set<String> listeAllerSchluessel = _tabellenObjekt.getSpo().getMapAttributMaxWertDarzustellenderAttribute().keySet();

            // Wenn maxAnzahlVarAtt == 0 ist, dann wird der Inhalt des Array's
            // vollstndig in das Feld bernommen.
            // In der HashMap befinden sich nur die Prfixe der Arrayelemente,
            // wenn der maximal Wert > 0.
            // Der maximal Wert fr das Arrayelement ist > 0, wenn die Bedingung
            // Anzahl der Elemente des Attributes > 0 ist, und die Anzahl fest
            // ist.
            if ((anzahlVarAtt == 0) &&!(_tabellenObjekt.getSpo().getMapAttributMaxWertDarzustellenderAttribute().containsKey(relevanteTeilString))) {
                listZeilenInhalt.add(datenArray.toString());
            } else {
                if (listeAllerSchluessel.contains(relevanteTeilString)) {
                    maximum_AnzuzeigenderVariablerAttribute_DatenArrayLength = _tabellenObjekt.getSpo().getMapAttributMaxWertDarzustellenderAttribute().get(relevanteTeilString);
                } else {
                    maximum_AnzuzeigenderVariablerAttribute_DatenArrayLength = anzahlVarAtt;
                }

                for (int zaehlerAnzahlAtt = 0; zaehlerAnzahlAtt < maximum_AnzuzeigenderVariablerAttribute_DatenArrayLength; zaehlerAnzahlAtt++) {
                    if ((datenArray.getLength() >= maximum_AnzuzeigenderVariablerAttribute_DatenArrayLength)) {
                        if ((datenArray.getItem(zaehlerAnzahlAtt).isList()) || (datenArray.getItem(zaehlerAnzahlAtt).isArray())) {
                            String zaehler = String.format("[%s]", zaehlerAnzahlAtt);
                            String prefixAtt;

                            prefixAtt = BaumVerwaltung.getInstanz().erzeugePrefixFuerSpaltenNamen(pref, String.format("%s%s", data.getName(), zaehler));
                            bestimmeZeilenObjektInhaltAlsListe(datenArray.getItem(zaehlerAnzahlAtt), listZeilenInhalt, prefixAtt, false, teilStringNichtRelevant, anzahlVarAtt);
                        } else if (datenArray.getItem(zaehlerAnzahlAtt).isPlain()) {
                            listZeilenInhalt.add(datenArray.getItem(zaehlerAnzahlAtt).valueToString());
                        }
                    } else if ((datenArray.getLength() < maximum_AnzuzeigenderVariablerAttribute_DatenArrayLength)) {
                        ArrayList<String> listeZeilenVorBestimmungDerElemente  = new ArrayList<String>();
                        ArrayList<String> listeZeilenNachBestimmungDerElemente = new ArrayList<String>();
                        int               differenzAnzahlElemente;

                        if (zaehlerAnzahlAtt < datenArray.getLength()) {
                            if (zaehlerAnzahlAtt == 0) {
                                listeZeilenVorBestimmungDerElemente.addAll(listZeilenInhalt);
                            }

                            String zaehler = String.format("[%s]", zaehlerAnzahlAtt);
                            String prefixAtt;

                            prefixAtt = BaumVerwaltung.getInstanz().erzeugePrefixFuerSpaltenNamen(pref, String.format("%s%s", data.getName(), zaehler));
                            bestimmeZeilenObjektInhaltAlsListe(datenArray.getItem(zaehlerAnzahlAtt), listZeilenInhalt, prefixAtt, false, teilStringNichtRelevant, anzahlVarAtt);

                            if (zaehlerAnzahlAtt == 0) {
                                listeZeilenNachBestimmungDerElemente.addAll(listZeilenInhalt);
                                differenzAnzahlElemente = listeZeilenNachBestimmungDerElemente.size() - listeZeilenVorBestimmungDerElemente.size();

                                Map<String, Integer> mapArrayElementNameWAnzahlFelderDesElementes = new HashMap<String, Integer>();

                                mapArrayElementNameWAnzahlFelderDesElementes.put(data.getName(), differenzAnzahlElemente);
                                _tabellenObjekt.getSpo().setMapArrayElementNameWAnzahlFelderDesElementes(mapArrayElementNameWAnzahlFelderDesElementes);
                            }
                        } else {
                            Map<String, Integer> mapArrayElementeAnzahlFelder = new HashMap<String, Integer>();

                            mapArrayElementeAnzahlFelder.putAll(_tabellenObjekt.getSpo().getMapArrayElementNameWAnzahlFelderDesElementes());

                            if (!mapArrayElementeAnzahlFelder.isEmpty()) {
                                int anzahlLeerFelder = mapArrayElementeAnzahlFelder.get(data.getName());

                                for (int i = 0; i < anzahlLeerFelder; i++) {
                                    listZeilenInhalt.add("");
                                }
                            }
                        }
                    }
                }
            }
        } else if (data.isList()) {
            Iterator<?> iterator = data.iterator();

            while (iterator.hasNext()) {
                Data   nextDataInList = (Data) iterator.next();
                String prefixAtt;

                prefixAtt = BaumVerwaltung.getInstanz().erzeugePrefixFuerSpaltenNamen(pref, data.getName());
                bestimmeZeilenObjektInhaltAlsListe(nextDataInList, listZeilenInhalt, prefixAtt, false, teilStringNichtRelevant, anzahlVarAtt);
            }
        } else if (data.isPlain()) {

            // ohne Einhet:
            if (_datenOhneEinheit) {
                listZeilenInhalt.add(data.asTextValue().getValueText());
            }

            // mit Einheit:
            else {
                listZeilenInhalt.add(data.valueToString());
            }
        }

        return listZeilenInhalt;
    }

    @Override
    public void btnArchivanfrageExportCsvOhneEinheitSelektiert() {
        _datenOhneEinheit = true;
        btnArchivanfrageExportCsvSelektiert();
        _datenOhneEinheit = false;
    }

    @Override
    public void btnArchivanfrageExportCsvSelektiert() {
        _gui.getBtnStartStopp().setEnabled(false);

        // Starte die Archivanfrage und bearbeite alle Archivdaten:
        if (starteArchivanfrage(Integer.MAX_VALUE, false)) {

            // Export der Daten in die Datei:
            btnExportInCsv();
        }
    }

    @Override
    public void btnArchivanfrageExportHtmlOhneEinheitSelektiert() {
        _datenOhneEinheit = true;
        btnArchivanfrageExportHtmlSelektiert();
        _datenOhneEinheit = false;
    }

    @Override
    public void btnArchivanfrageExportHtmlSelektiert() {
        _gui.getBtnStartStopp().setEnabled(false);

        // Starte die Archivanfrage und bearbeite alle Archivdaten:
        if (starteArchivanfrage(Integer.MAX_VALUE, false)) {

            // Export der Daten in die Datei:
            btnExportInHtml();
        }
    }

    @Override
    public void btnArchivanfrageSelektiert() {

        //
        _maxAnzTabellenZeilenFuerArchiv = _gui.getSpinnerMaxZeilen().getSelection();

        // Starte die Archivanfrage, bearbeite die maximal angegebene Anzahl der Archivdaten
        // und stelle die Daten in der Tabelle dar:
        starteArchivanfrage(_maxAnzTabellenZeilenFuerArchiv, true);
    }

    /**
     * Die Methode btnDrucken wird von der Schaltflche Drucken aufgerufen und
     * sorgt dafr, dass der aktuelle Tabelleninhalt ausgedruckt wird.
     */
    public void btnDrucken() {

        // Exportiere Protokolle in die Tempdatei.
        // Erstelle die Tempdatei mit dem ISOZeitstempel:
        String dateiName = String.format("%s%sprotokolle_%s.csv", OrdnerEinstellungen.ermittleTempOrdner(), FILESEPARATOR, DatumFunktionen.erstelleISOZeitStempel());

        // Title:
        String titel = String.format("TLS Sicht Tabelle %n%n%n%nFilter:  %s %nSortierung:  %s %nSpaltenauswahl:  %s %n%n",  //
                                     _gui.getComboFilter().getItem(_gui.getComboFilter().getSelectionIndex()),              //
                                     _gui.getComboSortierung().getItem(_gui.getComboSortierung().getSelectionIndex()),      //
                                     _gui.getComboSpalten().getItem(_gui.getComboSpalten().getSelectionIndex()));

        // Title fr die Tabelle:
        List<String>  spaltenAuswahl = bestimmeSpaltenAuswahl();
        StringBuilder tabTitel       = new StringBuilder();

        for (String spaltenName : spaltenAuswahl) {
            tabTitel.append(String.format("%s%s", spaltenName, TRENN_ZEICHEN));
        }

        tabTitel.append(NEWLINE);

        // Exportiere das aktuelle Protokoll in die Datei im CSV-Format:
        boolean erfolgreich = true;

        try {
            FileWriter out = new FileWriter(dateiName);

            out.write(titel);
            out.write(tabTitel.toString());

            LinkedList<ITabellenZeile> alleZeilen         = _tabellenStruktur.getZeilen();
            int[]                      spaltenreihenfolge = _gui.getTableViewer().getTable().getColumnOrder();

            for (ITabellenZeile zeilenObj : alleZeilen) {
                for (int j = 0; j < spaltenAuswahl.size(); j++) {
                    out.write(zeilenObj.getAttribut(spaltenreihenfolge[j]).toString());
                    out.write(TRENN_ZEICHEN);
                }

                out.write(NEWLINE);
            }

            out.close();
        }
        catch (IOException e) {
            erfolgreich = false;
            Log.zeigeInterneMeldung(Activator.PLUGIN_ID, e);
        }

        // Exportiere Protokolle in die Datei:
        if (!erfolgreich) {
            MessageDialog.openError(_gui.getShell(), "Fehler", "Es ist ein Fehler aufgetreten. (s. Meldung unten)!" + NEWLINE + NEWLINE + "berprfen Sie, ob die Datei <" + dateiName + "> geschlossen ist.");
            dateiName = "";
        }

        // Drucke die Tempdatei:
        if (!dateiName.isEmpty()) {
            StandardAktionen.aufrufenStandardWindowsAktionFuerDatei(StandardAktionen.OEFFNEN, dateiName, false, "csv", OrdnerEinstellungen.ermittleTempOrdner());
        }
    }

    /**
     * Die Methode ruft die exportiermethode auf und bergibt dieser den
     * Parameter mit der Information, dass ein csv Dokument erstellt werden
     * soll.
     */
    public void btnExportInCsv() {
        export("csv");
    }

    /**
     * Die Methode ruft die Exportmethode auf und bergibt dieser den Parameter
     * mit der Information, dass ein html Dokument erstellt werden soll.
     */
    public void btnExportInHtml() {
        export("html");
    }

    /**
     * Die Methode btnSpeichernUnter speichert die aktuell gewhlten
     * Darstellungsoptionen unter dem aktuell selektiertem Darstellungsnamen.
     */
    public void btnSpeichern() {

        // Prfe Recht:
        boolean recht = RechteVew.getInstanz().istFunktionFuerAngemeldetenBenutzerErlaubt(AktionenGTM.FUNKTION_ID_TABELLENVERWALTUNG);

        if (!recht) {
            MessageDialog.openWarning(_gui.getShell(), "Achtung", String.format(  //
                "Sie haben kein Recht die Tabellendarstellungen zu bearbeiten!%s%sDie Tabellendarstellung wird nicht gespeichert!", NEWLINE, NEWLINE));

            return;
        }

        //
        if (MessageDialog.openQuestion(_gui.getShell(), "Speichern",  //
                                       "Soll die aktuelle Darstellung unter dem gewhlten Darstellungsnamen gespeichert werden?")) {
            speicherAktuelleDarstellungsOption(_gui.getComboDarstellungsName().getText());
            aenderungErfolgt();
        }
    }

    /**
     * Die Methode btnSpeichernUnter wird von der Schaltflche Speichern aufgerufen,
     * wenn diese bettigt wird. Die Methode ffnet einen kleinen Dialog in dem
     * der Benutzer die Mglichkeit hat einen Namen anzugeben, unter dem die
     * aktuelle Darstellung gespeichert werden soll.
     */
    public void btnSpeichernUnter() {

        // Prfe Recht:
        boolean recht = RechteVew.getInstanz().istFunktionFuerAngemeldetenBenutzerErlaubt(AktionenGTM.FUNKTION_ID_TABELLENVERWALTUNG);

        if (!recht) {
            MessageDialog.openWarning(_gui.getShell(), "Achtung", String.format(  //
                "Sie haben kein Recht die Tabellendarstellungen zu bearbeiten!%s%sDie Tabellendarstellung wird nicht gespeichert!", NEWLINE, NEWLINE));

            return;
        }

        //
        guiVergleichsObjFuellen();

        // Definiere den Validator:
        IInputValidator validator = new IInputValidator() {
            @Override
            public String isValid(String text) {
                text = text.trim();

                if (text.length() == 0) {
                    return "";
                } else if ((text.equals(BENUTZERSPEZIFISCH)) || (text.equals(KEINE_DARSTELLUNG))) {
                    return "Der Name ist ungltig !";
                } else if (_alleTabellenVerwaltungen.getTabellenVerwaltungsObjekt(text) != null) {
                    return "Der Name existiert schon !";
                }

                return null;
            }
        };

        // Definiere den Dialog:
        InputDialog inputDialog = new InputDialog(_gui.getShell(), "Speichern", "Bitte geben Sie den Darstellungsnamen ein", "", validator);

        // ffne den Dialog:
        if (inputDialog.open() == Dialog.OK) {

            // Merke den eingegebenen Namen:
            String darstellung = inputDialog.getValue().trim();

            // Speichere die Einstellung:
            speicherAktuelleDarstellungsOption(darstellung);

            // Passe das Combo an:
            erzeugeComboboxDarstellungsName();
            _gui.getComboDarstellungsName().setText(darstellung);
            GewaehlteDarstellung.getInstanz().setGewaehlteDarstellung(darstellung);

            //
            aenderungErfolgt();
        }
    }

    /**
     * Die Methode btnStartStopp reagiert auf die Bettigung der Schaltflche
     * Start/Stopp. Je nach Modus (start oder stopp) werden die Schaltflchen
     * Drucken, Export in html, Export in csv bettigbar. Zudem lst die Methode
     * eine aktualisierung der gerade dargestellten Tabelle bzgl. der Filter,
     * Sortierung wie auch Spaltenauswahl aus.
     */
    public void btnStartStopp() {
        if (_gui.getCheckArchiv().getSelection() || _gui.getCheckKonfDaten().getSelection()) {
            _gui.setStart(false);
        } else {
            setzteAbhaengigeButtonsNormalModus();
        }

        // Die fr die Tabelle angemeldeten Objekte werden vom Datenverteiler abgemeldet werden, wenn der Stopp Modus gewhlt wird,
        // umgekehrt sonst.
        if (_gui.getCheckArchiv().getSelection()) {
            if (!_endeArchivDatenErreicht) {
                loescheTabellenZeilen(ARCHIV_50_PROZENT);
                bearbeiteArchiveDaten(_gui.getSpinnerMaxZeilen().getSelection() - getAnzahlZeilen(_tabellenStruktur), true);
                _maxAnzTabellenZeilenFuerArchiv = _gui.getSpinnerMaxZeilen().getSelection();
            }
        } else {
            if (_gui.isStart()) {
                _gui.update(null);

                if ((_gui.getComboAtg().getSelectionIndex() != -1) && (_gui.getComboAsp().getSelectionIndex() != -1)) {
                    anmeldenDav(_gui.getComboAtg().getText(), _gui.getComboAsp().getText());
                    _gui.getCheckArchiv().setEnabled(false);
                    _gui.getCheckKonfDaten().setEnabled(false);
                    aktualisiereDarstellungBzglGewaehlterFilter();
                    aktualisiereDarstellungBzglGewaehlterSortierung();
                    aktualisiereDarstellungBzglGewaehlterSpalten();
                } else {
                    _gui.getBtnStartStopp().setEnabled(false);
                }
            } else {
                abmeldenDav();

                try {
                    Thread.sleep(500);
                }
                catch (InterruptedException e) {
                    e.printStackTrace();
                }

                _gui.getCheckArchiv().setEnabled(true);
                _gui.getCheckKonfDaten().setEnabled(true);
                _gui.update(null);
            }
        }
    }

    /**
     * Die Methode sorgt dafr, dass sich der View zur Verwaltung der
     * Tabellenoptionen ffnet.
     */
    public void btnVerwOeffnen() {
        GewaehlteDarstellung.getInstanz().setGewaehlteDarstellung(_gui.getComboDarstellungsName().getText());

        if (PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().findView(ViewTabellenVerwaltung.ID) != null) {
            GuiFunktionen.schliesseSicht(ViewTabellenVerwaltung.ID);
        }

        if (AktionenVew.getInstanz().ausfuehrenAktion(AktionenGTM.COMMAND_ID_TABELLENVERWALTUNG) != null) {
            MessageDialog.openWarning(_gui.getShell(), "Achtung", "Sie haben kein Recht mit dem GUI 'Tabellenverwaltung' zu arbeiten!");
        }
    }

    /**
     * Die Methode setzt alle abhngigkeiten im GUI bzgl. der Wahl Archivdatenanfrage.
     */
    public void checkArchivDaten() {
        if (_gui.getCheckArchiv().getSelection()) {
            _gui.getCheckKonfDaten().setSelection(false);
            initialisiereBzglArchivOderKonfDaten();

            // Wenn die Checkbox ausgewhlt ist, wird der Bereich fr die
            // Archivanfrage angezeigt.
            _gui.anzeigenArchivBereich(true);
            setzeArchivabhaengigeButtons(true);
        } else {
            _gui.anzeigenArchivBereich(false);
            setzeArchivabhaengigeButtons(false);
        }

        aenderungErfolgt();
    }

    /**
     * Die Methode setzt das GUI bzgl. konfigurierender Daten.
     */
    public void checkKonfDaten() {
        if (_gui.getCheckKonfDaten().getSelection()) {
            _gui.getCheckArchiv().setSelection(false);
            _gui.anzeigenArchivBereich(false);
            erlaubeDruckenUndExport(true);
        } else {
            erlaubeDruckenUndExport(false);
        }

        initialisiereBzglArchivOderKonfDaten();
    }

    /**
     * Methode erlaubt unabhngig vom Startbutton das Drucken wie auch die
     * Export funktionalitten.
     * @param erlauben  variable gibt an, ob Schaltflchen bettigbar sein sollen oder nicht.
     */
    private void erlaubeDruckenUndExport(boolean erlauben) {
        _gui.getBtnDrucken().setEnabled(erlauben);
        _gui.getBtnExportInCsv().setEnabled(erlauben);
        _gui.getBtnExportInHtml().setEnabled(erlauben);
    }

    /**
     * Die Methode fuelleComobDarstellungsName fllt die Combobox beim Aufbau
     * mit allen existierenden Darstellungen.
     */
    protected void erzeugeComboboxDarstellungsName() {
        ArrayList<String>    list = new ArrayList<String>();
        List<AttributeGroup> atgListe;
        Collection<Object>   gewaehlteSystemObjekte;

        gewaehlteSystemObjekte = bestimmeSystemObjekteDerGewaehltenObjekte();

        //
        boolean istKonf;

        try {
            istKonf = _gui.getCheckKonfDaten().getSelection();
        }
        catch (Exception e) {
            istKonf = false;
        }

        boolean istArchiv;

        try {
            istArchiv = _gui.getCheckArchiv().getSelection();
        }
        catch (Exception e) {
            istArchiv = false;
        }

        //
        atgListe = BaumHilfsFunktionen.bestimmeAttributgruppen(gewaehlteSystemObjekte, istKonf);

        for (String darstellungsName : _alleTabellenVerwaltungen.getTabellenVerwaltungArray()) {
            List<TabellenVerwaltungEintrag> tblEintraege = _alleTabellenVerwaltungen.getTabellenVerwaltungsObjekt(darstellungsName).getTabellenVerwaltungsEintrag();

            for (TabellenVerwaltungEintrag te : tblEintraege) {

                // Archiv/Konfig:
                if ((istKonf == te.getDatenidentifikation().isKonfigurierendeDaten()) &&  //
                    (istArchiv == te.getDatenidentifikation().isArchivDaten())) {

                    // atg:
                    for (AttributeGroup atg : atgListe) {
                        if (atg.getPidOrId().equals(te.getDatenidentifikation().getAtgGroup())) {
                            list.add(darstellungsName);

                            break;
                        }
                    }
                }
            }
        }

        Collections.sort(list);
        _gui.getComboDarstellungsName().removeAll();
        _gui.getComboDarstellungsName().add(KEINE_DARSTELLUNG);

        for (String dName : list) {
            _gui.getComboDarstellungsName().add(dName);
        }

        if (_gui.getComboDarstellungsName().getText().isEmpty()) {
            _gui.getComboDarstellungsName().select(0);
        } else {
            for (int indexDarstellung = 0; indexDarstellung < _gui.getComboDarstellungsName().getItems().length; indexDarstellung++) {
                if (_gui.getComboDarstellungsName().getText().equals(_gui.getComboDarstellungsName().getItem(indexDarstellung))) {
                    _gui.getComboDarstellungsName().select(indexDarstellung);
                }
            }
        }

        _gui.getComboDarstellungsName().add(BENUTZERSPEZIFISCH);
    }

    /**
     * Die Methode erzeugeTabellenDatenStruktur erzeugt ein Objekt dass die
     * TabellenDatenstruktur reprsentiert, welches genau den Tabellenaufbau
     * hat, welches fr die Darstellung der Tabelle von nten ist. Die
     * Darstellung ist abhngig von dem Tabellenobjekt, welches sich durch die
     * Attributgruppe wie auch den Aspekt bestimmt.
     *
     * @param tbo
     *            Tabellenobjekt.
     * @return TabellenDatenStruktur
     */
    private TabellenDatenStruktur erzeugeTabellenDatenStruktur(TabellenObjekt tbo) {
        int anzahlVarAtt = _gui.getAnzahlVarAtt();

        _tabellenObjekt   = tbo;
        _tabellenStruktur = _tabellenObjekt.erzeugeTabellenDatenStruktur(anzahlVarAtt, _gui.getCheckArchiv().getSelection());
        _spaltenNamenTyp  = _tabellenObjekt.getSpaltenNamenTyp();

        return _tabellenStruktur;
    }

    /**
     * Die Methode erzeugt zur aktuell gewhlten Attributgruppe und zum aktuell gewhlten Aspekt
     * ein Tabellenobjekt zur Darstellung der zugehrigen Daten.
     * @param listePidNrGewaehlterKnotenImBaum Liste der Pid's der gewhlten Knoten im Baum.
     * @return Tabellenobjekt.
     */
    private TabellenObjekt erzeugeTabellenObj(List<String> listePidNrGewaehlterKnotenImBaum) {
        String atgPid = _gui.getComboAtg().getText();
        String aspPid = _gui.getComboAsp().getText();

        _tabellenObjekt = new TabellenObjekt(atgPid, aspPid, listePidNrGewaehlterKnotenImBaum);

        return _tabellenObjekt;
    }

    /**
     * Die Methode export sorgt dafr, dass die aktuell in der Tabelle
     * dargestellten Tabellenzeilen samt Zusatzinformationen in csv oder html
     * exportiert werden. Bei den Zusatzinformationen handelt es sich um:
     * <li> 0. Datum und Zeit, wann das Dokument erstellt wurde. </li>
     * <li> 1. Gewhlteer Darstellungsname </li>
     * <li> 2. Objekttyp </li>
     * <li> 3. Attributgruppe </li>
     * <li> 4. Aspekt </li>
     * <li> 5. nderungsdarstellung ja/nein </li>
     * <li> 6. Variable Attributanzahl </li>
     * <li> 7. Tabellenzeilenanzahl </li>
     * <li> 8. Filter (ja/nein) bzw. welcher Filter </li>
     * <li> 9. Sortierung </li>
     * <li> 10. Spaltenauswahl </li>
     * <li> 11. Ausgewhlte Objekte </li>
     *
     * @param exportInformation
     *            dabei handelt es sich um die Information, ob ein html oder csv
     *            Dokument erstellt werden soll.
     */
    private void export(String exportInformation) {

        // Export:
        int              spaltenZaehler                  = 0;
        String           dateiName                       = "";
        String[][]       zusatzInformationen             = new String[12][2];
        Date             date                            = new Date();
        String           datum                           = date.toString();
        SpaltenElement[] arTabellenKopf                  = _tabellenStruktur.getAlleSpaltenTitel();
        String[]         tabellenKopfZeileAlsStringArray = new String[arTabellenKopf.length];
        List<String>     spaltenAuswahl                  = bestimmeSpaltenAuswahl();
        int              startIndex                      = 0;

        if (_gui.getCheckArchiv().getSelection()) {
            zusatzInformationen = new String[23][2];
        }

        for (SpaltenElement spaltenElement : arTabellenKopf) {
            tabellenKopfZeileAlsStringArray[spaltenZaehler] = spaltenElement.toString();
            spaltenZaehler++;
        }

        String aenderungsDarstellung;

        if (_gui.getBtnAenderungsDarstellung().getSelection()) {
            aenderungsDarstellung = "Ja";
        } else {
            aenderungsDarstellung = "Nein";
        }

        zusatzInformationen[0][0] = "Datum: ";
        zusatzInformationen[0][1] = datum;
        zusatzInformationen[1][0] = "Gewhlte Darstellung: ";
        zusatzInformationen[1][1] = _gui.getComboDarstellungsName().getText();
        zusatzInformationen[2][0] = "Objekttyp: ";
        zusatzInformationen[2][1] = _gui.getObjTyp();
        zusatzInformationen[3][0] = "Attributgruppe: ";
        zusatzInformationen[3][1] = _gui.getComboAtg().getText();
        zusatzInformationen[4][0] = "Aspekt: ";
        zusatzInformationen[4][1] = _gui.getComboAsp().getText();

        if (_gui.getCheckArchiv().getSelection()) {
            startIndex = 5;

            String ja   = "Ja";
            String nein = "Nein";

            // Archiv
            ArchivanfrageDaten archiv = _instanzArchivVew.ermittleObjektAusGUI();

            zusatzInformationen[startIndex + 0][0] = "Prioritt der Anfrage: ";
            zusatzInformationen[startIndex + 0][1] = archiv.getPrioritaetDerAnfrage();
            zusatzInformationen[startIndex + 1][0] = "(Zeit-)Bereich der Anfrage: ";
            zusatzInformationen[startIndex + 1][1] = archiv.getZeitBereichDerAnfrage();
            zusatzInformationen[startIndex + 2][0] = "Datenanzahl begrenzt: ";
            zusatzInformationen[startIndex + 2][1] = archiv.isIstDatenanzahlBegrenzt() ? ja : nein;

            String[] vonBis = archiv.ermittleZeitbereichAlsText();

            zusatzInformationen[startIndex + 3][0]  = "Von: ";
            zusatzInformationen[startIndex + 3][1]  = vonBis[0];
            zusatzInformationen[startIndex + 4][0]  = "Bis: ";
            zusatzInformationen[startIndex + 4][1]  = vonBis[1];
            zusatzInformationen[startIndex + 5][0]  = "Anfrageart aktuelle Daten: ";
            zusatzInformationen[startIndex + 5][1]  = archiv.isAktuelleDaten() ? ja : nein;
            zusatzInformationen[startIndex + 6][0]  = "Anfrageart nachgelieferte Daten: ";
            zusatzInformationen[startIndex + 6][1]  = archiv.isNachgelieferteDaten() ? ja : nein;
            zusatzInformationen[startIndex + 7][0]  = "Anfrageart nachgefordert-aktuelle Daten: ";
            zusatzInformationen[startIndex + 7][1]  = archiv.isNachgefordertAktuelleDaten() ? ja : nein;
            zusatzInformationen[startIndex + 8][0]  = "Anfrageart nachgefordert-nachgelieferte Daten: ";
            zusatzInformationen[startIndex + 8][1]  = archiv.isNachgefordertNachgelieferteDaten() ? ja : nein;
            zusatzInformationen[startIndex + 9][0]  = "Zustands-/Deltaanfrage: ";
            zusatzInformationen[startIndex + 9][1]  = archiv.getIsZustandsAnfrage();
            zusatzInformationen[startIndex + 10][0] = "Sortierreihenfolge Datenstze: ";
            zusatzInformationen[startIndex + 10][1] = archiv.getSortierReihenfolge();
            startIndex                              = 11;
        }

        zusatzInformationen[startIndex + 5][0]  = "nderungsdarstellung: ";
        zusatzInformationen[startIndex + 5][1]  = aenderungsDarstellung;
        zusatzInformationen[startIndex + 6][0]  = "Variable Attribute: ";
        zusatzInformationen[startIndex + 6][1]  = _gui.getAnzahlVarAtt() + "";
        zusatzInformationen[startIndex + 7][0]  = "Tabellenzeilenanzahl: ";
        zusatzInformationen[startIndex + 7][1]  = _gui.getSpinnerMaxZeilen().getSelection() + "";
        zusatzInformationen[startIndex + 8][0]  = "Filter: ";
        zusatzInformationen[startIndex + 8][1]  = _gui.getComboFilter().getItem(_gui.getComboFilter().getSelectionIndex());
        zusatzInformationen[startIndex + 9][0]  = "Sortierung: ";
        zusatzInformationen[startIndex + 9][1]  = _gui.getComboSortierung().getItem(_gui.getComboSortierung().getSelectionIndex());
        zusatzInformationen[startIndex + 10][0] = "Spaltenauswahl: ";
        zusatzInformationen[startIndex + 10][1] = _gui.getComboSpalten().getItem(_gui.getComboSpalten().getSelectionIndex());
        zusatzInformationen[startIndex + 11][0] = "Gewhlte Objekte: ";
        zusatzInformationen[startIndex + 11][1] = _stringGewaehlteKnoten.toString();

        if (exportInformation.equals("csv")) {
            CsvExport csvExport = new CsvExport(tabellenKopfZeileAlsStringArray, _gui.getTableViewer(), _tabellenStruktur, zusatzInformationen, spaltenAuswahl);

            dateiName = csvExport.erzeugeCSV();
        } else if (exportInformation.equals("html")) {
            HtmlExport htmlExport = new HtmlExport(tabellenKopfZeileAlsStringArray, _gui.getTableViewer(), _tabellenStruktur, zusatzInformationen, spaltenAuswahl);

            dateiName = htmlExport.erzeugeHTML(_gui.getCheckArchiv().getSelection());
        }

        if ((dateiName == null) || (dateiName.isEmpty())) {
            MessageDialog.openError(_gui.getShell(), "Fehler", "Der Export konnte nicht durchgefhrt werden");
        } else {
            if (exportInformation.equals("html")) {
                StandardAktionen.aufrufenStandardWindowsAktionFuerDatei(StandardAktionen.OEFFNEN, dateiName, false, "html", OrdnerEinstellungen.ermittleTempOrdner());
            } else if (exportInformation.equals("csv")) {
                StandardAktionen.aufrufenStandardWindowsAktionFuerDatei(StandardAktionen.OEFFNEN, dateiName, false, "csv", OrdnerEinstellungen.ermittleTempOrdner());
            }
        }
    }

    /**
     * Fllt die bergebene Combobox mit Daten.
     *
     * @param combo
     *            Die zu fllende Combobox.
     * @param selektionAusSpeicher
     *            Selektion aus den gespeicherten Informationen. D.h. wenn ein
     *            existierender Filter eingelesen wird, dann beinhaltet diese
     *            Variable den Namen, so dass die jeweilige Combobox
     *            dementsprechend vorbelegt werden kann. Ist diese Variable
     *            leer, handelt es sich um ein initiales Anlegen der Combobox
     *            ohne vorselektion.
     */
    protected void fuelleCombo(Combo combo, String selektionAusSpeicher) {
        ArrayList<String> list  = new ArrayList<String>();
        int               index = -1;
        int               count = 0;

        // Wenn alle ausgewhlt werden sollen.
        Collection<Object> gewaehlteSystemObjekte;

        gewaehlteSystemObjekte = bestimmeSystemObjekteDerGewaehltenObjekte();

        if (combo.equals(_gui.getComboAtg())) {
            _atgListe = new ArrayList<AttributeGroup>();
            _gui.getComboAtg().removeAll();

            if (_gui.getComboAsp() != null) {
                _gui.getComboAsp().removeAll();
            }

            _atgListe = BaumHilfsFunktionen.bestimmeAttributgruppen(gewaehlteSystemObjekte, _gui.getCheckKonfDaten().getSelection());

            if (_atgListe != null) {
                for (AttributeGroup atg : _atgListe) {
                    list.add(atg.getPid());
                }
            }
        } else if (combo.equals(_gui.getComboAsp())) {
            count = 0;

            List<Aspect> aspListe;

            _gui.getComboAsp().removeAll();

            for (AttributeGroup atg : _atgListe) {
                if (_gui.getComboAtg().getSelectionIndex() >= 0) {
                    if (atg.getPid().equals(_gui.getComboAtg().getText())) {
                        aspListe = BaumHilfsFunktionen.bestimmeAspekte(atg, _gui.getCheckKonfDaten().getSelection());

                        for (Aspect asp : aspListe) {
                            list.add(asp.getPid());
                        }
                    }
                }
            }
        } else if (combo.equals(_gui.getComboFilter())) {
            count = 0;
            _gui.getComboFilter().removeAll();

            for (String filter : _instanzAlleFilter.getFilterArray()) {
                List<FilterEintrag> listeFilter = _instanzAlleFilter.getFilterObjekt(filter).getFilterEintraege();

                for (FilterEintrag fe : listeFilter) {
                    if ((fe.getDatenidentifikation().getAtgGroup().equals(_gui.getComboAtg().getText())) && (fe.getDatenidentifikation().isArchivDaten() == _gui.getCheckArchiv().getSelection()) && (fe.getDatenidentifikation().isKonfigurierendeDaten() == _gui.getCheckKonfDaten().getSelection())) {
                        list.add(filter);
                    }
                }
            }
        } else if (combo.equals(_gui.getComboSpalten())) {
            count = 0;
            _gui.getComboSpalten().removeAll();

            for (String spalten : _instanzAlleSpalten.getSortierungArray()) {
                List<SortierungEintrag> spaltenListe = _instanzAlleSpalten.getSortierungObjekt(spalten).getSortierungEintraege();

                for (SortierungEintrag se : spaltenListe) {
                    if ((se.getDatenidentifikation().getAtgGroup().equals(_gui.getComboAtg().getText())) && (se.getDatenidentifikation().isArchivDaten() == _gui.getCheckArchiv().getSelection()) && (se.getDatenidentifikation().isKonfigurierendeDaten() == _gui.getCheckKonfDaten().getSelection())) {
                        list.add(spalten);
                    }
                }
            }
        } else if (combo.equals(_gui.getComboSortierung())) {
            count = 0;
            _gui.getComboSortierung().removeAll();

            for (String sortierung : _instanzAlleSortierungen.getSortierungArray()) {
                List<SortierungEintrag> sortierListe = _instanzAlleSortierungen.getSortierungObjekt(sortierung).getSortierungEintraege();

                for (SortierungEintrag sE : sortierListe) {
                    if ((sE.getDatenidentifikation().getAtgGroup().equals(_gui.getComboAtg().getText())) && (sE.getDatenidentifikation().isArchivDaten() == _gui.getCheckArchiv().getSelection()) && (sE.getDatenidentifikation().isKonfigurierendeDaten() == _gui.getCheckKonfDaten().getSelection())) {
                        list.add(sortierung);
                    }
                }
            }
        }

        Collections.sort(list);

        if (combo.equals(_gui.getComboAtg())) {
            for (String atg : list) {
                _gui.getComboAtg().add(atg);

                if (atg.equals(selektionAusSpeicher)) {
                    index = count;
                }

                count++;
            }

            if (index != -1) {
                _gui.getComboAtg().select(index);
            } else {
                if (_gui.getBtnStartStopp() != null) {
                    _gui.getBtnStartStopp().setEnabled(false);
                    _gui.getComboAtg().setText("");
                }
            }
        } else if (combo.equals(_gui.getComboAsp())) {
            for (String asp : list) {
                _gui.getComboAsp().add(asp);

                if (asp.equals(selektionAusSpeicher)) {
                    index = count;
                }

                count++;
            }

            if (index != -1) {
                _gui.getComboAsp().select(index);
            } else {
                if (_gui.getBtnStartStopp() != null) {
                    _gui.getBtnStartStopp().setEnabled(false);
                    _gui.getComboAsp().setText("");
                }
            }
        } else if (combo.equals(_gui.getComboFilter())) {
            _gui.getComboFilter().add(KEINEN_FILTER, 0);

            for (String filter : list) {
                _gui.getComboFilter().add(filter);

                if (filter.equals(selektionAusSpeicher)) {
                    index = count + 1;
                }

                count++;
            }

            if (index != -1) {
                _gui.getComboFilter().select(index);
            } else if (list.size() >= 0) {
                _gui.getComboFilter().select(0);
            }
        } else if (combo.equals(_gui.getComboSortierung())) {
            _gui.getComboSortierung().add(KEINE_SORTIERUNG, 0);

            for (String sortierung : list) {
                _gui.getComboSortierung().add(sortierung);

                if (sortierung.equals(selektionAusSpeicher)) {
                    index = count + 1;
                }

                count++;
            }

            if (index != -1) {
                _gui.getComboSortierung().select(index);
            } else if (list.size() >= 0) {
                _gui.getComboSortierung().select(0);
            }
        } else if (combo.equals(_gui.getComboSpalten())) {
            _gui.getComboSpalten().add(KEINE_SPALTENAUSWAHL, 0);

            for (String spalten : list) {
                _gui.getComboSpalten().add(spalten);

                if (spalten.equals(selektionAusSpeicher)) {
                    index = count + 1;
                }

                count++;
            }

            if (index != -1) {
                _gui.getComboSpalten().select(index);
            } else if (list.size() >= 0) {
                _gui.getComboSpalten().select(0);
            }
        }
    }

    /**
     * Die Methode fuelleGUIElemente fllt alle GUI Elemente in Abhngigkeit der
     * gewhlten Darstellung. Der boolesche Parameter
     * aktualisiereBeiSelektierterAuswahl ist genau dann true, wenn ein neuer
     * Darstellungsname gewhlt wird. Wird diese Methode durch den Fokuswechsel
     * zur Aktualisierung aller GUI Elemente aufgerufen ist der boolesche
     * Parameter aktualisiereBeiSelektierterAuswahl false.
     *
     * @param aktualisierenBeiSelektierterAuswahl
     *            sorgt dafr, dass ein Dialog geffnet wird, mittels dem der
     *            Benutzer entscheiden kann, ob er die Darstellung auf die
     *            aktuell im Baum gewhlten Objekte oder die gespeicherten
     *            Objekte anwenden mchte.
     */
    protected void fuelleGUIElemente(boolean aktualisierenBeiSelektierterAuswahl) {
        String dartsellung = _gui.getComboDarstellungsName().getText();

        if (!(dartsellung.equals(KEINE_DARSTELLUNG)) && (!(dartsellung.equals(BENUTZERSPEZIFISCH)))) {
            List<TabellenVerwaltungEintrag> tblVewEintraege = _alleTabellenVerwaltungen.getTabellenVerwaltungsObjekt(dartsellung).getTabellenVerwaltungsEintrag();

            for (TabellenVerwaltungEintrag tbl : tblVewEintraege) {
                _gui.getComboAtg().setText(tbl.getDatenidentifikation().getAtgGroup());
                _gui.getComboAsp().setText(tbl.getDatenidentifikation().getAspect());
                _gui.getSpinnerAnzahlVarAtt().setSelection(tbl.getVarAtt());
                _gui.getSpinnerMaxZeilen().setSelection(tbl.getVarTbl());

                if (tbl.getArchivanfrageDaten() != null) {
                    _gui.getCheckArchiv().setSelection(tbl.getDatenidentifikation().isArchivDaten());

                    if (tbl.getDatenidentifikation().isArchivDaten()) {
                        _gui.anzeigenArchivBereich(true);
                        setzeArchivabhaengigeButtons(true);
                        aenderungErfolgt();
                    }

                    fuelleCombo(_gui.getComboAtg(), tbl.getDatenidentifikation().getAtgGroup());
                    fuelleCombo(_gui.getComboAsp(), tbl.getDatenidentifikation().getAspect());

                    // Archiv
                    _instanzArchivVew.setzeGUIbereich(tbl.getArchivanfrageDaten());
                }

                _gui.getBtnAenderungsDarstellung().setSelection(tbl.isAenderungsdarstellung());
                _gui.getSpinnerAnzahlVarAtt().setSelection(tbl.getVarAtt());
                _gui.getSpinnerMaxZeilen().setSelection(tbl.getVarTbl());
                fuelleCombo(_gui.getComboFilter(), tbl.getFilterAuswahlName());
                fuelleCombo(_gui.getComboSpalten(), tbl.getSpaltenAuswahlName());
                fuelleCombo(_gui.getComboSortierung(), tbl.getSortierAuswahlName());

                if (aktualisierenBeiSelektierterAuswahl) {
                    if (!(tbl.getGewaehlteKnotenBaum().isEmpty() || (tbl.getGewaehlteKnotenBaum().equals(_arListGewaehltenObjImBaum)))) {
                        aktionOeffneAbfrageDialogKnotenAuswahl(tbl.getGewaehlteKnotenBaum(), tbl.isSelektionUebernehmen());
                    }
                }
            }
        }
    }

    /**
     * Die Methode fuelleTextFeldGewaehlteKnotenImBaum fllt das Textfeld mit
     * den aktuelle gewhlten Knoten im Baum.
     *
     * @param gewaehlteKnotenBaum
     *            Gewhlte Knoten im Baum.
     */
    protected void fuelleTextFeldGewaehlteKnotenImBaum(List<String> gewaehlteKnotenBaum) {
        _stringGewaehlteKnoten = new StringBuffer();

        List<String> pidNummernDerGewaehltenObjekte;

        pidNummernDerGewaehltenObjekte = gewaehlteKnotenBaum;

        for (String pid : pidNummernDerGewaehltenObjekte) {
            _stringGewaehlteKnoten.append(pid);
            _stringGewaehlteKnoten.append(";");
            _stringGewaehlteKnoten.append("\r\n");
        }

        _gui.getTxtGewaehlteKnoten().setText(_stringGewaehlteKnoten.toString());
    }

    //~ GET METHODEN ==========================================================

    /**
     * Ermittle die Anzahl der (nicht gefilterten, sortierten...) Zeilen in der TabellenDatenStruktur.
     * </p>
     * Dabei wird die Anzahl der Original Liste (nicht gefilterten, sortierten...) berechnet.
     * Das ist ntig, da man die Zeilen nur aus der Original Liste lschen kann
     * (s. Methode {@link #loescheTabellenZeilen(String)}}).
     * </p>
     * Somit wird die Gre der Tabelle immer auf die Original Liste beziehen und
     * genau dieser Wert wird im max.Anzahl der Tabellenzeilen in Darstellungoptionen verwendet.
     * Wenn z.B. max.Anzahl=100, werden 100 Datenstze in einem Schritt abgeholt (nicht mehr)
     * obwohl z.B. nur 9 davon in gefilterter Liste kommen.
     * </p>
     *
     * @param tabellenDatenStruktur TabellenDatenStruktur.
     *
     * @return Anzahl der (nicht gefilterten, sortierten...) Zeilen in der TabellenDatenStruktur.
     */
    private int getAnzahlZeilen(TabellenDatenStruktur tabellenDatenStruktur) {

        // Merke alle Eigenschaften der Tabelle, die die Liste beeinflussen:
        boolean istAenderungsDarstellung = tabellenDatenStruktur.istAenderungsDarstellung();
        boolean istGefiltert             = tabellenDatenStruktur.istGefiltert();
        boolean istSortiert              = tabellenDatenStruktur.istSortiert();

        // Schalte alle Eigenschaften der Tabelle aus:
        tabellenDatenStruktur.setAenderungsDarstellung(false);
        tabellenDatenStruktur.setGefiltert(false);
        tabellenDatenStruktur.setSortieren(false);

        //
        int anz = tabellenDatenStruktur.getAnzahlZeilen();

        // Schalte alle Eigenschaften der Tabelle wieder ein:
        tabellenDatenStruktur.setAenderungsDarstellung(istAenderungsDarstellung);
        tabellenDatenStruktur.setGefiltert(istGefiltert);
        tabellenDatenStruktur.setSortieren(istSortiert);

        return anz;
    }

    /**
     * Getter fr Eigenschaft 'tabellenDatenStruktur'.
     *
     * @return Wert der Eigenschaft 'tabellenDatenStruktur'.
     *
     * @see #_tabellenDatenStruktur
     */
    public TabellenDatenStruktur getTabellenDatenStruktur() {
        return _tabellenDatenStruktur;
    }

    //~ METHODEN ==============================================================

    /**
     * Die Methode erzeugeGUIVergleichsObj erzeugt zum TabellendarstellungsGUI
     * ein Vergleichsobjekt anhand dessen festegestellt werden kann, ob sich die
     * aktuelle Darstellung verndert hat. Diese Information wird verwendet, um
     * ein Speichern oder bernehmen der genderten Darstellungsoption zu
     * ermglichen. Das Vergleichsobjekt, bei dem es sich um ein
     * TabellenVerwaltungsEintrag handelt, besteht aus folgenden Attributen:
     * <li> 1. Archiv (flag ja nein) </li>
     * <li> 2. Gewhlte Darstellungsname </li>
     * <li> 3. Konfigurierende Daten ja/nein </li>
     * <li> 4. Gewhlte Attributgruppe </li>
     * <li> 5. Gewhlte Aspekt </li>
     * <li> 6. Archivoptionen </li>
     * <li> 7. nderungsdarstellung ja/nein </li>
     * <li> 8. Variable Anzahl der Attribute </li>
     * <li> 9. Anzahl der Tabellenzeilen </li>
     * <li> 10. Gewhlte Filter </li>
     * <li> 11. Gewhlte Sortierung </li>
     * <li> 12. Gewhlte Spaltenauswahl </li>
     */
    private void guiVergleichsObjFuellen() {
        String atg = "";
        String asp = "";

        if ((_gui.getComboAtg().getSelectionIndex() != -1)) {
            atg = _gui.getComboAtg().getItem(_gui.getComboAtg().getSelectionIndex());
        }

        if ((_gui.getComboAsp().getSelectionIndex() != -1)) {
            asp = _gui.getComboAsp().getItem(_gui.getComboAsp().getSelectionIndex());
        }

        /** Datenidentifikationsobjekt. */
        Datenidentifikation datenIdentifikationGUI;

        datenIdentifikationGUI                     = new Datenidentifikation(_gui.getObjTyp(), atg, asp, _gui.getCheckArchiv().getSelection(), _gui.getCheckKonfDaten().getSelection());
        _guiTabellenVerwaltungEintragVergleichsObj = new TabellenVerwaltungEintrag();
        _guiTabellenVerwaltungEintragVergleichsObj.setAenderungsdarstellung(_gui.getBtnAenderungsDarstellung().getSelection());
        _guiTabellenVerwaltungEintragVergleichsObj.setDatenidentifikation(datenIdentifikationGUI);

        String filter     = "";
        String sortierung = "";
        String spalten    = "";

        if ((_gui.getComboFilter().getSelectionIndex() != -1)) {
            filter = _gui.getComboFilter().getItem(_gui.getComboFilter().getSelectionIndex());
        }

        if ((_gui.getComboSortierung().getSelectionIndex() != -1)) {
            sortierung = _gui.getComboSortierung().getItem(_gui.getComboSortierung().getSelectionIndex());
        }

        if ((_gui.getComboSpalten().getSelectionIndex() != -1)) {
            spalten = _gui.getComboSpalten().getItem(_gui.getComboSpalten().getSelectionIndex());
        }

        _guiTabellenVerwaltungEintragVergleichsObj.setFilterAuswahlName(filter);
        _guiTabellenVerwaltungEintragVergleichsObj.setSortierAuswahlName(sortierung);
        _guiTabellenVerwaltungEintragVergleichsObj.setSpaltenAuswahlName(spalten);
        _guiTabellenVerwaltungEintragVergleichsObj.setVarAtt(_gui.getSpinnerAnzahlVarAtt().getSelection());
        _guiTabellenVerwaltungEintragVergleichsObj.setVarTbl(_gui.getSpinnerMaxZeilen().getSelection());
        _guiTabellenVerwaltungEintragVergleichsObj.setGewaehlteKnotenBaum(_arListGewaehltenObjImBaum);

        // Archiv:
        ArchivanfrageDaten archivanfrageDaten = _instanzArchivVew.ermittleObjektAusGUI();

        _guiTabellenVerwaltungEintragVergleichsObj.setArchivanfrageDaten(archivanfrageDaten);
    }

    /**
     * Die Methode setzt das GUI bzgl. Archiv oder Konfigurierende Daten.
     */
    private void initialisiereBzglArchivOderKonfDaten() {
        if (_gui.isStart()) {
            btnStartStopp();
        }

        _gui.getBtnStartStopp().setEnabled(false);
        loescheKopfzeile();
        _tabellenDatenStruktur = new TabellenDatenStruktur(_gui.getTableViewer().getTable().getColumnCount());
        fuelleCombo(_gui.getComboAtg(), "");
        _gui.getComboDarstellungsName().removeAll();
        _gui.getComboDarstellungsName().setText("");
        erzeugeComboboxDarstellungsName();
        fuelleCombo(_gui.getComboFilter(), "");
        fuelleCombo(_gui.getComboSortierung(), "");
        fuelleCombo(_gui.getComboSpalten(), "");
    }

    /**
     * Die Methode initialisiereAlles initialisiert die Darstellungsbezogenen GUI Elemente mit dem
     * Initialwert.
     */
    protected void initialisiereDarstellungsOptionen() {
        _gui.getBtnAenderungsDarstellung().setSelection(false);
        _gui.getSpinnerAnzahlVarAtt().setSelection(0);
        _gui.getSpinnerMaxZeilen().setSelection(1000);
    }

    @Override
    public boolean istBtnArchivanfrage() {
        return true;
    }

    /**
     * Wenn keine Darstellung ausgewhlt ist, muss das GUI initial belegt werden.
     * Die Methode sorgt dafr, dass diese initialbelegung aller widgets im GUI vollzogen wird.
     */
    protected void keineDarstellungGewaehltObjFuellen() {
        _keineDarstellungGewaehltObj = new TabellenVerwaltungEintrag();
        _keineDarstellungGewaehltObj.setAenderungsdarstellung(false);
        _keineDarstellungGewaehltObj.setDatenidentifikation(new Datenidentifikation(_gui.getObjTyp(), "", "", _gui.getCheckArchiv().getSelection(), _gui.getCheckKonfDaten().getSelection()));
        _keineDarstellungGewaehltObj.setFilterAuswahlName(_gui.getComboFilter().getItem(0));
        _keineDarstellungGewaehltObj.setSortierAuswahlName(_gui.getComboSortierung().getItem(0));
        _keineDarstellungGewaehltObj.setSpaltenAuswahlName(_gui.getComboSpalten().getItem(0));
        _keineDarstellungGewaehltObj.setVarAtt(GTMDialogGUI.DEFAULT_VAR_ATT);
        _keineDarstellungGewaehltObj.setVarTbl(GTMDialogGUI.DEFAULT_MAX_ZEILEN);
        _keineDarstellungGewaehltObj.setGewaehlteKnotenBaum(_arListGewaehltenObjImBaum);
        _keineDarstellungGewaehltObj.setArchivanfrageDaten(new ArchivanfrageDaten());
    }

    /**
     * Konvertierung der DavDaten zu einem Zeilenobjekt.
     *
     * @param statusMeldung
     *            Status Meldung.
     * @param pidOrNameOrId
     *            OA = online aktuell, ON = online nachgeliefert, NA =
     *            nachgefordert aktuell, NN = nachgefordert nachgeliefert
     * @param date
     *            Datum des Datensatzes.
     * @param istTabelleNeuLaden Stellt fest, ob die Tabelle neu geladen werden soll.
     * @param isArchivAnfrage  boolesche Variable die angibt, ob es sich um eine Archivanfrage handelt.
     */
    private void konvertiereDavDatenMitStatusInformation(String statusMeldung, String pidOrNameOrId, long date, boolean istTabelleNeuLaden, boolean isArchivAnfrage) {
        if (_tabellenObjekt != null) {
            _spaltenNamenArrayList = _tabellenObjekt.getSpaltenNamen();

            if (_spaltenNamenArrayList != null) {
                try {

                    // Erzeuge ein Zeilenobjekt, welches die Statusinformation des Datenverteilers beinhaltet.
                    // Bei der Statusinformation kann es sich um folgende Status handeln:
                    // - "keine Daten"
                    // - "keine Daten (keine Quelle)"
                    // - "keine Daten (keine Rechte)"
                    // - "keine Daten (potentielle Datenlcke)"
                    // - "Ende des Archivanfragezeitraums"
                    // - "Gelschter Bereich"
                    // - "Ausgelagerter Bereich"
                    // - "keine Daten (fehlerhafte Anmeldung)"
                    // - "keine Daten (Undefinierte Objektkodierung)"
                    ArrayList<String> listStatusMeldung = new ArrayList<String>();

                    listStatusMeldung.add(statusMeldung);

                    try {
                        ZeilenObjekt zeile = _tabellenObjekt.erzeugeSystemObjekt("", date, 0, listStatusMeldung, pidOrNameOrId, isArchivAnfrage);

                        // Hngt die bergebene Zeile - das ZeilenObjekt - an die Tabellendatenstruktur an:
                        if (_tabellenStruktur != null) {
                            _tabellenStruktur.addZeile(zeile);

                            // Aktualisiere das GUI:
                            if (istTabelleNeuLaden) {
                                tabelleNeuLaden();
                            }
                        }
                    }
                    catch (Exception e) {
                        Log.zeigeInterneMultiMeldung(Activator.PLUGIN_ID, "Es sind Probleme bei der Konvertierung der Datenverteilerdaten in Zeilenobjekte aufgetreten.", e);
                    }
                }
                catch (Exception ignored) {}
            }
        }
    }

    /**
     * Konvertiere Daten aus DaV zu Liste von Zeilenobjekten.
     *
     * @param archiveDataKind
     *            Archivdaten Art.
     * @param data
     *            Dataobjekt vom Datenverteiler.
     * @param ausgewaehlteObj
     *            das ausgewhlte Objekt.
     * @param datenZeit
     *            Datum des Objektes zur Ankunftszeit im Archiv.
     * @param archivDatenZeit
     *            Datum des Objektes.
     * @param istTabelleNeuLaden Stellt fest, ob die Tabelle neu geladen werden soll.
     * @param isArchivAnfrage  boolesche Variable die angibt, ob es sich um eine Archivanfrage handelt.
     * @param anzahlVarAtt
     *                    Anzahl der variablen Attributte (Parameter muss angegeben werden,
     *                    damit in der Methode kein Zugriff auf GUI passiert).
     */
    private void konvertiereDavDatenZuZeilenObjekt(ArchiveDataKind archiveDataKind, Data data, String ausgewaehlteObj, long datenZeit, long archivDatenZeit, boolean istTabelleNeuLaden, boolean isArchivAnfrage, int anzahlVarAtt) {
        ArrayList<String> listZeilenInhalt = new ArrayList<String>();

        if (_tabellenObjekt != null) {
            _spaltenNamenArrayList = _tabellenObjekt.getSpaltenNamen();
        }

        if (data != null) {
            listZeilenInhalt = bestimmeZeilenObjektInhaltAlsListe(data, listZeilenInhalt, "", true, "", anzahlVarAtt);

            // Erzeuge Zeilenobjekt basierend auf dem Zeileninhalt, dem Namen ein neues Zeilenobjekt:
            try {
                ZeilenObjekt zeile = _tabellenObjekt.erzeugeSystemObjekt(archiveDataKind.toString(), datenZeit, archivDatenZeit, listZeilenInhalt, ausgewaehlteObj, isArchivAnfrage);

                // Hngt die bergebene Zeile - das ZeilenObjekt - an die Tabellendatenstruktur an:
                if (_tabellenStruktur != null) {
                    _tabellenStruktur.addZeile(zeile);

                    // Aktualisiere das GUI:
                    if (istTabelleNeuLaden) {
                        tabelleNeuLaden();
                    }
                }
            }
            catch (Exception e) {
                Log.zeigeInterneMultiMeldung(Activator.PLUGIN_ID, "Es sind Probleme bei der Zeilenobjekterzeugung aufgetreten.", e);

                Shell shell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();

                MessageDialog.openError(shell, "Fehler", "Es sind Probleme bei der Zeilenobjekterzeugung aufgetreten.");
            }
        }
    }

    /**
     * Die Methode loescheKopfzeile lscht die aktuelle Tabellenkopfzeile.
     */
    protected void loescheKopfzeile() {
        _gui.getTableViewer().getTable().clearAll();

        int anzahlSpalten = _gui.getTableViewer().getTable().getColumnCount();

        for (int i = 0; i < anzahlSpalten; i++) {
            _gui.getTableViewer().getTable().getColumn(0).dispose();
        }

        _gui.getTableViewer().getTable().clearAll();
    }

    /**
     * Die Methode loescheTabellenZeilen lscht so viele Tabellenzeilen, bis die
     * Anzahl der Tabellenzeilen gleich der Anzahl der Maximal darzustellenden
     * Zeilen ist.
     * </p>
     * Dabei wird die Anzahl der Original Liste (nicht gefilterten, sortierten...) gemeint.
     * Das ist ntig, da man die Zeilen nur aus der Original Liste lschen kann.
     * </p>
     * Somit wird die Gre der Tabelle immer auf die Original Liste beziehen und
     * genau dieser Wert wird im max.Anzahl der Tabellenzeilen in Darstellungoptionen verwendet.
     * Wenn z.B. max.Anzahl=100, werden 100 Datenstze in einem Schritt abgeholt (nicht mehr)
     * obwohl z.B. nur 9 davon in gefilterter Liste kommen.
     * </p>
     *
     * @param modus
     *            der Modus gibt an wieviele Zeilen aus der Tabelle gelscht
     *            werden sollen, entweder alles, oder 50% der im Spinner
     *            eingestellten Tabellenzeilenzahl, oder genauso viele das die
     *            Zeilenzahl des Spinners der Zeilenzahl in der Tabelle
     *            entsprechen.
     */
    public void loescheTabellenZeilen(String modus) {
        int aktuelleZeilenZahl = getAnzahlZeilen(_tabellenStruktur);
        int zuLoeschen         = 0;
        int maxZeilen          = _gui.getSpinnerMaxZeilen().getSelection();

        if (modus.equals(ALLE)) {
            zuLoeschen = aktuelleZeilenZahl;
        } else if (modus.equals(ARCHIV_50_PROZENT)) {
            if (_maxAnzTabellenZeilenFuerArchiv < aktuelleZeilenZahl) {
                zuLoeschen = _maxAnzTabellenZeilenFuerArchiv / 2 + (aktuelleZeilenZahl - _maxAnzTabellenZeilenFuerArchiv);
            } else if (_maxAnzTabellenZeilenFuerArchiv == aktuelleZeilenZahl) {
                if (maxZeilen < _maxAnzTabellenZeilenFuerArchiv) {
                    zuLoeschen = _maxAnzTabellenZeilenFuerArchiv - maxZeilen;
                } else if (maxZeilen > _maxAnzTabellenZeilenFuerArchiv) {
                    zuLoeschen = 0;
                } else {
                    zuLoeschen = _maxAnzTabellenZeilenFuerArchiv / 2;
                }
            } else if (_maxAnzTabellenZeilenFuerArchiv > aktuelleZeilenZahl) {
                zuLoeschen = 0;
            }
        } else if (modus.equals(BENUTZERDEFINIERT)) {
            if (maxZeilen <= aktuelleZeilenZahl) {
                zuLoeschen = aktuelleZeilenZahl - maxZeilen;
            }
        }

        // Merke alle Eigenschaften der Tabelle, die die Liste beeinflussen:
        boolean istAenderungsDarstellung = _tabellenStruktur.istAenderungsDarstellung();
        boolean istGefiltert             = _tabellenStruktur.istGefiltert();
        boolean istSortiert              = _tabellenStruktur.istSortiert();

        // Schalte alle Eigenschaften der Tabelle aus:
        // (da man die Zeilen nur aus der Original Liste lschen kann)
        _tabellenStruktur.setAenderungsDarstellung(false);
        _tabellenStruktur.setGefiltert(false);
        _tabellenStruktur.setSortieren(false);

        if (zuLoeschen == aktuelleZeilenZahl) {
            _tabellenStruktur.getZeilen().clear();
        } else {
            for (int i = 0; i < zuLoeschen; i++) {
                _tabellenStruktur.getZeilen().remove(0);

                if (!(_ringBufferListe.isEmpty())) {
                    _ringBufferListe.remove(0);
                }
            }
        }

        // Schalte alle Eigenschaften der Tabelle wieder ein:
        _tabellenStruktur.setAenderungsDarstellung(istAenderungsDarstellung);
        _tabellenStruktur.setGefiltert(istGefiltert);
        _tabellenStruktur.setSortieren(istSortiert);

        //
        if (aktuelleZeilenZahl > 0) {
            tabelleNeuLaden();
        }
    }

    /**
     * Die Methode loescheWennMaxAnzahlTabellenzeilenUeberschritten ruft die
     * Methode loescheTabellenZeilen auf, wenn die Maximaltabellenzeilenanzahl
     * berschritten wird.
     *
     * @param modus
     *            wieviele Zeilen gelscht werden sollen.
     */
    protected void loescheWennMaxAnzahlTabellenzeilenUeberschritten(String modus) {
        if (_tabellenStruktur != null) {
            if (_gui.getSpinnerMaxZeilen().getSelection() < getAnzahlZeilen(_tabellenStruktur)) {
                loescheTabellenZeilen(modus);
            }
        }
    }

    //~ SET METHODEN ==========================================================

    /**
     * Setter fr Eigenschaft 'instanzArchivVew'.
     *
     * @param instanzArchivVew Wert zum Setzen der Eigenschaft 'instanzArchivVew'.
     *
     * @see #_instanzArchivVew
     */
    protected void setInstanzArchivVew(ArchivanfrageDatenGUIVew instanzArchivVew) {
        _instanzArchivVew = instanzArchivVew;
    }

    //~ METHODEN ==============================================================

    /**
     * Die Methode setzt alle archivabhngigen Buttons. Beispielsweise ist es in
     * dem Archivmodus immer mglich zu Drucken, oder Daten zu exportieren.
     *
     * @param isArchivModus
     *            gibt an ob sich die aktuelle Tabellensicht im Archivmodus
     *            befindet.
     */
    private void setzeArchivabhaengigeButtons(boolean isArchivModus) {
        if (isArchivModus) {
            _gui.setStart(false);
            _gui.getBtnStartStopp().setText("Start");
            _gui.getBtnStartStopp().setBackground(SWTResourceManager.getColor(SWT.COLOR_GREEN));
            _gui.getBtnStartStopp().setEnabled(false);
            erlaubeDruckenUndExport(true);
        } else {
            setzteAbhaengigeButtonsNormalModus();
        }
    }

    /**
     * Flle die Tabelle mit dem Inhalt.
     *
     * Inhalt wird gesetzt, nur falls die Sektion "Tabelle" aufgeklappt ist.
     */
    private void setzeTabellenInput() {
        if (_gui.getTableViewer().getContentProvider() != null) {
            try {
                _gui.getTableViewer().setInput(_tabellenInhaltAktuell);
                _gui.getSectionTabelle().setExpanded(true);
            }
            catch (Exception e) {
                Log.zeigeInterneMeldung(Activator.PLUGIN_ID, e);
            }
        }
    }

    /**
     * Die Tabelle wird neu aufgebaut.
     */
    protected void setzeTabellenInputErneut() {

        // Richte den Tabelleninhalt fr Referenzattribute und String attribute linksbndig aus.
        // Alle anderen werden rechtsbndig in die Tabellenspalten eingefgt:
        int anzahlSpalten = _gui.getTableViewer().getTable().getColumnCount();

        for (int i = 0; i < anzahlSpalten; i++) {
            TableColumn tabellenSpalte = _gui.getTableViewer().getTable().getColumn(i);
            String      columnName     = tabellenSpalte.getText();

            if (_spaltenNamenTyp.contains(columnName)) {
                tabellenSpalte.setAlignment(SWT.LEFT);
            } else {
                tabellenSpalte.setAlignment(SWT.RIGHT);
            }
        }

        //
        if (!_gui.getCheckArchiv().getSelection()) {
            loescheWennMaxAnzahlTabellenzeilenUeberschritten(BENUTZERDEFINIERT);
        }

        if (_tabellenDatenStruktur.getAlleSpaltenTitelAlsListe().size() > 0) {
            _tabellenInhaltAktuell = _tabellenDatenStruktur;
            setzeTabellenInput();
        }
    }

    /**
     * Die Methode belegt den Startbutton sowie alle abhngigen Buttons mit den
     * default Belegungen.
     */
    private void setzteAbhaengigeButtonsNormalModus() {
        if (!_gui.getCheckKonfDaten().getSelection()) {
            if (_gui.isStart()) {
                _gui.setStart(false);
                _gui.getBtnStartStopp().setText("Start");
                _gui.getBtnStartStopp().setBackground(SWTResourceManager.getColor(SWT.COLOR_GREEN));
                _gui.getBtnDrucken().setEnabled(true);
                _gui.getBtnExportInCsv().setEnabled(true);
                _gui.getBtnExportInHtml().setEnabled(true);
            } else {
                _gui.setStart(true);
                _gui.getBtnStartStopp().setText("Stopp");
                _gui.getBtnStartStopp().setBackground(SWTResourceManager.getColor(SWT.COLOR_RED));
                erlaubeDruckenUndExport(false);
            }
        }
    }

    /**
     * Die Methode spaltenAuswahl blendet Spalten je nach Spaltenauswahl ein
     * oder aus.
     *
     * @param selection
     *            Parameter der angibt, ob die Spalten ein oder ausgeblendet
     *            werden sollen.
     */
    private void spaltenAuswahl(boolean selection) {
        if (_gui.getTableViewer() != null) {
            Table table = _gui.getTableViewer().getTable();

            if (table != null) {
                TableColumn[] alleTabellenSpalten = table.getColumns();
                int[]         spaltenReihenFolge  = new int[alleTabellenSpalten.length];
                int[]         urspruenglich       = new int[alleTabellenSpalten.length];
                List<String>  spaltenAuswahl      = bestimmeSpaltenAuswahl();

                if (selection) {
                    List<Integer> listVerwendeteIndexe = new ArrayList<Integer>();
                    int           count                = 0;
                    String[]      arSpaltenAuswahl     = new String[spaltenAuswahl.size()];

                    for (String sp : spaltenAuswahl) {
                        arSpaltenAuswahl[count] = sp;
                        count++;
                    }

                    count = 0;

                    for (int i = 0; i < spaltenReihenFolge.length; i++) {
                        spaltenReihenFolge[i] = -1;
                    }

                    for (String anArSpaltenAuswahl : arSpaltenAuswahl) {
                        for (int alleSpaltenCount = 0; alleSpaltenCount < alleTabellenSpalten.length; alleSpaltenCount++) {
                            if (anArSpaltenAuswahl.equals(alleTabellenSpalten[alleSpaltenCount].getText())) {
                                spaltenReihenFolge[count] = alleSpaltenCount;
                                listVerwendeteIndexe.add(alleSpaltenCount);
                                count++;
                            }
                        }
                    }

                    for (int i = 0; i < spaltenReihenFolge.length; i++) {
                        if (spaltenReihenFolge[i] == -1) {
                            for (int j = 0; j < spaltenReihenFolge.length; j++) {
                                if (!listVerwendeteIndexe.contains(j)) {
                                    spaltenReihenFolge[i] = j;
                                    listVerwendeteIndexe.add(j);

                                    break;
                                }
                            }
                        }
                    }

                    // ausblenden der Spalten die nicht ausgewhlt wurden.
                    table.setColumnOrder(spaltenReihenFolge);

                    for (int i = 0; i < table.getColumnCount(); i++) {
                        TableColumn tableColumn = table.getColumn(i);

                        if (!(spaltenAuswahl.contains(tableColumn.getText()))) {
                            tableColumn.setWidth(0);
                        }
                    }
                } else {
                    if (table.getColumnCount() > 0) {
                        TableColumn tableColumnArt = table.getColumn(0);

                        tableColumnArt.setWidth(50);
                        urspruenglich[0] = 0;

                        for (int i = 1; i < table.getColumnCount(); i++) {
                            TableColumn tableColumn = table.getColumn(i);

                            tableColumn.setWidth(100);
                            urspruenglich[i] = i;
                        }

                        table.setColumnOrder(urspruenglich);
                    }
                }
            }
        }
    }

    /**
     * Die aktuelle Darstellungsoption wird unter dem vom Benutzer eingegebenen
     * Namen gespeichert.
     *
     * @param darstellung
     *            der Name unter dem die aktuelle Darstellung gespeichert wird.
     */
    private void speicherAktuelleDarstellungsOption(String darstellung) {
        ArchivanfrageDaten              archivDaten = _instanzArchivVew.ermittleObjektAusGUI();
        Datenidentifikation             datId       = _guiTabellenVerwaltungEintragVergleichsObj.getDatenidentifikation();
        TabellenVerwaltungEintrag       te          = new TabellenVerwaltungEintrag                                                                   //
            (false, datId, _guiTabellenVerwaltungEintragVergleichsObj.getFilterAuswahlName(),                                                         //
             _guiTabellenVerwaltungEintragVergleichsObj.getSortierAuswahlName(), _guiTabellenVerwaltungEintragVergleichsObj.getSpaltenAuswahlName(),  //
             _guiTabellenVerwaltungEintragVergleichsObj.getVarAtt(), _guiTabellenVerwaltungEintragVergleichsObj.getVarTbl(),                          //
             _guiTabellenVerwaltungEintragVergleichsObj.getGewaehlteKnotenBaum(), _gui.getCheckArchiv().getSelection(), archivDaten, false);
        List<TabellenVerwaltungEintrag> listeTe     = new ArrayList<TabellenVerwaltungEintrag>();

        listeTe.add(te);

        TabellenVerwaltung tabellenVewElement = new TabellenVerwaltung(darstellung, listeTe);

        _alleTabellenVerwaltungen.addTabellenVerwaltung(tabellenVewElement);
        _alleTabellenVerwaltungen.speichereAlleTabellenVerwaltungen();
    }

    /**
     * Starte die Archivanfrage, bearbeite die maximal angegebene Anzahl der Archivdaten
     * und, falls der Parameter istTabelleNeuLaden auf true gesetzt wird, stelle die Daten
     * in der Tabelle dar.
     *
     * @param maxAnzDaten Maximale Anzahl der Archiv-Daten, die aus dem Archiv abgeholt werden.
     * @param istTabelleNeuLaden Stellt fest, ob die Tabelle neu geladen werden soll
     * (d.h. ob die Archivdaten in der Tabelle dargestellt werden sollen).
     *
     * @return true, falls die Archivdaten erfolgreich bearetet wurden,
     * false - sonst.
     */
    public boolean starteArchivanfrage(int maxAnzDaten, boolean istTabelleNeuLaden) {

        // Falls Aspekt oder Atg nicht definiert sind:
        if ((_gui.getComboAsp().getText().isEmpty() || (_gui.getComboAtg().getText().isEmpty()))) {
            _instanzArchivVew.setzeEnabledWertFuerAlleBtnArchivanfrage(false);
        }

        // Starte die Archivanfrage:
        else {
            AttributeGroup        atg               = _davKonf.getAttributeGroup(_gui.getComboAtg().getText());
            Aspect                aspekt            = _davKonf.getAspect(_gui.getComboAsp().getText());
            final DataDescription datenbeschreibung = new DataDescription(atg, aspekt);

            // Archivoptionen:
            final ArchivanfrageDaten archiv = _instanzArchivVew.ermittleObjektAusGUI();

            // Prfe den Archivzeitberech:
            if (!archiv.istZeitbereichKorrekt()) {
                MessageDialog.openError(_gui.getShell(), "Fehler", String.format(  //
                    "Zeitbereich des Archivs ist nicht korrekt %n(Anfang des Bereichs muss kleiner als Ende sein)!%n%nBitte korrigieren Sie zuerst die Zeitangaben."));

                return false;
            }

            // Lsche den Tabelleninhalt:
            if (getAnzahlZeilen(_tabellenDatenStruktur) > 0) {
                loescheTabellenZeilen(ALLE);
            }

            //
            long[] interval = archiv.ermittleZeitbereich();
            long   von      = interval[0];
            long   bis      = interval[1];

            if (archiv.bisZeitbereichAusschliessen()) {
                bis = bis - 1;
            }

            // Flle die Map mit Schlssel Systemobjekt, Wert der zugehrigen Datenbeschreibung
            // (diese Map wird zur Anemldung der Daten beim Datenverteiler verwendet):
            _angemeldeteSystemObjekteMapMitDatenbeschreibung.clear();

            for (Object obj : _arListGewaehltenObjImBaum) {
                SystemObject so = _davKonf.getObject(obj.toString());

                _angemeldeteSystemObjekteMapMitDatenbeschreibung.put(so, datenbeschreibung);
            }

            // Archivspezifikation:
            ArchiveTimeSpecification       archiveTimeSpecification  = new ArchiveTimeSpecification(archiv.ermittleDavZeitbereich(),  //
                                                                                                    archiv.isIstDatenanzahlBegrenzt(), von, bis);
            ArchiveRequestManager          archiveRequestManager     = _dav.getArchive();
            List<ArchiveDataSpecification> archiveDataSpecifications = new LinkedList<ArchiveDataSpecification>();

            for (SystemObject systemObject : _angemeldeteSystemObjekteMapMitDatenbeschreibung.keySet()) {
                archiveDataSpecifications.add(new ArchiveDataSpecification(                                                           //
                    archiveTimeSpecification, archiv.ermittleDavDatenArt(), archiv.ermittleDavSortierung(),                           //
                    archiv.ermittleDavArtAnfrage(), datenbeschreibung, systemObject));
            }

            if (archiveRequestManager.isArchiveAvailable()) {

                // Archivanfrage:
                ArchiveDataQueryResult queryResult = archiveRequestManager.request(archiv.ermittleDavPrioritaet(), archiveDataSpecifications);

                try {
                    if (queryResult.isRequestSuccessful()) {
                        _archiveDataStream              = new ArchiveDataStream[queryResult.getStreams().length];
                        _archiveDataStream              = queryResult.getStreams();
                        _zaehlerArchivDatenAbfrageIndex = 0;
                        _endeArchivDatenErreicht        = false;

                        // Bearbeite die Archivdaten:
                        return bearbeiteArchiveDaten(maxAnzDaten, istTabelleNeuLaden);
                    } else {
                        MessageDialog.openError(Display.getDefault().getActiveShell(), "Fehler",  //
                                                String.format("Es sind Probleme bei der Archivanfrage aufgetreten %nBitte starten Sie die Anfrage erneut."));
                    }
                }
                catch (Exception e) {
                    Log.zeigeInterneMultiMeldung(Activator.PLUGIN_ID, "Probleme bei der Archivanfrage.", e);
                }
            } else {
                MessageDialog.openError(Display.getDefault().getActiveShell(), "Fehler", "Das Archiv ist zur Zeit nicht verfgbar!");
            }
        }

        return false;
    }

    /**
     * Die Tabelle wird neu aufgebaut, basierend auf der bergebenen
     * Tabellendatenstruktur.
     */
    private void tabelleNeuLaden() {
        final Display display = Display.getDefault();

        if (_gui.getTableViewer() != null) {
            try {
                display.syncExec(new Runnable() {
                    @Override
                    public void run() {
                        _tabellenInhaltAktuell = _tabellenStruktur;
                        setzeTabellenInput();
                    }
                });
            }
            catch (Exception e) {
                Shell shell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();

                MessageDialog.openError(shell, "Fehler", "Es sind Probleme bei der Aktualisierung der Tabelle aufgetreten!.");
            }
        }
    }

    /**
     * Die Methode verarteiteDavDaten sorgt dafr, dass die bergebenen
     * Datenverteilerdaten je nach Zustand in Zeilenobjekte transformiert
     * werden.
     *
     * @param results
     *            die Datenverteiler bertragenen Daten.
     */
    public void verarbeiteDavDaten(ResultData[] results) {
        Date date         = new Date();
        long datum        = date.getTime();
        int  datenZaehler = _resultDataCount - 1;

        if (results == null) {
            _statusInfoErzeugt = false;

            if (!_gui.isStart()) {
                konvertiereDavDatenMitStatusInformation("Unterbrechung durch den Benutzer", "ALLE", datum, true, _gui.getCheckArchiv().getSelection());
                addObjekteRingBufferMitStatusInformation("Unterbrechung durch den Benutzer", null, null, _resultDataCount, "ALLE", datum);
                _unterbrechungDurchBenutzer = true;
            } else {
                konvertiereDavDatenMitStatusInformation("Start durch den Benutzer", "ALLE", datum, true, _gui.getCheckArchiv().getSelection());
                addObjekteRingBufferMitStatusInformation("Start durch den Benutzer", null, null, _resultDataCount, "ALLE", datum);
                _unterbrechungDurchBenutzer = false;
            }

            _statusInfoErzeugt = true;
        } else {
            if (_gui.isStart() && _statusInfoErzeugt) {
                _resultDataCount += results.length;

                for (ResultData result : results) {
                    if (!_unterbrechungDurchBenutzer) {
                        DataTableObjectErweitert dto             = new DataTableObjectErweitert(result);
                        DataState                resultDataState = dto.getDataState();

                        datenZaehler = datenZaehler + 1;

                        /* System-Objekt der erthaltenen Daten */
                        SystemObject object = result.getObject();

                        /* Aspekt dieser Datenbeschreibung <code>description</code> */
                        Aspect aspect = result.getDataDescription().getAspect();

                        /*
                         * Attributgruppe dieser Datenbeschreibung
                         * <code>description</code>
                         */
                        AttributeGroup attributGruppe = result.getDataDescription().getAttributeGroup();

                        if (result.hasData()) {
                            Data data = result.getData();

                            konvertiereDavDatenZuZeilenObjekt(dto.getDataKind(), data, object.getPidOrNameOrId(), result.getDataTime(), 0, true, _gui.getCheckArchiv().getSelection(), _gui.getSpinnerAnzahlVarAtt().getSelection());
                            addObjekteRingBuffer(dto.getDataKind(), data, attributGruppe, aspect, datenZaehler, object.getPidOrNameOrId(), result.getDataTime(), 0);
                        } else {
                            String statusText = DavDatenVew.getInstanz().bestimmeStatusText(resultDataState);

                            konvertiereDavDatenMitStatusInformation(statusText, object.getPidOrNameOrId(), result.getDataTime(), true, _gui.getCheckArchiv().getSelection());
                            addObjekteRingBufferMitStatusInformation(statusText, attributGruppe, aspect, datenZaehler, object.getPidOrNameOrId(), result.getDataTime());
                        }
                    }
                }
            }
        }
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 24.06.14
