/*
 * @(#)GtmLabelProvider.java   13.03.12
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.navigation.gui.lib;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.gtm.datvew.lib.DaVKonfigurationsbereichsObjekt;
import de.inovat.buv.gtm.datvew.lib.DaVObjektTyp;
import de.inovat.buv.gtm.datvew.lib.DaVSystemObjekt;
import de.inovat.buv.gtm.datvew.lib.ISystemObjekt;

import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;

//~ KLASSEN ===================================================================

/**
 * LabelProvider definiert Beschriftungen und Icons im Baum mit Elementen von Typ ISystemObjekt.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public class LabelProviderGTM extends LabelProvider {
    @Override
    public Image getImage(Object element) {
        Image image = null;

        if (element instanceof ISystemObjekt) {
            ISystemObjekt so = (ISystemObjekt) element;

            image = so.getImage();
        }

        return image;
    }

    @Override
    public String getText(Object element) {
        String text = element.toString();

        if ((element instanceof DaVKonfigurationsbereichsObjekt) || (element instanceof DaVObjektTyp) || (element instanceof DaVSystemObjekt)) {
            ISystemObjekt so = (ISystemObjekt) element;

            text = String.format("%s (%s)", so.getSystemObjekt().getPidOrId(), so.getSystemObjekt().getName());
        } else if (element instanceof ISystemObjekt) {
            ISystemObjekt so = (ISystemObjekt) element;

            text = String.format("%s (%s)", so.getSystemObjekt().getName(), so.getSystemObjekt().getPidOrId());
        }

        return text;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 21.03.12
