/*
 * @(#)ToolTipHtml.java   29.07.10
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.visualisierung.karte;

//~ NICHT JDK IMPORTE =========================================================

import org.eclipse.jface.window.ToolTip;
import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;

//~ KLASSEN ===================================================================

/**
 * Klasse erstellt einen ToolTip in dem HTML-Format.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 88 $ / $Date: 2012-03-09 16:20:38 +0100 (Fr, 09 Mrz 2012) $ / ($Author: LG $)
 */
public class ToolTipHtml extends ToolTip {
    private String  _text = "";
    private Browser _browser;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Erzeugt eine Instanz der Klasse ToolTipHtml.
     *
     * @param control GUI-Element, f[r das der ToolTip erstellt wird.
     */
    public ToolTipHtml(Control control) {
        super(control);
    }

    //~ METHODEN ==============================================================

    @Override
    protected Composite createToolTipContentArea(Event event, Composite parent) {
        return initGUI(parent);
    }

    /**
     * Initialisiere das GUI.
     *
     * @param parent Parent-composite.
     *
     * @return Composite.
     *
     * @wbp.parser.entryPoint
     */
    private Composite initGUI(Composite parent) {
        GridLayout gridLayout = new GridLayout(1, false);

        gridLayout.marginWidth  = 0;
        gridLayout.marginHeight = 0;
        parent.setLayout(gridLayout);

        Composite comp = new Composite(parent, SWT.NONE);

        comp.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

        GridLayout gl_comp = new GridLayout(1, false);

        gl_comp.marginWidth  = 0;
        gl_comp.marginHeight = 0;
        comp.setLayout(gl_comp);

        //
        _browser = new Browser(comp, SWT.NONE);
        _browser.setJavascriptEnabled(false);
        _browser.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
        _browser.setText(_text);

        // TODO Browser-size:
        _browser.setSize(600, 400);

        return comp;
    }

    /**
     * Setze den Text fr den ToolTip (Browser).
     *
     * @param text Neuer Text (kann HTML-Formatierung enthalten).
     */
    public void setzeText(String text) {
        _text = text;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 15.09.10
