/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;

/**
 * Klasse verwaltet dtd-Element aspekt.
 * 
 * <!ELEMENT aspekt (info?)>
 * <!ATTLIST aspekt
 * 		pid NMTOKEN #REQUIRED
 * 		konfigurationsModus ( datensatzNotwendig | datensatzNotwendigUndnderbar | datensatzOptional | datensatzOptionalUndnderbar ) #IMPLIED
 * 		onlineModus (quelle | senke | quelleUndSenke ) #IMPLIED
 * >
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class AspektBeschreibung {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Private ----------------------------------------------------------------
	/** bersicht der AspektBeschreibung. */
	private Uebersicht _uebersicht;

	/**
	 * konfigurationsModus
	 * ( datensatzNotwendig | datensatzNotwendigUndnderbar | datensatzOptional | datensatzOptionalUndnderbar )
	 */
	private String _konfigurationsModus;

	/**
	 * onlineModus
	 * (quelle | senke | quelleUndSenke )
	 */
	private String _onlineModus;

	/** Die Definition vom Aspekt (kann null sein). */
	private AspektDefinitionBeschreibung _aspektDefB;

// ------------------------------------------------------------------------
// KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
// ------------------------------------------------------------------------

	/**
	 * Erzeugt eine Instanz der Klasse AspektBeschreibung.
	 *
	 * @param uebersicht
	 * @param konfigurationsModus
	 * @param onlineModus
	 * @param aspektDefB
	 */
	public AspektBeschreibung(Uebersicht uebersicht,
			String konfigurationsModus, String onlineModus,
			AspektDefinitionBeschreibung aspektDefB) {
		_uebersicht = uebersicht;
		_konfigurationsModus = konfigurationsModus;
		_onlineModus = onlineModus;
		_aspektDefB = aspektDefB;
	}

// ------------------------------------------------------------------------
// GETTER / SETTER METHODEN
// ------------------------------------------------------------------------

	/**
	 * Getter fr Eigenschaft 'aspektDefB'.
	 *
	 * @return Wert der Eigenschaft 'aspektDefB'.
	 *
	 * @see  {#link _aspektDefB}
	 */
	public AspektDefinitionBeschreibung getAspektDefB() {
		return _aspektDefB;
	}

	/**
	 * Getter fr Eigenschaft 'konfigurationsModus'.
	 *
	 * @return Wert der Eigenschaft 'konfigurationsModus'.
	 *
	 * @see  {#link _konfigurationsModus}
	 */
	public String getKonfigurationsModus() {
		return _konfigurationsModus;
	}

	/**
	 * Getter fr Eigenschaft 'onlineModus'.
	 *
	 * @return Wert der Eigenschaft 'onlineModus'.
	 *
	 * @see  {#link _onlineModus}
	 */
	public String getOnlineModus() {
		return _onlineModus;
	}

	/**
	 * Getter fr Eigenschaft 'uebersicht'.
	 *
	 * @return Wert der Eigenschaft 'uebersicht'.
	 *
	 * @see  {#link _uebersicht}
	 */
	public Uebersicht getUebersicht() {
		return _uebersicht;
	}
}
