/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;

import java.util.ArrayList;
import java.util.List;

/**
 * Klasse verwaltet dtd-Element attributlistenDefinition.
 * 
 * <!ELEMENT attributlistenDefinition ( info, (attribut|attributliste|attributauswahl)+ ) >
 * <!ATTLIST attributlistenDefinition
 * 		pid ID #REQUIRED
 * 		name CDATA #IMPLIED
 * >
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class AttributlistenDefinitionBeschreibung {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Private ----------------------------------------------------------------
	/** bersicht der AttributlistenDefinitionBeschreibung. */
	private Uebersicht _uebersicht;

	/** Liste der AttributBeschreibungen. */
	private List<AttributBeschreibung> _listeAttributBeschreibung=new ArrayList<AttributBeschreibung>();

	/** Liste der AttributlistenBeschreibungen. */
	private List<AttributlistenBeschreibung> _listeAttributListenBeschreibung=new ArrayList<AttributlistenBeschreibung>();

	/** Liste der AttributauswahlBeschreibungen. */
	private List<AttributauswahlBeschreibung> _listeAttributAuswahlBeschreibung=new ArrayList<AttributauswahlBeschreibung>();

// ------------------------------------------------------------------------
// KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
// ------------------------------------------------------------------------

	/**
	 * Erzeugt eine Instanz der Klasse AttributlistenDefinitionBeschreibung.
	 *
	 * @param uebersicht
	 */
	public AttributlistenDefinitionBeschreibung(Uebersicht uebersicht) {
		_uebersicht = uebersicht;
	}

// ------------------------------------------------------------------------
// GETTER / SETTER METHODEN
// ------------------------------------------------------------------------

	/**
	 * Getter fr Eigenschaft 'listeAttributAuswahlBeschreibung'.
	 *
	 * @return Wert der Eigenschaft 'listeAttributAuswahlBeschreibung'.
	 *
	 * @see  {#link _listeAttributAuswahlBeschreibung}
	 */
	public List<AttributauswahlBeschreibung> getListeAttributAuswahlBeschreibung() {
		return _listeAttributAuswahlBeschreibung;
	}

	/**
	 * @param listeAttributAuswahlBeschreibung listeAttributAuswahlBeschreibung
	 */
	public void setListeAttributAuswahlBeschreibung(
			List<AttributauswahlBeschreibung> listeAttributAuswahlBeschreibung) {
		if(listeAttributAuswahlBeschreibung!=null){
			_listeAttributAuswahlBeschreibung = listeAttributAuswahlBeschreibung;
		}
		else{
			_listeAttributAuswahlBeschreibung=new ArrayList<AttributauswahlBeschreibung>();
		}
	}

	/**
	 * Getter fr Eigenschaft 'listeAttributBeschreibung'.
	 *
	 * @return Wert der Eigenschaft 'listeAttributBeschreibung'.
	 *
	 * @see  {#link _listeAttributBeschreibung}
	 */
	public List<AttributBeschreibung> getListeAttributBeschreibung() {
		return _listeAttributBeschreibung;
	}

	/**
	 * @param listeAttributBeschreibung listeAttributBeschreibung
	 */
	public void setListeAttributBeschreibung(
			List<AttributBeschreibung> listeAttributBeschreibung) {
		if(listeAttributBeschreibung!=null){
			_listeAttributBeschreibung = listeAttributBeschreibung;
		}
		else{
			_listeAttributBeschreibung=new ArrayList<AttributBeschreibung>();
		}
	}

	/**
	 * Getter fr Eigenschaft 'listeAttributListenBeschreibung'.
	 *
	 * @return Wert der Eigenschaft 'listeAttributListenBeschreibung'.
	 *
	 * @see  {#link _listeAttributListenBeschreibung}
	 */
	public List<AttributlistenBeschreibung> getListeAttributListenBeschreibung() {
		return _listeAttributListenBeschreibung;
	}

	/**
	 * @param listeAttributListenBeschreibung listeAttributListenBeschreibung
	 */
	public void setListeAttributListenBeschreibung(
			List<AttributlistenBeschreibung> listeAttributListenBeschreibung) {
		if(listeAttributListenBeschreibung!=null){
			_listeAttributListenBeschreibung = listeAttributListenBeschreibung;
		}
		else{
			_listeAttributListenBeschreibung=new ArrayList<AttributlistenBeschreibung>();
		}
	}

	/**
	 * Getter fr Eigenschaft 'uebersicht'.
	 *
	 * @return Wert der Eigenschaft 'uebersicht'.
	 *
	 * @see  {#link _uebersicht}
	 */
	public Uebersicht getUebersicht() {
		return _uebersicht;
	}
}
