/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;

/**
 * Klasse verwaltet dtd-Element konfigurationsAenderung.
 * 
 * <!ELEMENT konfigurationsAenderung  (#PCDATA | %zeichenauszeichnung.klasse; |
 *                                          %absatzauszeichnung.klasse;)* >
 * <!ATTLIST konfigurationsAenderung
 *			stand CDATA #REQUIRED
 *			version CDATA #IMPLIED
 *			autor CDATA #REQUIRED
 *			grund CDATA #IMPLIED
 * >
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class KonfigurationsAenderungBeschreibung {
	
	/** Inhalt der Konfigurationsnderung. */
	private Inhalt _inhalt;
	
	/** Stand (Datum) der Konfigurationsnderung. */
	private String _stand;
	
	/** Version der Konfigurationsnderung. */
	private String _version;
	
	/** Autor der Konfigurationsnderung. */
	private String _autor;
	
	/** Grund der Konfigurationsnderung. */
	private String _grund;
	
	/**
	 * Erzeugt eine Instanz der Klasse KonfigurationsAenderungBeschreibung.
	 * 
	 * @param inhalt
	 * @param stand
	 * @param version
	 * @param autor
	 * @param grund
	 */
	public KonfigurationsAenderungBeschreibung(Inhalt inhalt, String stand,
			String version, String autor, String grund) {
		_inhalt = inhalt;
		_stand = stand;
		_version = version;
		_autor = autor;
		_grund = grund;
	}

	/**
	 * Getter fr Eigenschaft 'inhalt'.
	 * 
	 * @return Wert der Eigenschaft 'inhalt'.
	 * 
	 * @see  {#link _inhalt}
	 */
	public Inhalt getInhalt() {
		return _inhalt;
	}

	/**
	 * Getter fr Eigenschaft 'stand'.
	 * 
	 * @return Wert der Eigenschaft 'stand'.
	 * 
	 * @see  {#link _stand}
	 */
	public String getStand() {
		return _stand;
	}

	/**
	 * Getter fr Eigenschaft 'version'.
	 * 
	 * @return Wert der Eigenschaft 'version'.
	 * 
	 * @see  {#link _version}
	 */
	public String getVersion() {
		return _version;
	}

	/**
	 * Getter fr Eigenschaft 'autor'.
	 * 
	 * @return Wert der Eigenschaft 'autor'.
	 * 
	 * @see  {#link _autor}
	 */
	public String getAutor() {
		return _autor;
	}

	/**
	 * Getter fr Eigenschaft 'grund'.
	 * 
	 * @return Wert der Eigenschaft 'grund'.
	 * 
	 * @see  {#link _grund}
	 */
	public String getGrund() {
		return _grund;
	}

}
