/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;

import java.util.ArrayList;
import java.util.List;

/**
 * Klasse verwaltet dtd-Element konfigurationsBereich.
 * 
 * <!ELEMENT konfigurationsBereich (info?, konfigurationsAenderung*, modell?, objekte?) >
 * <!ATTLIST konfigurationsBereich pid ID #REQUIRED >
 * <!ATTLIST konfigurationsBereich name CDATA #IMPLIED >
 * <!ATTLIST konfigurationsBereich verantwortlich NMTOKEN #REQUIRED>
 * <!ATTLIST konfigurationsBereich xml:base CDATA #IMPLIED >
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class KonfigurationsBereichBeschreibung {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Private ----------------------------------------------------------------
	/** bersicht der KonfigurationsBereichBeschreibung. */
	private Uebersicht _uebersicht;

	/** Verantwortlicher fr den KonfigurationsBereich. */
	private String _verantwortlich;

	/** Wird nicht benutzt. */
	private String _xmlBase;

	/** Liste der KonfigurationsAenderungBeschreibungen. */
	private List<KonfigurationsAenderungBeschreibung> _listeKA=new ArrayList<KonfigurationsAenderungBeschreibung>();

	/** Das Modell der KonfigurationsBereichBeschreibung. */
	private ModellBeschreibung _model;

	/** Die Objekte der KonfigurationsBereichBeschreibung. */
	private ObjekteBeschreibung _objekte;

// ------------------------------------------------------------------------
// KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
// ------------------------------------------------------------------------

	/**
	 * Erzeugt eine Instanz der Klasse KonfigurationsBereichBeschreibung.
	 *
	 * @param uebersicht
	 * @param verantwortlich
	 * @param xmlBase
	 * @param listeKA
	 * @param model
	 * @param objekte
	 */
	public KonfigurationsBereichBeschreibung(Uebersicht uebersicht,
			String verantwortlich, String xmlBase,
			List<KonfigurationsAenderungBeschreibung> listeKA, ModellBeschreibung model,
			ObjekteBeschreibung objekte) {
		_uebersicht = uebersicht;
		_verantwortlich = verantwortlich;
		_xmlBase = xmlBase;
		if(listeKA!=null){
			_listeKA = listeKA;
		}
		_model = model;
		_objekte = objekte;
	}

// ------------------------------------------------------------------------
// GETTER / SETTER METHODEN
// ------------------------------------------------------------------------

	/**
	 * Getter fr Eigenschaft 'listeKA'.
	 *
	 * @return Wert der Eigenschaft 'listeKA'.
	 *
	 * @see  {#link _listeKA}
	 */
	public List<KonfigurationsAenderungBeschreibung> getListeKA() {
		return _listeKA;
	}

	/**
	 * Getter fr Eigenschaft 'model'.
	 *
	 * @return Wert der Eigenschaft 'model'.
	 *
	 * @see  {#link _model}
	 */
	public ModellBeschreibung getModel() {
		return _model;
	}

	/**
	 * Getter fr Eigenschaft 'objekte'.
	 *
	 * @return Wert der Eigenschaft 'objekte'.
	 *
	 * @see  {#link _objekte}
	 */
	public ObjekteBeschreibung getObjekte() {
		return _objekte;
	}

	/**
	 * Getter fr Eigenschaft 'uebersicht'.
	 *
	 * @return Wert der Eigenschaft 'uebersicht'.
	 *
	 * @see  {#link _uebersicht}
	 */
	public Uebersicht getUebersicht() {
		return _uebersicht;
	}

	/**
	 * Getter fr Eigenschaft 'verantwortlich'.
	 *
	 * @return Wert der Eigenschaft 'verantwortlich'.
	 *
	 * @see  {#link _verantwortlich}
	 */
	public String getVerantwortlich() {
		return _verantwortlich;
	}

	/**
	 * Getter fr Eigenschaft 'xmlBase'.
	 *
	 * @return Wert der Eigenschaft 'xmlBase'.
	 *
	 * @see  {#link _xmlBase}
	 */
	public String getXmlBase() {
		return _xmlBase;
	}
}
