/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package de.inovat.buv.inovat.lib.io;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.inovat.lib.io.CsvLeser;
import de.inovat.buv.inovat.lib.io.CsvSchreiber;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import static org.junit.Assert.*;

//~ JDK IMPORTE ===============================================================

import java.io.FileReader;
import java.io.FileWriter;

import java.util.List;

//~ KLASSEN ===================================================================

/**
 * Testklasse zum Testen von CsvSchreiber
 *
 * @author inovat
 * @author Dipl.-Inform. Joachim Collasius (JC)
 * @version $Revision: 12 $ / $Date: 2013-09-24 13:23:48 +0200 (Di, 24. Sep 2013) $ / ($Author: LG $)
 */
public class CsvSchreiberTest {
    private static CsvLeser     csvLeser;
    private static CsvSchreiber csvSchreiber;
    private static FileReader   leser;
    private static FileWriter   schreiber;

    //~ METHODEN ==============================================================

    @Test

    // @Ignore
    public final void schreibeKopfZeile() {
        List<String> ersteZeile = csvLeser.getErsteZeile();

        csvSchreiber.setzeKopfZeile(ersteZeile);
        csvSchreiber.schreibeKopfZeile();
    }

    //~ SET METHODEN ==========================================================

    /**
     * @throws java.lang.Exception
     */
    @Before
    public void setUp() throws Exception {}

    /**
     * @throws java.lang.Exception
     */
    @BeforeClass
    public static void setUpBeforeClass() throws Exception {

        // leser = new FileReader("BSTNW99.csv");
        leser     = new FileReader("C:\\Dokumente und Einstellungen\\JC\\Eigene Dateien\\Dokumente\\Import.csv");
        schreiber = new FileWriter("C:\\Dokumente und Einstellungen\\JC\\Eigene Dateien\\Dokumente\\ExportTest.csv");

        char begrenzer = ';';

        csvLeser     = new CsvLeser(leser, begrenzer);
        csvSchreiber = new CsvSchreiber(schreiber, begrenzer);
    }

    //~ METHODEN ==============================================================

    /**
     * @throws java.lang.Exception
     */
    @After
    public void tearDown() throws Exception {}

    /**
     * @throws java.lang.Exception
     */
    @AfterClass
    public static void tearDownAfterClass() throws Exception {
        csvLeser.close();
        csvSchreiber.close();
    }

    @Test
    public final void testSchreibeZeile() {
        boolean bool;

        while (bool = csvLeser.hasNochMehrZeilen()) {
            assertTrue("csvLeser.hasNochMehrZeilen? Ja", bool == true);
            csvSchreiber.schreibeZeile(csvLeser.getNaechsteZeile());
        }

        assertTrue("csvLeser.hasNochMehrZeilen? Nein", bool == false);
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 29.05.09
